/*******************************************************************************
 *
 *	layout.h
 *
 *	part of the layout program.
 *
 *
 *	Written by Gerard Leurs, NIKHEF-H, Amsterdam.
 *	December 1991.
 *	email: a89@nikhef.nl
 *
 ******************************************************************************/

	/* define all used libraries */

# include <stdio.h>
# include <ctype.h>
# include <time.h>
# include <math.h>


	/* define all general variables */

# define MaxEnt	   96			/* maximum length of hostnames */
# define MaxLine 1024			/* maximum length of one line in the input */
# define FALSE	    0
# define TRUE	    1
# define NONSENSE  10			/* "values" for unknown-nodes */


extern int Debug;			/* print statistics/jobs */
extern int number_of_nodes;		/* keep track of total hosts - networks */
extern int WINDOWwidth;			/* x-size of the window (default) */
extern int WINDOWheight;		/* y-size of the window (default) */
extern int DEFAULTwidth;		/* width for nodes with originally zero width */
extern int DEFAULTheight;		/* height for nodes with originally zero height */
extern int boundary;			/* surrounding area in window */


	/* define the hoststructure */

struct hostentity			/* node structure declaration */
{
	char id[MaxEnt];
	char hostname[MaxEnt];
	long int x_coord;
	long int y_coord;
	long int width;
	long int height;
	int link;
	int number;
	struct hostentity *next;
} ;

	/* and all its members */

extern struct hostentity *host;			/* name of the node structure */
extern struct hostentity *host_zero_links;	/* structurename with nodes without links */
extern struct hostentity *host_one_link;	/* structurename with nodes with only one links */
extern struct hostentity *host_more_to_one;	/* structurename with nodes with more links, but only to nodes with one link */
extern struct hostentity *host_1;
extern struct hostentity *host_2;
extern struct hostentity *host_more;

extern struct hostentity * addnodestructure();


	/* define the linkstructure */

struct linkentity			/* link structure declaration */
{
	char linktype[MaxEnt];
	char id_one[MaxEnt];
	char id_two[MaxEnt];
	int nr_one;
	int nr_two;
	struct linkentity *next;
} ;

	/* and all its members */

extern struct linkentity *link;			/* name of the link structure */

extern struct linkentity * addlinkstructure();


	/* define the heightstucture */

struct nodeheightentity			/* more_link_node with totalheight structure */
{
	char hostname[MaxEnt];
	int number;
	long int totalheight;
	struct nodeheightentity * next;
};

	/* and all its members */

extern struct nodeheightentity *nodeheight;

extern struct nodeheightentity * addheightstructure();


	/* define all procedures which return "non-void" */

extern int get_characteristics();
extern int linked_or_not();
extern int check_nodes_overlap();
extern int check_free();
extern long int get_height();
