# include "layout.h"


static void get_lowest_node_nr(hoststr, lowest_nr, is_x)
struct hostentity *hoststr;
int *lowest_nr;
int is_x;
{
	struct hostentity *dummy;
	int low;


	if (is_x)
		low = 5 * WINDOWwidth;
	else
		low = 5 * WINDOWheight;

	dummy = hoststr;
	while (dummy != NULL)
	{
		if (is_x)
		{
			if (dummy->x_coord < low)
			{
				low = dummy->x_coord;
				*lowest_nr = dummy->number;
			}
		}
		else
		{
			if (dummy->y_coord < low)
			{
				low = dummy->y_coord;
				*lowest_nr = dummy->number;
			}
		}
	}
}


static void make_sorted_list(hoststr, newhoststr, is_x)
struct hostentity *hoststr;
struct hostentity *newhoststr;
{
	struct hostentity *dummy1;
	struct hostentity *dummy2;
	struct hostentity *not_yet_str;
	int lowest_nr;


	newhoststr = NULL;

	dummy1 = hoststr;
	while (dummy1 != NULL)
	{
		not_yet_str = NULL;
		dummy2 = hoststr;
		if (dummy2 != NULL)
			get_lowest_node_nr(dummy2, &lowest_nr, is_x);
	
		dummy2 = hoststr;
		while (dummy2 != NULL)
		{
			if (dummy2->number == lowest_nr)
			{
				newhoststr = addnodestructure( newhoststr, dummy2->id, dummy2->hostname,
								dummy2->x_coord, dummy2->y_coord,
								dummy2->width, dummy2->height,
								dummy2->link, dummy2->number, TRUE);
			}
			else
			{
				not_yet_str = addnodestructure( not_yet_str, dummy2->id, dummy2->hostname,
								dummy2->x_coord, dummy2->y_coord,
								dummy2->width, dummy2->height,
								dummy2->link, dummy2->number, TRUE);
			}
	
			dummy2 = dummy2->next;
		}
		hoststr = not_yet_str;

		dummy1 = dummy1->next;
	}
}


static void node_halfway(hoststr, node_str, is_x, size)
struct hostentity *hoststr;		/* nodestructure with all hosts */
struct hostentity *node_str;		/* new structure with nodes halfway the window */
int is_x;				/* do it for x_coordinates or y_coordinates */
int size;				/* dimension of the window */
{
	struct hostentity *dummy;
	struct hostentity *tmp_str;
	int tmp_height;


	node_str = NULL;	tmp_str = NULL;
	dummy = hoststr;
	while (dummy != NULL)
	{
		if (is_x)
		{
			if ( (dummy->x_coord < (size / 2) )
			&& ( (dummy->x_coord + dummy->width) > (size / 2) ) )
				tmp_str = addnodestructure( tmp_str, dummy->id, dummy->hostname,
							    dummy->x_coord, dummy->y_coord,
							    dummy->width, dummy->height,
							    dummy->link, dummy->number, TRUE);
		}
		else
		{
			tmp_height = get_height(dummy);
			if ( (dummy->y_coord < (size / 2) )
			&& ( (dummy->y_coord + tmp_height) > (size / 2) ) )
				tmp_str = addnodestructure( tmp_str, dummy->id, dummy->hostname,
							    dummy->x_coord, dummy->y_coord,
							    dummy->width, dummy->height,
							    dummy->link, dummy->number, TRUE);
		}

		dummy = dummy->next;
	}
	make_sorted_list(tmp_str, node_str, is_x);
}


/* WHAT FOLLOWS IS IN MOVE_NODE.C */

	/* adjust the coordinates of nodes below/above the limit with the free-space available */
	/* if full_or_half != 1 : compare x with windowpart, and after that fix y !!
				Or compare y and fix x_coordinates !! */

static void adjust_nodes(limit, free_space, is_x, full_or_half, size)
long int limit, free_space;
int is_x;
int full_or_half;	/* 1: all coordinates, 2: upper half, 3: lower half */
int size;		/* the size of the window */
{
	struct hostentity * dummyhost1;


	dummyhost1 = host;
	while (dummyhost1 != NULL)
	{

#ifdef DEBUG
		fprintf(stderr,"adjust_nodes: %s at %ld %ld",
			dummyhost1->hostname, dummyhost1->x_coord, dummyhost1->y_coord);
#endif

		if (is_x)
		{
			if (full_or_half == 1)
			{
				if ((dummyhost1->x_coord + dummyhost1->width) < limit)
					dummyhost1->x_coord += free_space;
			}

			else if (full_or_half == 2)
			{
				if ( ((dummyhost1->x_coord + dummyhost1->width) > (size / 2) )
				  && (dummyhost1->y_coord >= limit) )
					dummyhost1->y_coord -= free_space;
			}
			else /* if (full_or_half == 3) */
			{
				if ( ((dummyhost1->x_coord + dummyhost1->width) < (size / 2) )
				  && (dummyhost1->y_coord >= limit) )
					dummyhost1->y_coord -= free_space;
			}
		}
		else
		{
			if (full_or_half == 1)
			{
				if ((dummyhost1->y_coord + dummyhost1->height) < limit)
					dummyhost1->y_coord += free_space;
			}
			else if (full_or_half == 2)
			{
				if ( ((dummyhost1->y_coord + dummyhost1->height) > (size / 2) )
				  && (dummyhost1->x_coord >= limit) )
					dummyhost1->x_coord -= free_space;
			}
			else /* if (full_or_half == 3) */
			{
				if ( ((dummyhost1->y_coord + dummyhost1->height) < (size / 2) )
				 && (dummyhost1->x_coord >= limit) )
					dummyhost1->x_coord -= free_space;
			}
		}

#ifdef DEBUG
		fprintf(stderr," \t NEW: %s at %ld %ld\n", dummyhost1->hostname,
			dummyhost1->x_coord, dummyhost1->y_coord);
#endif

		dummyhost1 = dummyhost1->next;
	}
}


/* ALSO IN MOVE_NODE.C */

	/* get the maximum free space for the nodes */
	/* there tends to be a gap between a x/y-coordinate of a node and the rest of the nodes.
	   we can reduce the size of the WINDOW if we correct for this unused x/y-space */
	/* This is a RECURSIVE routine */

extern void reduce_gaps(nodestruct, distance, is_x, full_or_half, size)
struct hostentity * nodestruct;
long int distance;
int is_x;
int full_or_half;	/* 1: all coordinates, 2: upper half, 3: lower half */
int size;		/* the size of the window (before adjusting) */
{
	struct hostentity * dummyhost1;
	struct hostentity * dummyhost2;
	long int cor1,  cor2,  x_cor1,  x_cor2,  y_cor1,  y_cor2;
	long int size1, size2, x_size1, x_size2, y_size1, y_size2;
	long int free, max, where;


	move_towards_boundary(nodestruct);

	max = 0;
	dummyhost1 = host;
	while (dummyhost1 != NULL)
	{
		free = size;

		x_cor1 = dummyhost1->x_coord;	x_size1 = dummyhost1->width;
		y_cor1 = dummyhost1->y_coord;
		y_size1 = get_height(dummyhost1);

		if (is_x)
		{
			cor1 = x_cor1;		size1 = x_size1;
		}
		else
		{
			cor1 = y_cor1;		size1 = y_size1;
		}

		if ( (full_or_half == 1)
		|| ( (full_or_half == 2) && ((cor1 + size1) > (size / 2)) )
		|| ( (full_or_half == 3) && (cor1 < (size / 2)) ) )
		{
			dummyhost2 = host;
			while (dummyhost2 != NULL)
			{
				if (dummyhost1->number != dummyhost2->number)
				{
					x_cor2 = dummyhost2->x_coord;	x_size2 = dummyhost2->width;
					y_cor2 = dummyhost2->y_coord;
					y_size2 = get_height(dummyhost2);

					if (is_x)
					{
						cor2 = x_cor2;		size2 = x_size2;
					}
					else
					{
						cor2 = y_cor2;		size2 = y_size2;
					}

					if (full_or_half == 1)
						determine_space(cor1, size1, cor2, size2, &free);

					if ( ( (full_or_half == 2) && ((cor2 + size2) > (size / 2)) )
					  || ( (full_or_half == 3) && (cor2 < (size / 2)) ) )
					{
	if (is_x)
		determine_space(y_cor1, y_size1, y_cor2, y_size2, &free);
	else
		determine_space(x_cor1, x_size1, x_cor2, x_size2, &free);
					}
				}
				dummyhost2 = dummyhost2->next;
			}

			if (free == size)
				free = 0;

			if (free > max)
			{
				max = free;
				if (full_or_half == 1)
					where = cor1;
				else if ( (full_or_half != 1) && (is_x) )
					where = y_cor1;
				else
					where = x_cor1;
			}
		}

		dummyhost1 = dummyhost1->next;
	}

	if (max > distance)
	{
		max = max - distance;
		if (is_x)
		{
			if (full_or_half == 1)
			{
				fprintf(stderr,"reducing gap (%ld) in x direction with %ld\n", (distance + max), max);
				adjust_nodes(where, max, TRUE, full_or_half, size);
				reduce_gaps(nodestruct, distance, TRUE, full_or_half, size);
			}
			else
			{
   				if (full_or_half == 2)
					fprintf(stderr,"Y-Gap (%ld) fixing for upper x-part of window with %ld\n",
						(distance + max), max);
				else
					fprintf(stderr,"Y-Gap (%ld) fixing for lower x-part of window with %ld\n",
						(distance + max), max);
				adjust_nodes(where, max, TRUE, full_or_half, size);
			}
		}
		else
		{
			if (full_or_half == 1)
			{
				fprintf(stderr,"reducing gap (%ld) in y direction with %ld\n", (distance + max), max);
				adjust_nodes(where, max, FALSE, full_or_half, size);
				reduce_gaps(nodestruct, distance, FALSE, full_or_half, size);
			}
			else
			{
				if (full_or_half == 2)
					fprintf(stderr,"X-Gap (%ld) fixing for upper y-part of window with %ld\n",
						(distance + max), max);
				else
					fprintf(stderr,"X-Gap (%ld) fixing for lower y-part of window with %ld\n",
						(distance + max), max);
				adjust_nodes(where, max, FALSE, full_or_half, size);
			}
		}
	}

	move_towards_boundary(nodestruct);
}
