/*****************************************************************************/
/*****************************************************************************/
/* $Header: //gaia/group.local/computer/monet/Xmonet/RCS/main.c,v 1.1 1991/03/26 12:00:14 a38 Exp a38 $ */
/*****************************************************************************/
/*****************************************************************************/

#include <monet/map/Drawing.h>
#include <monet/msh/Script.h>
#include <monet/msh/Channel.h>
#include <monet/std/Std.h>
#include <monet/probe/Probe.h>
#include <signal.h>
#include <errno.h>
#include <sys/ioctl.h>

/***************************************************************************/
/*  Finish off */
/***************************************************************************/

static void finish ()
{
  MonetMap_finish ();
#ifdef PROBELIBOKAY
  MonetProbe_finish ();
#endif
  Monet_finish ();
  exit (0);
}

/***************************************************************************/
/*  Adjust 'select(2)' parameters */
/***************************************************************************/

extern void before (numbits,readbits, writebits, other, timer)
     int *numbits;
     fd_set *readbits, *writebits, *other;
     struct timeval *timer;
{
  /*  Modifies the timer if an event is pending in less time than the
      value of timer.tv_sec  */
  (void) MonetEvent_next (timer);
#ifdef PROBELIBOKAY
  MonetProbe_before_select(numbits,readbits, writebits, other, timer);
#endif
}

/***************************************************************************/
/*  Called after select to handle pending input  */
/***************************************************************************/

extern void after (count, readbits, writebits, other)
     int count;
     fd_set *readbits, *writebits, *other;
{
#ifdef PROBELIBOKAY
  MonetProbe_after_select (count, readbits, writebits, other);
#endif
}

/*****************************************************************************/
/*  The top */
/*****************************************************************************/

main(argc, argv)
     int             argc;
     char           **argv;
{
  /* Initialise the monet library */
  Monet_init ("monet", finish, "monetrc", MONET_DIR, argc, argv);
  MonetStd_init ();

#ifdef PROBELIBOKAY
  /* Network probing stuff, snmp, x25 etc */
  MonetProbe_init ();
#endif

  /* Initialise the map and database libraries */
  MonetMap_init (NULL, NULL, NULL, NULL, NULL);

  /* Load in the user configuration files */
  /* and if interactive set up a command line */
  /* interface.  */
  Monet_user_config (argc, argv);


  /* Wait for events to come in and call the
     appropriate handlers when needed.
     */
  MonetSelectForever (before, after);
  /* NOTREACHED */
}

/*****************************************************************************/
/*****************************************************************************/
/* $Header: //gaia/group.local/computer/monet/Xmonet/RCS/main.c,v 1.1 1991/03/26 12:00:14 a38 Exp a38 $ */
/*****************************************************************************/
/*****************************************************************************/

