/***************************************************************************/
/***************************************************************************/
/*  $Header: //gaia/group.local/computer/monet/Monetd/RCS/monetd.c,v 1.2 1991/03/22 16:09:27 a38 Exp a38 $  */
/***************************************************************************/
/***************************************************************************/

#include <monet/db/Db.h>
#include <monet/msh/Channel.h>
#include <monet/std/Std.h>
#include <monet/probe/Probe.h>
#include <sys/time.h>

/****************************************************************************/
/*  Fiish off  */
/****************************************************************************/

static void finish ()
{
  MonetEntity_save_db (NULL);
  MonetDb_finish ();
#ifdef PROBELIBOKAY
  MonetProbe_finish ();
#endif
  Monet_finish ();
  exit(0);
}

/***************************************************************************/
/*  Adjust 'select(2)' parameters */
/***************************************************************************/

extern void before (numbits,readbits, writebits, other, timer)
     int *numbits;
     fd_set *readbits, *writebits, *other;
     struct timeval *timer;
{
  /* Check that the x121/address translation file has not been changed */
  MonetX25Lookup_periodic_check_file ();

#ifdef PROBELIB
  MonetProbe_before_select(numbits,readbits, writebits, other, timer);
#endif
}

/***************************************************************************/
/*  Called after select to handle pending input  */
/***************************************************************************/

extern void after (count, readbits, writebits, other)
     int count;
     fd_set *readbits, *writebits, *other;
{
#ifdef PROBELIB
  MonetProbe_after_select (count, readbits, writebits, other);
#endif
}

/****************************************************************************/
/*   Main */
/****************************************************************************/

main (argc, argv)
     int             argc;
     char           **argv;
{
  /* -- Init basic monet stuff */
  Monet_init ("monetd", finish, "monetdrc", MONET_DIR, argc, argv);
  MonetStd_init ();
#ifdef PROBELIBOKAY
  /* -- Init the network query stuff */
  MonetProbe_init ();
#endif

  /* -- Init the entity database, as a server */
  MonetDb_init (True, NULL);

  /* -- Load in users configuration file */
  Monet_user_config (argc, argv);

  /* -- Loop forever handling events as they occur */
  MonetSelectForever (before, after);
  /* NOTREACHED */
}

/***************************************************************************/
/***************************************************************************/
/*  $Header: //gaia/group.local/computer/monet/Monetd/RCS/monetd.c,v 1.2 1991/03/22 16:09:27 a38 Exp a38 $  */
/***************************************************************************/
/***************************************************************************/
