.TH  monetlogd 1 "Release 0.10" Monet
.SH NAME
monetlogd-
.SH SYNOPSIS
monetlogd [  -reference -manual -email -debug -home -startup -dir -short -daemon -shell -exec -options -help -c]
.SH DESCRIPTION
The monetlogd program is a logging server that provides three basic
functions, alarms, logging and queries.
Alarms are timestamped one line informational messages.
Logging is done on a per device basis and uses the draft IETF logging
format.  Queries perform searches on the data.
.PP
Using a server is preferable to doing logging directly to files
because it centralises the functionality, reduces number of programs needing
special access rights and lets logging be done remotely.  In addition it
provides a convenient means of accessing information.
.PP
Each logged device has its own formatted log file.  Alarms are kept
in their own file.  No complicated and expensive database mechanism
underlies the system.  The log directory will also probably be
available by anonymous ftp.
.PP
The querying commands are simple interfaces to basic unix commands,
such as 'cat', 'egrep' and 'ls'.  These provide plenty of functionality,
they are available on non unix machines and they are optimised.
.PP
Security is provided by passwords and checks on the source address of
incoming connections.
.PP
.SH OPTIONS
.TP 8
.B   -reference \-
produces an latex formatted reference manual and exits
.TP 8
.B      -manual \-
produces an nroff formatted manual page and exits
.TP 8
.B       -email \-
Sets the users email address.
.TP 8
.B       -debug \-
Switches on debugging -debug [on|off|num]
.TP 8
.B        -home \-
The user home directory, if not ~
.TP 8
.B     -startup \-
The name of the startup file
.TP 8
.B         -dir \-
Where to look for run time specific files
.TP 8
.B       -short \-
'.' or ',' can be used in place of ->
.TP 8
.B      -daemon \-
Set daemon mode for this program, careful
.TP 8
.B       -shell \-
Prompt for input from the command line
.TP 8
.B        -exec \-
A command to execute on start up
.TP 8
.B     -options \-
brief list of command line options
.TP 8
.B        -help \-
lists command line options and exits
.TP 8
.B           -c \-
Execute rest of command line as command and exit
.SH FILES
$MONETDIR/*.msh ~/.monetlogdrc $MONETDIR/monetlogdrc.msh
.SH SEE ALSO
Monet: User Guide
.SH AUTHOR
.na
.nf
James Barr, NIKHEF-H, Amsterdam <a38@nikhef.nl>
