.TH MONETMAP 1N "" 
.UC 4
.SH NAME
.TP
.B monetmap
\-
Maps networks using the domain nameserver
.SH SYNOPSIS
.B monetmap
[-wcw] [-host] [-n <name>] [-dir <dir>] [-d <domain ...>] [-s <host output>]"
.SH OPTIONS
.B -v
Verbose mode.
.B -wcw
Produces example networking map of the Wetenschaaplijk Centrum Watergraafsmeer
(Watergraafsmeer Science Park).
.B -(no)host
Forces monetmap to generate a new host output file by calling
host(1).  -nohost is the default.
.B -(no)map
Forces monetmap to make maps from the host files. -map is the default.
.B -s <host output file>
This is an output file for the host(1) command.
.B -dir <directory>
Directory to place output files.
.B -d <domain ...>
The name of some domains to look in for interesting systems.
.SH DESCRIPTION
Produces maps of interesting networks for use by \fImonet(1N)\fR.
A set of domains must be supplied, these are then searched for
'interesting systems'.  A logical description is created in one
file giving the connectivity and attributes of the various systems.
In addition a set of map files are produced, each of these contains
a list of network entities to be placed on the map.  Initially, the
coordinates are null but the program \fIlayout(1)\fR can be used to
give initial positions and \fIxmonet(1N)\fR can be used to tidy up
the maps by hand.
.PP
Interesting machines are those with more than one network address,
crays, machines running nameservers.
.PP
The maps produced are extracted from the domain-nameserver, thus
the number of types of map is limited to ip related areas.

.SH FILES
~/.monetrc             user configuration file
.br
/etc/monet/monetrc     configuration file

.SH "SEE ALSO"
monet(1N), xmonet(1N), layout(1)
.SH BUGS
\- Treats class B networks as Class C since it does not use netmasks.
.br
\- Does not check for aliases.
.br
\- Not really finished, has worked quite well for some examples but has
failed badly for others. The idea of working from the nameserver is good,
it just need completion.
.br
\- Is awfully slow sometimes.
.br
\- Definition of interesting systems needs improvement.
.br
\- 
.SH AUTHOR
James Barr, NIKHEF-H, Amsterdam

