/*****************************************************************************/
/*****************************************************************************/
/* $Header: //gaia/group.local/computer/monet/Xmonet/RCS/main.c,v 1.1 1991/03/26 12:00:14 a38 Exp a38 $ */
/*****************************************************************************/
/*****************************************************************************/

#include <monet/msh/General.h>
#include <monet/msh/Script.h>
#include <monet/std/Std.h>
#include <monet/probe/Probe.h>

/***************************************************************************/
/*  Finish off */
/***************************************************************************/

static void finish ()
{
#ifdef PROBELIBOKAY
  MonetProbe_finish ();
#endif
  Monet_finish ();
  exit (0);
}

/***************************************************************************/
/*  Adjust 'select(2)' parameters */
/***************************************************************************/

extern void before (numbits,readbits, writebits, other, timer)
     int *numbits;
     fd_set *readbits, *writebits, *other;
     struct timeval *timer;
{
  /*  Modifies the timer if an event is pending in less time than the
      value of timer.tv_sec  */
  (void) MonetEvent_next (timer);
#ifdef PROBELIBOKAY
  MonetProbe_before_select(numbits,readbits, writebits, other, timer);
#endif
}

/***************************************************************************/
/*  Called after select to handle pending input  */
/***************************************************************************/

extern void after (count, readbits, writebits, other)
     int count;
     fd_set *readbits, *writebits, *other;
{
#ifdef PROBELIBOKAY
  MonetProbe_after_select (count, readbits, writebits, other);
#endif
}

/*****************************************************************************/
/*  The top */
/*****************************************************************************/

main(argc, argv)
     int             argc;
     char           **argv;
{
  char * host = NULL, * community, * oid, * value = NULL;

  /* -- Start up basic monet stuff, read config files */
  Monet_init ("msnmp", NULL, "msnmprc", MONET_DIR, argc, argv);
  MonetStd_init ();

  (void) MonetMember_module_class ("msnmp");
  MonetMember_create_write ("host", &host, "default host name");
  MonetMember_create_write("comm",&community,"default community name");
  MonetMember_create_write ( "oid", &oid, "default oid");
  MonetMember_create_write ( "value", &value, "default value");

  MonetConfig_create ( "-h", "msnmp->host", "", "Default host name");
  MonetConfig_create ( "-c", "msnmp->comm", "", "Default community");
  MonetConfig_create ( "-o", "msnmp->oid", "", "Default oid");
  MonetConfig_create ( "-v", "msnmp->value", "", "Default value");

  community = MonetNewString ("public");
  oid = MonetNewString ("system");

#ifdef PROBELIBOKAY
  /* Network probing stuff, snmp, x25 etc */
  MonetProbe_init ();
#endif

  /* Load in the user configuration files */
  /* and if interactive set up a command line */
  /* interface.  */
  Monet_user_config (argc, argv);

  /* Wait for events to come in and call the
     appropriate handlers when needed.
     */
  MonetSelectForever (before, after);
  /* NOTREACHED */
}

/*****************************************************************************/
/*****************************************************************************/
/* $Header: //gaia/group.local/computer/monet/Xmonet/RCS/main.c,v 1.1 1991/03/26 12:00:14 a38 Exp a38 $ */
/*****************************************************************************/
/*****************************************************************************/

