.TH  rping 1 "Release 0.10" Monet
.UC 6
.SH NAME
rping \- send ICMP ECHO_REQUEST packets to network hosts
.SH SYNTAX
.B /etc/rping
[\fIoptions\fP]
\fIhost\fP
.SH OPTIONS
.TP 8
.BI \-t " seconds"
Establishes a new timeout value per retry. The default
value is 2 seconds.
.TP
.BI \-r " retries"
Establishes a new retry count to retry after a timeout.
The default is to retry 3 times.
.TP
.B \-v
Sets verbose mode to print more detailed status information.
If not set, only a terse message is displayed.
.br
The option \fB\-vv\fP specifies "very verbose" mode.
If the specified host has more than one network address,
a probe packet is sent to each of the addresses. 
.TP
.B \-R
Additional route tracing information is displayed, if available,
for the round trip of the probe packet. The number of intermediate
hosts that can be shown is limited to 9, however.
.SH DESCRIPTION
.I rping
utilizes the
ICMP protocol's mandatory ECHO_REQUEST datagram to elicit an
ICMP ECHO_RESPONSE from a host or gateway.
ECHO_REQUEST datagrams, \*(lqpings,\*(rq have an IP and ICMP header,
followed by a \fBstruct timeval\fR, and then an arbitrary number
of \*(lqpad\*(rq bytes used to fill out the packet.
.PP
\fIrping\fR sends one datagram to the specified host, and
prints one line of output for every ECHO_RESPONSE returned.
Round-trip times are computed, but displayed only in verbose mode.
.PP
If the specified host has more than one network address,
a probe packet is sent to each of the addresses until a valid
echo reply is received. If the "very verbose" mode is set,
each of the addresses is probed unconditionally.
.PP
This program is intended for use in network testing, measurement
and management.
It should be used primarily for manual fault isolation.
The exit status is zero if the specified host responded properly.
.SH AUTHOR
Eric Wassenaar, Nikhef-H
.SH SEE ALSO
ping(8)
