/*****************************************************************************/
/*****************************************************************************/
/* $Header: /nfs/bilbo/bilbo/user/a38/monet/bin/xmonet/RCS/main.c,v 1.2 1992/04/15 11:18:27 a38 Exp a38 $ */
/*****************************************************************************/
/*****************************************************************************/

#include "xmonet.h"
#include <monet/msh/Channel.h>
#include <monet/std/Std.h>
#include <monet/probe/Probe.h>

/*****************************************************************************/
/*  Destroy everything created, ready to start afresh */
/*  I'll be bloody suprised if this works just now !!! */
/*****************************************************************************/

static void finish_system ()
{
  MapCB_finish ();
/*  XtDestroyApplicationContext (XmonetAppCon); */
  Monet_finish ();
  exit (0);
/*  XtCloseDisplay (XmonetDisplay); */
}

/***************************************************************************/
/*  Adjust 'select(2)' parameters */
/***************************************************************************/

extern void before (numbits,readbits, writebits, other, timer)
     int *numbits;
     fd_set *readbits, *writebits, *other;
     struct timeval *timer;
{
  /*  Modifies the timer if an event is pending in less time than the
      value of timer.tv_sec  */
  (void) MonetEvent_next (timer);
#ifdef PROBELIBOKAY
  MonetProbe_before_select(numbits,readbits, writebits, other, timer);
#endif
}

/***************************************************************************/
/*  Called after select to handle pending input  */
/***************************************************************************/

extern void after (count, readbits, writebits, other)
     int count;
     fd_set *readbits, *writebits, *other;
{
#ifdef PROBELIBOKAY
  MonetProbe_after_select (count, readbits, writebits, other);
#endif
}
/*****************************************************************************/
/*  The top */
/*****************************************************************************/

main(argc, argv)
     int             argc;
     char           **argv;
{
  /* -- Start X stuff  */
  if ( ! XMonet_init_x ("XMonet", &argc, argv)) {
    (void) exit (1);
  }

  /* -- Start up basic monet stuff, read config files */
  Monet_init ("xmonet", finish_system, "xmonetrc", MONET_DIR, argc, argv);
  MonetStd_init ();

  MonetLibrary_begin (monetapp, "xmonet", "Xmonet");
  MonetMember_module_class ("xmonet");
  MonetLibrary_done ();

  /* -- Start X monet stuff  */
  if ( ! XMonet_init ()) {
    (void) exit (1);
  }

  /*  -- Register all application specific callbacks and widget classes */
  MapCB_init ();

#ifdef PROBELIBOKAY
  /* -- Init the network query stuff */
  MonetProbe_init ();
#endif

  /*  -- Execute a startup monet script */
  Monet_user_config (argc, argv);

  /*  -- enter the main application loop */
  XMonet_EventLoop ();

  return 0; /*  for lint  */
}

/*****************************************************************************/
/*****************************************************************************/
/* $Header: /nfs/bilbo/bilbo/user/a38/monet/bin/xmonet/RCS/main.c,v 1.2 1992/04/15 11:18:27 a38 Exp a38 $ */
/*****************************************************************************/
/*****************************************************************************/

