/*****************************************************************************/
/*****************************************************************************/
/* $Header: //gaia/group.local/computer/monet/Xmonet/RCS/main.c,v 1.1 1991/03/26 12:00:14 a38 Exp a38 $ */
/*****************************************************************************/
/*****************************************************************************/

#include <monet/map/Drawing.h>
#include <monet/msh/Script.h>
#include <monet/std/Std.h>
#include <monet/x/Widget.h>
#include <monet/msh/Channel.h>
#include <monet/bitmap/Icons.h>

/*****************************************************************************/
/*  Destroy everything created, ready to start afresh */
/*  I'll be bloody suprised if this works just now !!! */
/*****************************************************************************/

static void finish_system ()
{
/*  XtDestroyApplicationContext (XmonetAppCon); */
/*  XtCloseDisplay (XmonetDisplay); */
  MonetDb_finish ();
  Monet_finish ();
}

/*************************************************************************/
/*  Strip chart widget  */
/*************************************************************************/

static void strip_chart_get (w, closure, call_data)
     Widget     w;              /* unused */
     XtPointer    closure;        /* unused */
     XtPointer    call_data;      /* pointer to (double) return value */
{
  double value;
  char * r;

  r = MonetshExecute ("xchart-get", NULL, False);
  if (r) {
    value = atof (r);
  } else {
    value = 0.0;
  }
  *(double *)call_data = value;
}

MONETCALLBACK(do_strip_chart_callback)
     Widget w;
     if (w = Xmonet_sub_widget (argv[1], stripChartWidgetClass,
				"a Strip Chart")) {
       XtAddCallback(w, XtNgetValue, strip_chart_get, NULL);
     }
MONETEND

/*****************************************************************************/
/*  The top */
/*****************************************************************************/

main(argc, argv)
     int             argc;
     char           **argv;
{
  char * host = NULL, * attribute = NULL;

  /* -- Start X stuff  */
  if ( ! XMonet_init_x ("XMonetChart", &argc, argv)) {
    (void) exit (1);
  }

  /* -- Start up basic monet stuff, read config files */
  Monet_init ("xmonetchart", finish_system, "xmonetchartrc",
	      MONET_DIR, argc, argv);
  MonetStd_init ();

  (void) MonetMember_module_class ("xchart");
  MonetMember_create_write ("host", &host, "default host name");
  MonetMember_create_write ( "attribute", &attribute, "default attribute");

  MonetConfig_create ( "-h", "xchart->host", "", "Default host name");
  MonetConfig_create ( "-attr", "xchart->attribute", "", "Default attribute");

  MonetMember_create ("start",
		      do_strip_chart_callback,
		      "stripchartWidget",
		      "Sets the get value function for a strip chart widget");

  /* -- Init the entity database, as a server */
  MonetDb_init (True, NULL);

  Monet_command_line_options (argc, argv);

  /* -- Start X monet stuff  */
  if ( ! XMonet_init ()) {
    (void) exit (1);
  }

  /*  -- Create widget tree below XmonetTopWidget shell using Xrm database */
  WcWidgetCreation ( XmonetTopWidget );

  /*  -- Realize the widget tree */
  XtRealizeWidget ( XmonetTopWidget );

  /* this ensures that all requests are sent */
  /* without this line, linking with cc means */
  /* that the requests are not all sent */
  XFlush(XtDisplay(XmonetTopWidget));

  /*  -- Set up the icon pixmap */
  {
    Pixmap icon;
    Arg tmp_arg[2];
    icon = XCreateBitmapFromData(XmonetDisplay, XtWindow(XmonetTopWidget),
				 monetchart_bits, monetchart_width,
				 monetchart_height);
    XtSetArg(tmp_arg[0], XtNiconPixmap, icon);
    XtSetValues(XmonetTopWidget, tmp_arg, ONE);
  }
  /*  -- Execute a startup monet script */
  Monet_user_config (argc, argv);

  XMonet_EventLoop ();
}

/*****************************************************************************/
/*****************************************************************************/
/* $Header: //gaia/group.local/computer/monet/Xmonet/RCS/main.c,v 1.1 1991/03/26 12:00:14 a38 Exp a38 $ */
/*****************************************************************************/
/*****************************************************************************/

