.TH  xmonetchart 1 "Release 0.10" Monet
.SH NAME
xmonetchart-X11 based Attribute Chart Tool
.SH SYNOPSIS
xmonetchart [  -ps -p -a -probe -edb -attr -h -reference -manual -email -debug -home -startup -dir -short -daemon -shell -exec -options -help -c]
.SH DESCRIPTION
Monetchart is an X11 based client for monet.  It uses the Athena
Widgets (Xaw) StripChart Widget to display a the changing value of
an attribute over time, in a way similar to how xload(1) shows the load
on the local host.
.PP
Monet provides distributed monitoring of the network and keeps a set
of attributes on the systems it monitors representing their current state.
Clients connected to a monitoring agents are notified about
state changes as they happen.
.PP
Monetchart is used to monitor exactly one attribute of a single
system.  The system has a built in scripting language which means the
program is not not limited to just the values returned by the agents
but is perfectly capable of processing one of more attributes to get
the required value.
.PP
The program is not linked with the monetprobe library which would make it
capable of doing its own network querying (snmp, x25, ip etc).  If
this capability is required it is quite simple to add it.
.PP
The user interface is built using Xaw, Wcl and Xmonet and as such is very
configurable.
.PP
The StripChart Widget calls a function every so many seconds which should
return a number.  When this happens a monetsh function 'xchart-get' is
called which returns the required value, which is defined in the
configuration file $MONETDIR/xmonetchart.msh.
.SH OPTIONS
.TP 8
.B          -ps \-
Prolog file for postscript output
.TP 8
.B           -p \-
Port number of monitoring agent
.TP 8
.B           -a \-
Address of monitoring agent
.TP 8
.B       -probe \-
Enable probing by this program
.TP 8
.B         -edb \-
entity database file
.TP 8
.B        -attr \-
Default attribute
.TP 8
.B           -h \-
Default host name
.TP 8
.B   -reference \-
produces an latex formatted reference manual and exits
.TP 8
.B      -manual \-
produces an nroff formatted manual page and exits
.TP 8
.B       -email \-
Sets the users email address.
.TP 8
.B       -debug \-
Switches on debugging -debug [on|off|num]
.TP 8
.B        -home \-
The user home directory, if not ~
.TP 8
.B     -startup \-
The name of the startup file
.TP 8
.B         -dir \-
Where to look for run time specific files
.TP 8
.B       -short \-
'.' or ',' can be used in place of ->
.TP 8
.B      -daemon \-
Set daemon mode for this program, careful
.TP 8
.B       -shell \-
Prompt for input from the command line
.TP 8
.B        -exec \-
A command to execute on start up
.TP 8
.B     -options \-
brief list of command line options
.TP 8
.B        -help \-
lists command line options and exits
.TP 8
.B           -c \-
Execute rest of command line as command and exit
.SH FILES
$MONETDIR/*.msh ~/.xmonetchartrc $MONETDIR/xmonetchartrc.msh
.SH SEE ALSO
Monet: User Guide
.SH AUTHOR
.na
.nf
James Barr, NIKHEF-H, Amsterdam <a38@nikhef.nl>
