/*****************************************************************************/
/*****************************************************************************/
/* $Header: //gaia/group.local/computer/monet/Xmonet/RCS/main.c,v 1.1 1991/03/26 12:00:14 a38 Exp a38 $ */
/*****************************************************************************/
/*****************************************************************************/

#include <monet/map/Drawing.h>
#include <monet/msh/Script.h>
#include <monet/std/Std.h>
#include <monet/x/Widget.h>
#include <monet/msh/Channel.h>
#include <monet/probe/Probe.h>
#include <monet/bitmap/Icons.h>

/*****************************************************************************/
/*  Destroy everything created, ready to start afresh */
/*  I'll be bloody suprised if this works just now !!! */
/*****************************************************************************/

static void finish_system ()
{
/*  XtDestroyApplicationContext (XmonetAppCon); */
/*  XtCloseDisplay (XmonetDisplay); */
#ifdef PROBELIBOKAY
  MonetProbe_finish ();
#endif
  Monet_finish ();
}

/*****************************************************************************/
/*  The top */
/*****************************************************************************/

main(argc, argv)
     int             argc;
     char           **argv;
{
  char * host = NULL, * community, * oid, * value = NULL;

  /* -- Start X stuff  */
  if ( ! XMonet_init_x ("XMonetSnmp", &argc, argv)) {
    (void) exit (1);
  }

  /* -- Start up basic monet stuff, read config files */
  Monet_init ("xmonetsnmp", finish_system, "xmonetsnmprc",
	      MONET_DIR, argc, argv);
  MonetStd_init ();

  (void) MonetMember_module_class ("xsnmp");
  MonetMember_create_write ("host", &host, "default host name");
  MonetMember_create_write("community",&community,"default community name");
  MonetMember_create_write ( "oid", &oid, "default oid");
  MonetMember_create_write ( "value", &value, "default value");

  MonetConfig_create ( "-h", "xsnmp->host", "", "Default host name");
  MonetConfig_create ( "-c", "xsnmp->community", "", "Default community");
  MonetConfig_create ( "-o", "xsnmp->oid", "", "Default oid");
  MonetConfig_create ( "-v", "xsnmp->value", "", "Default value");

  community = MonetNewString ("public");
  oid = MonetNewString ("system");

#ifdef PROBELIBOKAY
  /* -- Init the network query stuff */
  MonetProbe_init ();
#endif

  Monet_command_line_options (argc, argv);

  /* -- Start X monet stuff  */
  if ( ! XMonet_init ()) {
    (void) exit (1);
  }

  /*  -- Create widget tree below XmonetTopWidget shell using Xrm database */
  WcWidgetCreation ( XmonetTopWidget );

  /*  -- Realize the widget tree */
  XtRealizeWidget ( XmonetTopWidget );

  /* this ensures that all requests are sent */
  /* without this line, linking with cc means */
  /* that the requests are not all sent */
  XFlush(XtDisplay(XmonetTopWidget));

  /*  -- Set up the icon pixmap */
  {
    Pixmap icon;
    Arg tmp_arg[2];
    icon = XCreateBitmapFromData(XmonetDisplay, XtWindow(XmonetTopWidget),
				 monetsnmp_bits, monetsnmp_width,
				 monetsnmp_height);
    XtSetArg(tmp_arg[0], XtNiconPixmap, icon);
    XtSetValues(XmonetTopWidget, tmp_arg, ONE);
  }
  /*  -- Execute a startup monet script */
  Monet_user_config (argc, argv);

  XMonet_EventLoop ();
}

/*****************************************************************************/
/*****************************************************************************/
/* $Header: //gaia/group.local/computer/monet/Xmonet/RCS/main.c,v 1.1 1991/03/26 12:00:14 a38 Exp a38 $ */
/*****************************************************************************/
/*****************************************************************************/

