

#ifndef _COMPONENT_H_
#define _COMPONENT_H_


/***************************************************************************/
/*  Function Prototypes                                                    */
/***************************************************************************/

#ifdef MONET_PROTOTYPES

extern void init_components	(void);
extern void finish_components	(void);
extern void load_component	(String super, String sub);
extern void make_subcomponent	(MonetEntity super, MonetEntity sub);
extern void unmake_subcomponent	(MonetEntity super, MonetEntity sub);
extern void free_components	(MonetEntity sys);
extern MonetBool isSubcomponent	(MonetEntity super, MonetEntity sub);
extern MonetBool isSupercomponent	(MonetEntity super, MonetEntity sub);

#else

extern void init_components	();
extern void finish_components	();
extern void load_component	();
extern void make_subcomponent	();
extern void unmake_subcomponent	();
extern void free_components	();
extern MonetBool isSubcomponent	();
extern MonetBool isSupercomponent	();

#endif

#endif  _COMPONENT_H_
