#ifndef  MONET_DB_H
#define  MONET_DB_H

/***************************************************************************/
/***************************************************************************/
/*  $Header: Db.h,v 1.1 91/10/01 16:06:58 a38 Exp $ */
/***************************************************************************/
/***************************************************************************/

#include <monet/msh/Entity.h>
#include <monet/draw/Shape.h>
#include <monet/db/Component.h>
#include <monet/db/Redirect.h>

#define MonetAttribute_TO_NUM         3
#define MonetAttribute_FROM_NUM       4

#define MonetAttribute_AREA_NUM       5

#define MonetAttribute_SHAPE_NUM      9
#define MonetAttribute_PINGID_NUM  10
#define MonetAttribute_INTERFACE_NUM  11
#define MonetAttribute_COMPONENT_NUM  12
#define MonetAttribute_REQUEST_NUM  13

#define MONETAREA(entity) \
    MONETGETPOINTER((entity),MonetAttribute_AREA_NUM)
      
#define SHAPE(entity) \
    MONETGETPOINTER((entity),MonetAttribute_SHAPE_NUM)
      
#define PINGID(entity) \
      MONETGETINTEGER((entity),MonetAttribute_PINGID_NUM)

extern MonetEntity
  MonetInterfaceClass,
  MonetMapClass,
  MonetSystemClass,
  MonetNodeClass;

extern MonetEntity	MonetEntity_find_or_create
  PR((String));

extern MonetBool MonetEntity_is_title_valid
  PR((MonetEntity entity_class, String title));

extern MonetBool MonetEntity_isNode PR((MonetEntity));
extern MonetBool MonetEntity_isSystem PR((MonetEntity));
extern MonetBool MonetEntity_isInterface PR((MonetEntity));
extern MonetBool MonetEntity_isInterfaceClass PR((MonetEntity));
extern MonetBool MonetEntity_isMapClass PR((MonetEntity));
extern MonetBool MonetEntity_isMap PR((MonetEntity));

extern MonetShape MonetEntity_shapeOf
  PR((MonetEntity));


/***************************************************************************/
/*  Interfaces  */
/***************************************************************************/

extern MonetEntity	MonetEntity_choose_interface
  PR((MonetEntity from, MonetEntity to));
extern MonetEntity from_interface		PR((MonetEntity));
extern MonetEntity to_interface		PR((MonetEntity));
extern MonetBool can_interface		PR((MonetEntity, MonetEntity));
extern MonetBool are_interfaced		PR((MonetEntity, MonetEntity));
extern MonetBool MonetEntity_make_links
  PR((MonetEntity interface, MonetEntity from, MonetEntity to));
extern MonetBool MonetEntity_make_interface
  PR((MonetEntity,MonetEntity));
extern MonetBool MonetEntity_unmake_interface
  PR((MonetEntity,MonetEntity));

extern MonetEntity   MonetEntity_create_interface
  PR((MonetEntity entity_class, String title));
extern void	MonetEntity_status_report
  PR((MonetEntity));

extern String get_titleFormat
  PR((MonetEntity entity_class));

extern void  MonetEntity_set_shape
  PR((MonetEntity entity, MonetShape shape));

extern void MonetDb_init
  PR((MonetBool is_server, MonetStatusTrigger changed));

extern void MonetDb_finish
  PR((void));

/***************************************************************************/
/***************************************************************************/
/*  $Header: Db.h,v 1.1 91/10/01 16:06:58 a38 Exp $ */
/***************************************************************************/
/***************************************************************************/

#endif

