
#ifndef MONET_PRIVATE_ENTITY_H
#define MONET_PRIVATE_ENTITY_H

#include "Db.h"

/**************************************************************
  Links to an entity
  **************************************************************/

#define LVAL_FROM(entity) \
  (MONETGETPOINTER((entity),MonetAttribute_FROM_NUM))

#define LVAL_TO(entity)   \
  (MONETGETPOINTER((entity),MonetAttribute_TO_NUM))

#define FROM(entity) \
  ((MonetEntity) LVAL_FROM(entity))

#define TO(entity)   \
  ((MonetEntity) LVAL_TO(entity))

#define INTERFACE(entity)   \
  ((MonetEntity) MONETGETPOINTER((entity),MonetAttribute_INTERFACE_NUM))


/***************************************************************************/
/*  Function definitions  */
/***************************************************************************/

extern void MonetDbParser_init PR((void));
extern void MonetDbParser_finish PR((void));

extern MonetEntity PingId2MonetEntity PR ((unsigned id));
extern void MonetEntity_attribute_triggers PR((MonetEntity));

extern void init_parser	PR((void));
extern void finish_parser	PR((void));
extern void MonetEnum_init PR((void));
extern void MonetEnum_finish PR((void));


/*  These are all of type AttributeRoutine  */
extern String set_titleFormat 
  PR((MonetEntity,  AttributeOperation, AttributeFormat, String));
extern String set_instances 
  PR((MonetEntity,  AttributeOperation, AttributeFormat, String));
extern String set_interfaceClass 
  PR((MonetEntity,  AttributeOperation, AttributeFormat, String));
extern String set_systemClass 
  PR((MonetEntity,  AttributeOperation, AttributeFormat, String));
extern String set_noset_instances 
  PR((MonetEntity,  AttributeOperation, AttributeFormat, String));
extern String set_mapClass 
  PR((MonetEntity,  AttributeOperation, AttributeFormat, String));
extern String set_underlying 
  PR((MonetEntity,  AttributeOperation, AttributeFormat, String));
extern String set_titleFormat 
  PR((MonetEntity,  AttributeOperation, AttributeFormat, String));
extern String set_shape 
  PR((MonetEntity,  AttributeOperation, AttributeFormat, String));
extern String set_unbendingInterface 
  PR((MonetEntity,  AttributeOperation, AttributeFormat, String));

extern MonetBool isUnderlying
  PR((MonetEntity entity_class));

extern String	get_ping_instruction 
  PR((MonetEntity));
extern MonetBool	isBendingInterface 
  PR((MonetEntity));
extern MonetEntity	get_fromClass 
  PR((MonetEntity));
extern MonetEntity	get_toClass 
  PR((MonetEntity));
extern MonetBool	no_instances_allowed 
  PR((MonetEntity));

extern void monet_db_init_interface 
  PR((void));
extern void monet_db_finish_interface 
  PR((void));

extern void monet_init_redirect 
  PR((MonetBool is_server));
extern void monet_finish_redirect 
  PR((void));

extern void monet_init_components
  PR((void));
extern void monet_finish_components
  PR((void));

extern void MonetDb_trigger_init
  PR((void));
extern void MonetDb_trigger_finish
  PR((void));

extern void monet_init_access
  PR((void));
extern void monet_finish_access
  PR((void));

extern void init_db_script
  PR((void));
extern void finish_db_script
  PR((void));

#endif
