
/***************************************************************/
/***************************************************************/
/* $Header$ */
/***************************************************************/
/*  The mapper is bsed on a very simple entity oriented        */
/*  database model.  Every displayed entity Maps/Classes/      */
/*  systems/Interfaces are entitys.                            */
/*  This lot could be tidied up quite a bit.                   */
/***************************************************************/
          
#include "entityP.h"
#include "requestP.h"
#include <monet/msh/StringTable.h>
#include <monet/msh/Script.h>
#include <monet/draw/Draw.h>

MonetEntity
  MonetInterfaceClass,
  MonetMapClass,
  MonetSystemClass,
  MonetNodeClass;

#define BENDING(o) (False)

/***************************************************************/
/*  Various Tests of sub class  */
/***************************************************************/

extern MonetBool MonetEntity_isInterface (entity)
	MonetEntity entity;
{
  return (MonetEntity_subclass (MonetInterfaceClass, entity) &&
	  !MonetEntity_isClass(entity));
}

extern MonetBool MonetEntity_isNode (entity)
	MonetEntity entity;
{
  return (MonetEntity_subclass (MonetNodeClass, entity) &&
	  !MonetEntity_isClass(entity));
}

extern MonetBool MonetEntity_isSystem (entity)
	MonetEntity entity;
{
  return (MonetEntity_subclass (MonetSystemClass, entity) &&
	  !MonetEntity_isClass(entity));
}

extern MonetBool MonetEntity_isInterfaceClass (entity)
	MonetEntity entity;
{
  return (MonetEntity_isClass(entity) &&
	  MonetEntity_subclass (MonetInterfaceClass, entity));
}

extern MonetBool MonetEntity_isMapClass (entity)
     MonetEntity entity;
{
  return (MonetEntity_isClass(entity) &&
	  MonetEntity_subclass (MonetMapClass, entity));
}

extern MonetBool MonetEntity_isMap(entity)
	MonetEntity entity;
{
  return (MonetEntity_subclass (MonetMapClass, entity));
}

/***************************************************************/
/*  Various Tests  */
/***************************************************************/

extern MonetBool isUnderlying (entity_class)
	MonetEntity entity_class;
{
	if (entity_class == NULL)
		return False; /* !!! Dubious */
	if (!MonetEntity_isClass (entity_class))
		return False;
	return False; /* CLASS(entity_class) -> underlying; */
}

/***************************************************************************/
/***************************************************************************/

extern String set_titleFormat (entity_class, op, format, title_format)
     MonetEntity entity_class;
     AttributeOperation op;
     AttributeFormat format;
     String title_format;
{
/*  if (MonetEntity_isClass (entity_class)) {
    if (format) {
      if (FORMAT(entity_class) != NULL)
	MonetFree (FORMAT(entity_class));
      FORMAT(entity_class) = MonetNewString (title_format);
    }
    return FORMAT(entity_class);
  }
  MonetPrintfError ("Can only set title format in a class definition");
*/
  return NULL;
}

/****************************************************************/
/*  */
/****************************************************************/

extern MonetBool isBendingInterface (i)
     MonetEntity i;
{
  MonetEntity entity_class;

  if (MonetEntity_isClass (i))
    entity_class = i;
  else
    entity_class = MonetEntity_classOf(i);

  return BENDING (entity_class);
}

/****************************************************************/
/*  Return classes of nodes that an interface can connect to    */
/****************************************************************/

extern MonetEntity get_fromClass (o)
     MonetEntity o;
{
  MonetEntity entity_class;

  if (MonetEntity_isClass (o))
    entity_class = o;
  else
    entity_class = MonetEntity_classOf (o);
  for (; entity_class; entity_class = MonetEntity_classOf (entity_class))
    if (FROM (entity_class) != NULL)
      return FROM (entity_class);
  return NULL;
}

extern MonetEntity get_toClass (o)
     MonetEntity o;
{
  MonetEntity entity_class;

  if (MonetEntity_isClass (o))
    entity_class = o;
  else
    entity_class = MonetEntity_classOf (o);
  for (; entity_class; entity_class = MonetEntity_classOf (entity_class))
    if (TO (entity_class) != NULL)
      return TO (entity_class);
  return NULL;
}

/*****************************************************************************/
/*  Match an object title against standard pattern for a class to see if it  */
/*  is valid. */
/*****************************************************************************/

extern MonetBool MonetEntity_is_title_valid (entity_class, title)
	MonetEntity entity_class;
	String title;
{
/*	if (FORMAT(entity_class) == NULL) {
	} else if (MonetMatchWildcard (title, FORMAT(entity_class))) {
	} else
		return False;
*/
	return True;
}

/*****************************************************************/
/*  return the format of entity titles for a given class         */
/*****************************************************************/

extern String get_titleFormat (entity_class)
	MonetEntity entity_class;
{
/*	if (MonetEntity_isClass (entity_class))
		return FORMAT(entity_class);
*/
	return NULL;
}

/***************************************************************/
/*  Search for entity and return it if found else create a    */
/*  new one and return that.  */
/***************************************************************/

extern MonetEntity MonetEntity_find_or_create (string)
     String string;
{
  MonetEntity entity, entity_class;
  MonetBool isclass;
  String title;
  
  if (entity = parse_title (string, &title, &entity_class, &isclass)) {
  } else if (entity_class == NULL) {
    MonetPrintfError ("Class of entity [%s] is unknown", string);
    return NULL;
  } else if (title == NULL) {
    return NULL;
  } else if (isclass) {
    MonetPrintfError ("Find and create, cannot create classes [%s]", title);
    /* entity = MonetEntity_create_class (entity_class, title); */
  } else if (! MonetEntity_is_title_valid (entity_class, title)) {
    MonetPrintfWarning
      ("Title [%s] does not match the pattern [%s] for class [%s]",
       title, get_titleFormat (entity_class), MonetEntity_title (entity_class));
  } else {
    entity = MonetEntity_create_instance (entity_class, title);
  }
  if (!entity)
    MonetPrintfError ("Could not find or create entity [%s]", string);
  
  return entity;
}

/*****************************************************************************/
/*  Free interface  */
/*****************************************************************************/

extern MonetBool free_entity_interface (interface)
     MonetEntity interface;
{
  /*  Should disconnect  */
  return True;
}

/***************************************************************/
/*  An drawing is pingable if its class a ping description */
/***************************************************************/

extern MonetEntity MonetEntity_choose_interface (from,to)
     MonetEntity from, to;
{
  MonetEntity fc, fcc;

  if (from && (fc = MonetEntity_classOf(from)) &&
	(fcc = MonetEntity_classOf(fc))) {
    MonetEntity c, entity_class;
    entity_class = NULL;
    FOR_ENTITYLIST (c, MonetEntity_instances (fcc)) {
      if (MonetEntity_isInterfaceClass (c) &&
	  can_interface (c, fc) && can_interface (c, MonetEntity_classOf(to)))
	if (entity_class) {
	  entity_class = NULL;
	  break;
	} else {
	  entity_class = c;
	}
    } END_FORLIST;
    return entity_class;
  }
  return NULL;
}

extern MonetEntity PingId2MonetEntity (id)
     unsigned id;
{
  MonetEntity entity;
  FORALL (entity, Entities, next)
    if (PINGID (entity) == id)
      return entity;
  return NULL;
}

/******************************************************************/
/*  Get shape of object                                           */
/******************************************************************/

extern MonetShape MonetEntity_shapeOf (entity_class)
	MonetEntity entity_class;
{
  if (entity_class == NULL)
    return DEFAULT_SHAPE;
  if (SHAPE(entity_class))
    return (MonetShape) SHAPE(entity_class);
  return MonetEntity_shapeOf (MonetEntity_classOf(entity_class));
}

extern void  MonetEntity_set_shape (entity, shape)
     MonetEntity entity;
     MonetShape shape;
{
  SHAPE(entity) = (caddr_t) shape;
}

/******************************************************************/
/*  Handle changes to an entity, by triggering actions  */
/******************************************************************/

static MonetStatusTrigger ChangeTrigger;

static void change_trigger (entity)
     MonetEntity entity;
{
  MonetEntity_return_result (entity, False);
  MonetEntity_attribute_triggers (entity);
  if (ChangeTrigger) {
    ChangeTrigger (entity);
  }
}

/***************************************************************/
/*  Init and Finish                                            */
/***************************************************************/

extern void MonetDb_init (is_server, changed)
     MonetBool is_server;
     MonetStatusTrigger changed;
{
  MonetEntity top, network;

  MonetLibrary_begin (monetlib, "db", "Database Extensions");

  ChangeTrigger = changed;
  MonetEntity_set_change_trigger (change_trigger);

  MonetEnum_init ();
  init_db_script ();
  MonetDbParser_init ();

  monet_init_redirect (is_server);
  MonetRequest_init ();

  /*********************************************/
  /*  Defaults types and attributes            */
  /*********************************************/

  MonetDraw_init ();  /*  Needed for the shape attribute */
  monet_init_access ();
  monet_db_init_interface ();


  top = MonetEntityTopClass ();
  network = MonetEntity_create_class (top, "Network");
  MonetMapClass       = MonetEntity_create_class (network, "Map");
  MonetSystemClass    = MonetEntity_create_class (network, "System");
  MonetInterfaceClass = MonetEntity_create_class (MonetSystemClass,
						  "Interface");
  MonetNodeClass      = MonetEntity_create_class (MonetSystemClass, "Node");

  MonetDb_trigger_init ();

  MonetLibrary_done ();
}

extern void MonetDb_finish ()
{
  MonetDb_trigger_finish ();
  monet_db_finish_interface ();
  monet_finish_access ();
  MonetDraw_finish ();
  MonetRequest_finish ();
  monet_finish_redirect ();

  MonetDbParser_finish ();
  finish_db_script ();
  MonetEnum_finish ();
}

/***************************************************************/
/***************************************************************/
/* $Header$ */
/***************************************************************/
/***************************************************************/

