/***************************************************************************/
/***************************************************************************/
/* $Header: //gaia/group.local/computer/monet/lib/draw/RCS/Shape.h,v 1.1 1991/05/30 14:58:21 a38 Exp a38 $ */
/***************************************************************************/
/***************************************************************************/

#ifndef MONET_SHAPE_H
#define MONET_SHAPE_H

#include <monet/draw/Draw.h>

/***************************************************************************/
/*  How connectors (interfaces) are shown  */
/***************************************************************************/

typedef enum {
  connector_big = 0,
  connector_small = 1,
  connector_invisible = 2,
} ConnectorState;

/***************************************************************************/
/*  The basic shape class  */
/***************************************************************************/

#define NULSHAPE ((MonetShape) 0)
#define DEFAULT_SHAPE NULSHAPE

typedef struct monet_shape  * MonetShape;
typedef unsigned long MonetShapeState;

#define MONETSTATE_NO_PICTURE    (1<<24)
#define MONETSTATE_ROUND_BORDER  (1<<25)
#define MONETSTATE_NO_BORDER     (1<<26)
#define MONETSTATE_NO_LABEL      (1<<27)

/***************************************************************************/
/*  Functions  */
/***************************************************************************/

extern ConnectorState ConnectorState_default PR((void));

extern MonetShapeState  MonetShapeState_sub
  PR((MonetShapeState state, MonetShapeState new_state));

extern MonetShapeState  MonetShapeState_add
  PR((MonetShapeState state, MonetShapeState new_state));

extern MonetShapeState String2MonetShapeState
  PR((String));

extern String MonetShapeState2String
  PR((MonetShapeState));

extern MonetShape		String2MonetShape
  PR((String));

extern String		MonetShape2String		
  PR((MonetShape));

extern MonetBool MonetShape_isNet		
  PR((MonetShape));

extern void		MonetShape_prepare
  PR((MonetShape, MonetBool force_label,
   ConnectorState,
   Dimension *, Dimension *, String));

extern void		MonetShape_draw
  PR((MonetShape,
      Position, Position,
      Dimension, Dimension,
      MonetShapeState,
      MonetBool force_label,
      String label, int labellen, String label_2));

extern ConnectorState	String2ConnectorState
  PR((String));
extern String           ConnectorState2String
  PR((ConnectorState state));
extern MonetBool		MonetShape_resizable
  PR((MonetShape));
extern MonetBool		MonetShape_isConnector
  PR((MonetShape));
extern void		MonetShape_init
  PR((void));
extern void		MonetShape_finish
  PR((void));
extern MonetBool MonetShape_bending
  PR((MonetShape shape));

extern void MonetShape_draw_all
  PR((void));

/***************************************************************************/
/***************************************************************************/

#endif
