/******************************************************************/
/******************************************************************/
/* $Header: //gaia/group.local/computer/monet/lib/draw/RCS/MonetShape.c,v 1.2 1991/05/30 14:59:39 a38 Exp a38 $ */
/******************************************************************/
/* $Log: MonetShape.c,v $
 * Revision 1.2  1991/05/30  14:59:39  a38
 * Combined stuff from several sources to create a single MonetShape class.
 * Should be much easier to add new MonetShapes now.
 *
 * This stuff is something of a mess
 *
 * Revision 1.1  1991/05/30  14:58:21  a38
 * Initial revision
 * */
/******************************************************************/
/******************************************************************/

#include <monet/msh/General.h>
#include "drawP.h"
#include <monet/draw/Shape.h>
#include <monet/msh/Script.h>

static ConnectorState connector_default;
static MonetShape CurrentShape;

/***************************************************************************/
/*  Attributes connected with various shapes */
/***************************************************************************/

#define MONETSHAPE_CONNECTOR     1
#define MONETSHAPE_NOT_RESIZABLE 2
#define MONETSHAPE_EQUAL_SIDES   4
#define MONETSHAPE_NO_BORDER     8
#define MONETSHAPE_NO_LABEL      16
#define MONETSHAPE_LABEL_BORDER  32
#define MONETSHAPE_REVERSE       64
#define MONETSHAPE_NO_PICTURE    128
#define MONETSHAPE_NOT_BENDING   256
#define MONETSHAPE_LABEL_OUTSIDE 512
#define MONETSHAPE_IS_NET        1024

/************************************************************************/
/*  Drawing attributes  */
/************************************************************************/

#define	extra_left          1<<0
#define	extra_leftbelow     2<<0
#define	extra_border        3<<0
#define	extra_double_border 4<<0
#define	extra_highlight     5<<0
#define	extra_lowlight      6<<0

#define MONETSHAPE_EXTRA1(state) (state) & \
  (extra_left | extra_leftbelow | extra_border | extra_double_border | \
     extra_highlight | extra_lowlight)

#define	flag_down         1<<3
#define	flag_halfmast     2<<3
#define	flag_up           3<<3
#define MONETSHAPE_EXTRAFLAG(state) (state) & \
  (flag_down | flag_up | flag_halfmast)

#define	diagonal_topleft    1<<5
#define	diagonal_topright   2<<5
#define	diagonal_crosstwice 3<<5
#define MONETSHAPE_DIAGONAL(state)  (state) & \
  (diagonal_topleft | diagonal_topright | diagonal_crosstwice)

#define	topright_cross    1<<7
#define	topright_upFlag   2<<7
#define	topright_downFlag 3<<7
#define	topright_T        4<<7
#define	topright_P        5<<7
#define	topright_C        6<<7
#define	topright_U        7<<7

#define TOPRIGHT(state) (state) & \
  (topright_cross | topright_upFlag | topright_downFlag | \
   topright_T | topright_P | topright_C | topright_U)

#define border_normal  (1<<10)
#define border_backing (2<<10)
#define border_grey    (3<<10)

#define BORDER(state) ((state)&(border_normal | border_grey | border_backing ))

#define inside_normal  (1<<12)
#define inside_backing (2<<12)
#define inside_grey    (3<<12)

#define INSIDE(state)((state) & (inside_normal | inside_grey | inside_backing))

#define state_reverse (1<<14)
#define REVERSE(state) (state) & (state_reverse)

#define name_reverse    (1<<15)
#define NAME_REVERSE(state) ((state) & (name_reverse))

/***************************************************************************/
/*  Definition of a shape  */
/***************************************************************************/

typedef
  enum {
    s_elipse, s_fill_elipse, s_rectangle, s_fill_rectangle, 
    s_line, s_move, s_thick, s_thin, s_solid, s_dotted,
    s_text
    } DrawType;

#define MAXCOMMANDS 128
struct monet_shape {
  int			flags;
  String		name;
  int width, height;  /* Default width and height */
  struct {
    DrawType type;
    Position x, y;
    unsigned text_len;
    String text;
  } commands[MAXCOMMANDS];
  int number_of_commands;
  MonetShape  		next;
};

static MonetShape MonetShapeTable;

/**************************************************************************
  Shape is a network
  **************************************************************************/

extern MonetBool MonetShape_isNet	(shape)
     MonetShape shape;
{
  if (shape && shape -> flags & MONETSHAPE_IS_NET)
    return True;
  return False;
}

/***************************************************************************/
/*  Translation table between strings and shape-state attributes */
/***************************************************************************/

static struct  {
  String name;
  MonetShapeState state;
} table[] = { 
  { "reverse", state_reverse },
  { "border-left", extra_left },
  { "border-left-below", extra_leftbelow },
  { "extra-border", extra_border },
  { "double-border", extra_double_border },
  { "left-flag-down", flag_down },
  { "left-flag-halfmast", flag_halfmast },
  { "left-flag-up", flag_up },
  { "top-left-diagonal", diagonal_topleft },
  { "top-right-diagonal", diagonal_topright },
  { "double-diagonal", diagonal_crosstwice },
  { "highlight", extra_highlight },
  { "lowlight", extra_lowlight },
  { "top-right-diagonal", topright_cross },
  { "top-right-up-flag", topright_upFlag },
  { "top-right-down-flag", topright_downFlag },
  { "top-right-T",  topright_T },
  { "top-right-P",  topright_P },
  { "top-right-C",  topright_C },
  { "top-right-U",  topright_U },
  { "border-normal", border_normal },
  { "border-grey",   border_grey },
  { "border-backing",border_backing },
  { "inside-normal", inside_normal },
  { "inside-grey",   inside_grey },
  { "inside-backing",inside_backing },
  { "name-reverse",  name_reverse },
  { "none", 0 },
  { NULL, 0 }
};


extern ConnectorState ConnectorState_default ()
{
  return connector_default;
}

/************************************************************************/

/************************************************************************/

extern MonetShapeState  MonetShapeState_sub (state, new_state)
     MonetShapeState state, new_state;
{
  return state;
}

extern MonetShapeState  MonetShapeState_add (state, new_state)
     MonetShapeState state, new_state;
{
  state |= new_state;
  return state;
}

/************************************************************************/
/*  Translate between state and name  */
/************************************************************************/

extern MonetShapeState String2MonetShapeState (string)
     String string;
{
  unsigned num;
  for (num = 0; table[num].name; ++num)
    if (EQS(string, table[num].name))
      return table[num].state;
  MonetPrintfError ("No such drawing state [%s]", string);
  return 0;
}

extern String MonetShapeState2String (state)
     MonetShapeState state;
{
  unsigned num;
  for (num = 0; table[num].name; ++num)
    if (state == table[num].state)
      return table[num].name;
  return "";
}

MONETCALLBACK(do_help_shape_states)
     unsigned num;

     for (num = 0; table[num].name; ++num) {
       MonetPrintfnl ("%s", table[num].name);
     }
MONETEND

/************************************************************************/
/*  MonetShape handling routines  */
/************************************************************************/

extern String MonetShape2String (shape)
     MonetShape shape;
{
  if (shape)
    return shape -> name;
  return "simple";
}

extern MonetShape String2MonetShape (name)
	String name;
{
  MonetShape s;
  if (name) {
    FORALL (s, MonetShapeTable, next)
      if (EQS(name, s->name))
	return s;
  }
  return NULL;
}

/******************************************************************/
/*  Can a MonetShape be resized  */
/******************************************************************/

extern MonetBool MonetShape_resizable (shape)
	MonetShape shape;
{
	if (! shape)
		return True;
	if (shape->flags & MONETSHAPE_NOT_RESIZABLE)
		return False;
	return True;
}

/******************************************************************/
/*  Is this a connector  */
/******************************************************************/

extern MonetBool MonetShape_isConnector (shape)
	MonetShape shape;
{
	if (! shape)
		return False;
	return (shape->flags & MONETSHAPE_CONNECTOR);
}

/******************************************************************/
/*  Prepare for drawing  */
/*  Adjust width and height */
/******************************************************************/

extern void MonetShape_prepare (shape, force_label, conn,
				new_width, new_height, label)
     MonetShape shape;
     MonetBool force_label;
     Dimension *new_width, *new_height;
     ConnectorState conn;
     String label;
{
  Dimension width,height;

  width  = *new_width;
  height = *new_height;

  if (shape && shape->flags & MONETSHAPE_CONNECTOR && !force_label) {
    /* -- Resize connectors to match state */
    switch (conn) {
    default:
    case connector_big:
      width  = 6;
      height = 6;
      break;
    case connector_invisible:
      width  = 1;
      height = 1;
      break;
    case connector_small:
      width  /= 2;
      height /= 2;
      break;
    }
  } else if (width < 2 || height < 2) {
    width  = 64;
    height = 64;
  } else if (shape && shape->flags & MONETSHAPE_EQUAL_SIDES) {
    if (width > height)
      height = width;
    else
      width = height;
  }
  *new_width  = width;
  *new_height = height;
}

/******************************************************************/
/*  Draw the parts defined by the drawing state  */
/******************************************************************/

static void draw_state (state, border, x, y, width, height)
     MonetShapeState state;
     Position x,y;
     Dimension width,height;
     MonetShade border;
{

  /************************************************************/

  switch (MONETSHAPE_EXTRA1(state)) {
  case extra_left:
    Draw_line(border, x-2,y, (Position)  x-2, (Position) y+height);
    break;
  case extra_double_border:
    Draw_rectangle(border, x-2,y-2,
			(Position) width+4, (Position) height+4);
    Draw_rectangle(border, x-4,y-4,
			(Position) width+8, (Position) height+8);
    break;
  case extra_border:
    Draw_rectangle(border, x-2,y-2,
			(Position) width+4, (Position) height+4);
    break;
  case extra_leftbelow:
    Draw_line(border, x-2,y, (Position)  x-2, (Position) y+height);
    Draw_line(border, x,y+height+2,
		   (Position) x+width, (Position) y+height+2);
    break;
  case extra_highlight:
    Draw_line(border, x-1,y, (Position)  x-1, (Position) y+height);
    Draw_line(border, x,y-1, (Position)  x+width,y-1);
    break;
  case extra_lowlight:
    Draw_line(border,x+width+1,y,
		   (Position) x+width+1, (Position) y+height);
    Draw_line(border, x,y+height+1,
		   (Position) x+width, (Position) y+height+1);
    break;
  default:
    break;
  }

  /************************************************************/
  
  switch (MONETSHAPE_DIAGONAL(state)) {
  default:
    break;
  case diagonal_topright:
    Draw_line(border, x, y + height, (Position) x + width, y);
    break;
  case diagonal_crosstwice:
    Draw_line(border, x, y, (Position)  x + width, (Position)  y + height);
    Draw_line(border, x, (Position)  y + height, (Position)  x + width,  y);
    break;
  case diagonal_topleft:
    Draw_line(border, x, y, (Position)   x + width, (Position)  y + height);
    break;
  }

  switch (MONETSHAPE_EXTRAFLAG(state)) {
  default:
    break;
  case flag_halfmast:
    Draw_line(border, x, y, x - 4, y - 4);
    Draw_line(border, x-5, y-5, x - 5, y - 5);
    break;
  case flag_up:
    Draw_line(border, x, y, x, y - 4);
    Draw_rectangle(border, x-10, y - 10, 10, 5);
    break;
  case flag_down:
    Draw_line(border, x-4, y, x, y);
    Draw_rectangle(border, x-10, y, 5, 10);
    break;
  }
  switch (TOPRIGHT(state)) {
  default:
    break;
  case topright_cross:
    Draw_line(border, (Position)  x+ width, y-8,
		   x + width+10, y);
    Draw_line(border, (Position)  x+ width, y, (Position) 
		   x + width+10, y-8);
    break;
  case topright_U:
    Draw_line(border, (Position) x+ width, y-10, (Position) x + width, y);
    Draw_line(border, (Position) x+ width+10, y-10,
		   (Position) x + width, y+10);
    Draw_line(border, (Position) x+ width, y, (Position) x + width+10, y);
    break;
  case topright_C:
    Draw_line(border, (Position)  x+ width, y-10,
		   (Position)  x + width, y);
    Draw_line(border, (Position)  x+ width, y-10,
		   (Position)  x + width+10, y-10);
    Draw_line(border, (Position)  x+ width, y,
		   (Position)  x + width+10, y);
    break;
  case topright_T:
    Draw_line(border, (Position)  x+ width, y-10,
		   (Position)  x + width+10, y - 10);
    Draw_line(border, (Position)  x+ width+5, y - 8,
		   (Position)  x + width+5, y);
    break;
  case topright_upFlag:
    Draw_line(border, (Position)  x+ width, y, x + width,
		   (Position)  y - 4);
    Draw_rectangle(border, x+ width, y - 10, 10, 5);
    break;
  case topright_downFlag:
    Draw_line(border, x+ width, y, (Position)  x + width+4, y);
    Draw_rectangle(border, (Position)  x+ width+5, y, 5, 10);
    break;
  case topright_P:
    Draw_line(border, (Position)  x+ width + 1, y - 1,
		   x + width + 1, y - 3);
    Draw_rectangle(border, (Position)  x+ width + 1, y - 10, 8, 5);
    break;
  }
}

/******************************************************************/
/*  Draw the shape  */
/******************************************************************/

static void draw_shape (shape, text, border, inside)
     MonetShade border, text, inside;
     MonetShape shape;
{
  Position cx,cy;
  unsigned i;
  cx = 0;
  cy = 0;  /* current cursor position */

  if (border == inside && !Draw_is_xor ()) {
    border = MonetShade_inverse (inside);
  }

  for (i = 0; i < shape->number_of_commands; ++i) {
    Position px,py;
    DrawType type;
    MonetBool significant;

    type = shape->commands[i].type;
    py = shape->commands[i].y;
    px = shape->commands[i].x;

    switch (type) {
    case s_elipse:
      Draw_elipse (border, cx, cy, (Dimension) px, (Dimension) py);
      break;
    case s_rectangle:
      Draw_rectangle (border, cx, cy, (Dimension) px, (Dimension) py);
      break;
    case s_fill_elipse:
      Draw_fill_elipse (border, cx, cy, (Dimension) px, (Dimension) py);
      break;
    case s_fill_rectangle:
      Draw_fill_rectangle (border, cx, cy, (Dimension) px, (Dimension) py);
      break;
    case s_move:
    case s_line:
      /*  Do not draw very short lines, draw them as one long one,
	  this is a hack to get rid of problems when doing xor drawing.  */
      for (;;) {
	if (type == s_move) {
	  cy = py;
	  cx = px;
	  significant = True;
	} else if (Draw_significant_line (border, cx, cy, px, py)) {
	  cy = py;
	  cx = px;
	  significant = True;
	} else {
	  significant = False;
	}
	if (i+1 == shape->number_of_commands)
	  break;
	type = shape->commands[i+1].type;

	if (type != s_line || type != s_move) {
	  break;
	}
	++i;
	py = shape->commands[i].y;
	px = shape->commands[i].x;
      }
      if (! significant) {
	Draw_line (border, cx, cy, px, py);
      }
      break;
    case s_thin:
      MonetPrintfError ("s_thin: Not implemented yet");
      break;
    case s_thick:
      MonetPrintfError ("s_thick: Not implemented yet");
      break;
    case s_solid:
      MonetPrintfError ("s_solid: Not implemented yet");
      break;
    case s_dotted:
      MonetPrintfError ("s_dotted: Not implemented yet");
      break;
    case s_text:
      Draw_string(text, cx, cy, (Dimension) px, (Dimension) py ,
		       shape->commands[i].text,
		       shape->commands[i].text_len);
      break;
    }
  }
}

/******************************************************************/
/*  Do the label  and shape  */
/******************************************************************/

static void draw_label (x, y, lw, lh, split, text, inside,
			     label, labellen, reverse)
     char * label;
     Position x, y;
     Dimension lw, lh;
     int split, labellen;
     MonetBool reverse;
     MonetShade text, inside;
{
  if (Draw_is_xor ()) {
    if (inside == shade_grey) {
      text = inside;  /* !!! This is a hack for xmonet/draw.c  */
    }
  } else if (text == inside) {
    text =  MonetShade_inverse (inside);
  }
  if (label) {
    if (split > 0) {
      int h, w;

      h = lh/2- 2 ;

      w = (lw * split);
      w = w / labellen -2;
      if ( h > 0 && w > 0) {
	if (reverse) {
	  Draw_boxed_string(text, x + 1, y + 1, lw, h, label, split);
	} else {
	  Draw_string(text, x + 1, y + 1, lw, h, label, split);
	}
	if (reverse) {
	  Draw_boxed_string(text, x + 1, y + 2 + lh/2, lw, h,
			    label+split, labellen - split);
	} else {
	  Draw_string(text, x + 1, y + 2 + lh/2, lw, h,
		      label+split, labellen - split);
	}
      }
    } else if ( lw > 2 && lh > 2) {
      if (reverse) {
	Draw_boxed_string(text, x + 1, y + 1, lw -2 , lh -2,
			  label, labellen);
      } else {
	Draw_string(text, x + 1, y + 1, lw -2 , lh -2,
			 label, labellen);
      }
    }
  }
}

/* -- Searches for a convenient place to split a label.  Returns this
   -- position in 'split'.  If 'split' is negative it means truncate
   -- the label at this position - this is used in a last resort if
   -- it will not fit in the space provided.
   */
static MonetBool split_label (label, lw, lh, rw, rh, min_w, labellen, split)
     String label;
     Dimension *lw, *lh, rw, rh, min_w;
     int labellen, *split;
{
  *split = 0;

  MONETDEBUG(12, ( "shape: label [%s] min_w %d lw/lh[%d,%d]",
	      label, min_w, *lw, *lh));

  if (rw >= min_w && *lw <= rw && rh >= *lh) {
    *lw = rw;
    *lh = rh;
    MONETDEBUG(12, ( "shape: *lw < rw %d [%d,%d] [%d,%d]",
		min_w, rw, rh, *lw, *lh));
  } else if (rw >= min_w && rh >= *lh) {
    *lw = rw;
    *lh = rh;
    MONETDEBUG(12, ( "shape: rw > min_w %d [%d,%d] [%d,%d]",
		min_w, rw, rh, *lw, *lh));
  } else if (rh > *lh * 2 + 2) {
    unsigned c;
    MonetBool okay = True;

    for (c = 0; c < labellen; ++c) {
      char i = label[c];
      if ((WHITESPACE(i) || i == '.') && c > labellen / 3) {
	Dimension w_taken;
	/*  Work out length left */
	w_taken = min_w * c;
	w_taken /= labellen;
	if (w_taken >= rw) {
	  /*  Space taken too large  */
	  if (*split) {
	    /*  If we already have something that fits and anything
		larger would break.  */
	    break;
	  }
	  /*  Too little space so fail  */
	  *split = c;
	  okay = False;
	  break;
	}
	*split = c;
	if (min_w < w_taken) {
	  /*  No space left to do the rest of the string so finish  */
	  okay = False;
	  break;
	}
      }
    }
    *lw = rw;
    *lh = rh;
    MONETDEBUG(12, ( "shape: split %d %d [%d,%d] [%d,%d]",
		*split, min_w, rw, rh, *lw, *lh));
    if (*split == 0)
      return False;
    if (! okay) {
      for (c = 1; c < labellen; ++c) {
	char i = label[c];
	if (WHITESPACE(i) || i == '.') {
	  *split = -c;
	  break;
	}
      }
    }
    return okay;
  } else {
    unsigned c;

    /* -- Okay the split failed so lets just use part of the label
       -- ignore anything at the end of the label.  */
    for (c = 1; c < labellen; ++c) {
      char i = label[c];
      if (WHITESPACE(i) || i == '.') {
	*split = -c;
	break;
      }
    }
    *lw = rw;
    *lh = rh;
    MONETDEBUG(12, ( "shape: Split Failed %d [%d,%d] [%d,%d]",
		min_w, rw, rh, *lw, *lh));
    return False;
  }

  return True;
}

/*****************************************************************
  Work out the label
  First see if it all fits in the space given, if not
  See if it will fit in the whole space, if not
  Check to see if short form (split) fits in space given, if not
  just return split form for whole space.
  *****************************************************************/

static void get_split_label (label, width, height,
			     io_lx, io_ly, io_lw, io_lh,
			     rw, rh, min_w, labellen, label_height, io_split)
     String label;
     Position *io_lx, *io_ly;
     Dimension *io_lw, *io_lh, *rw, *rh, min_w, width, height;
     int labellen, *io_split;
{
  int split;
  Dimension lw, lh;

  split = 0;
  lw = *io_lw;
  lh = *io_lh;

  if (! split_label (label, &lw, &lh, *rw, *rh, min_w, labellen, &split)) {
    int split_2 = 0;
    Dimension lw_2, lh_2;
    lw_2 = lw;
    lh_2 = label_height;
    MONETDEBUG(12, ( "All failed split in full box"));
    if (split_label (label, &lw_2, &lh_2, width, height,
		     min_w, labellen, &split_2)) {
      *io_lx = 0;
      *io_ly = 0;
      *rw = width;
      *rh = height;
      split = split_2;
      lw = lw_2;
      lh = lh_2;
    } else {
      int split_3 = 0;
      lw_2 = lw;
      lh_2 = lh;
#ifdef ahjkdjkdasjdjk
      if (split_label (label, &lw_2, &lh_2, *rw, *rh,
		       min_w, abs(split), &split_3)) {
	/* -- First part of Split fits so use it.  */
	split = -abs(split);
	lw = lw_2;
	lh = lh_2;
      } else {
	*io_lx = 0;
	*io_ly = 0;
	*rw = width;
	*rh = height;
	split = split_2;
      }
#endif
    }
  }
  *io_lw = lw;
  *io_lh = lh;
  *io_split = split;
}

/******************************************************************/
/*  Do the label and shape  */
/******************************************************************/

static void do_label (x, y, width, height, label, labellen,
		      flags, shape,
		      text, inside, border, reverse)
     Position x,y;
     char * label;
     MonetBool reverse;
     Dimension width, height;
     MonetShape shape;
     int flags, labellen;
     MonetShade text, border, inside;
{
  Position lx, ly;
  Dimension lw, lh, label_height;
  int split = 0;
/*
  if (width == 0 || height == 0)
    return;
*/

  lw = DrawCharWidth * labellen;
  lh = DrawCharHeight;
  label_height = lh;

  if (flags & (MONETSHAPE_NO_PICTURE | MONETSHAPE_NO_LABEL)) {
    /*  No shape, force label to be drawn by itself */
    lx = 0;
    ly = 0;
    (void) split_label (label, &lw, &lh, width,height, lw, labellen, &split);
  } else {
    /*  Find geometry of shape and labels  */
    Dimension scale_shape_width;
    Dimension scale_shape_height;

    if (flags & (MONETSHAPE_NO_LABEL | MONETSHAPE_LABEL_OUTSIDE)) {
      scale_shape_width  = MONETMIN(width, height);
      scale_shape_height = MONETMIN(width, height);
      label = NULL;
      /*  Do not bother with drawing a label  */
    } else {
      Dimension min_w, min_h, rw, rh;
/*
      min_w = lw / 2;
      min_h = lh / 2;
*/
      min_w = lw;
      min_h = lh;
      if (width > height && width - height >= height) {
	/* -- very wide  */
	rw = width - height;
	rh = height;
	lx = height;
	ly = 0;
	scale_shape_width  = height;
	scale_shape_height = height;
      } else if (height / 2 < min_h) {
	/*  -- Not high enough to do anything with  */
	lx = 0;
	ly = 0;
	rw = width;
	rh = height;
      } else if (height / 2 >= width) {
	/*  -- Very tall  */
	rh = height - width;
	rw = width;
	lx = 0;
	ly = width;
	scale_shape_width  = width;
	scale_shape_height = width;
      } else if (height > min_h * 2) {
	/*  Not wide enough to put label along side, so put it below */
	rh = height / 2;
	rw = width;
	lx = 0;
	ly = height /2;
	scale_shape_width  = height /2;
	scale_shape_height = height /2;
      } else {
	/*  -- Not so tall, so squash the shape up a bit  */
	rh = width;
	rw = width;
	lx = 0;
	ly = height - width;
	scale_shape_width  = height - width;
	scale_shape_height = height - width;
      }

      get_split_label (label, width, height,
		       &lx, &ly, &lw, &lh, &rw, &rh, min_w,
		       labellen, label_height, &split);
    }

    /************************************************************/
    /*  Draw the shape in the top left corner */
    /************************************************************/

    if (ly > 0 || lx > 0) {
      /*  Do scaling */
      MONETDEBUG(12, ( "Shape_draw, box: %d %d %u %u %u %u",
		  x,y,
		  (unsigned) shape->width, (unsigned) shape->height,
		  (unsigned) scale_shape_width,
		  (unsigned) scale_shape_height));
      Draw_set_box(x, y, shape->width, shape->height,
		   scale_shape_width, scale_shape_height);
      draw_shape (shape, text, border, inside);
      /* reset scaling  */
      Draw_reset_box();
    }
  }
  if (label) {
    MONETDEBUG(12, ( "Label [%s]:[%d], split [%d]  lw,lh [%d,%d]",
		label, labellen, split, lw, lh));
    if (split < 0) {
      labellen = - split;
      split = 0;
    }
    draw_label (x+lx, y+ly, lw,lh, split,text,inside,label, labellen, reverse);
  }
  MONETDEBUG(12, ( "Shape_draw, label: %d %d %u %u [%s]",
		 (int) lx, (int) ly, (unsigned) lw, (unsigned) lh,
		 label));
}


/******************************************************************/
/*  Draw a small label of to the side  */
/******************************************************************/

static void draw_sub_label (shade, x, y, label, len, num, denum)
     MonetShade shade;
     Position x,y;
     char * label;
     int len, num, denum;
{
  Dimension w, h;

  w = DrawCharWidth * len;
  h = DrawCharHeight;

  if (num < denum && num * 4 >= denum) {
    if (denum > 0 && num > 0) {
      w *= denum;
      w /= num;
      h *= denum;
      h /= num;
    }
  }
  Draw_string(shade, x, y, w+2, h+2,label, len);
}

/******************************************************************/
/*  Draw a basic MonetShape  */
/******************************************************************/

extern void MonetShape_draw (shape, x,y,width,height, state, force_label,
			     label, labellen, label_2)
     MonetShape shape;
     Position x,y;
     Dimension width,height;
     MonetBool force_label;
     MonetShapeState state;
     String label, label_2;
     int labellen;
{
  int flags;
  MonetShade border, text, inside;
  Dimension rwidth, rheight;
  Position rx,ry, x_label, y_label;
  Dimension w_label, h_label;

  MONETDEBUG(12, ( "Shape_draw ---: %d %d %u %u [%s]",
		 (int) x, (int) y, (unsigned) width, (unsigned) height,
		 label));


  rwidth = width;
  rheight = height;
  rx = x;
  ry = y;

  MonetDraw_adjust_for_scale (&x, &y, &width, &height);
  if (width == 0 || height == 0)
    return;
  Draw_set_box(rx, ry, width, height, rwidth, rheight);
  x = 0;
  y = 0;

  w_label = width;
  h_label = height ;
  x_label = x;
  y_label = y;

  MONETDEBUG(100, ( "Adjusted: %d %d %d %d", x,y,width, height));
  if (shape)
    flags = shape -> flags;
  else
    flags = MONETSHAPE_NO_PICTURE;

  if (label == NULL) {
    flags |= MONETSHAPE_NO_LABEL;
    label = "";
  } else if (force_label && (flags  & MONETSHAPE_NO_LABEL)) {
    flags -= MONETSHAPE_NO_LABEL;
  }
  if (state & MONETSTATE_NO_BORDER)
    flags |= MONETSHAPE_NO_BORDER;
  if (state & MONETSTATE_NO_LABEL)
    flags |= MONETSHAPE_NO_LABEL;
  if (state & MONETSTATE_NO_PICTURE)
    flags |= MONETSHAPE_NO_PICTURE;

  /************************************************************/
  /*  Set up shade/BORDER and geometry of drawing             */
  /*  What BORDERs/shade to use  */
  /************************************************************/

  switch (BORDER(state)) {
  case border_backing:
    border = shade_background;
    break;
  default:
  case border_normal:
    border = shade_dark;
    break;
  case border_grey:
    border = shade_grey;
    break;
  }

  switch (INSIDE(state)) {
  default:
  case inside_backing:
    inside = shade_background;
    break;
  case inside_normal:
    inside = shade_dark;
    break;
  case inside_grey:
    inside = shade_grey;
    break;
  }
  text   = shade_dark;


  if (flags & (MONETSHAPE_REVERSE | REVERSE(state))) {
    Draw_set_reverse ();
  }

  if (Draw_in_region (x,y,width,height)) {
    /* -- don't bother drawing anything unless actually in the region */
    Position  inner;

    /**********************************************************************/
    /*  Drawn with a border  */
    /**********************************************************************/

    if (flags & MONETSHAPE_NO_BORDER) {
      inner = 0;
    } else {
      if (flags & MONETSHAPE_LABEL_BORDER) {
	inner = 2;
      } else {
	inner = 1;
      }
      if (state & MONETSTATE_ROUND_BORDER) {
	MONETDEBUG(12, ( "Elipse draw box"));
	Draw_box_elipse (border, inside, x, y, width, height, inner);
	w_label = width*3   / 4;
	h_label = height*3  / 4;
	x_label = x + w_label / 8;
	y_label = y + h_label / 8;
      } else {
	Draw_box (border, inside, x, y, width, height, inner);
      }
    }

    /**********************************************************************/
    /*  Work out positions of labels and shapes                      */
    /*  I don't care what anyone else thinks of functional if,            */
    /*  never used one outside a macro before.                            */
    /**********************************************************************/

    if (w_label > inner*2 && h_label > inner * 2)
      do_label (x_label+inner, y_label+inner, w_label-inner*2, h_label-inner*2,
		label, labellen, flags, shape, text, inside, border,
		NAME_REVERSE(state) ? True : False);

  }

  Draw_reset_box ();

  /************************************************************/
  /*  Draw the secondary label in the bottom right  */
  /************************************************************/

  if (label_2) {
    draw_sub_label (text, rx + rwidth, ry + rheight,
		    label_2, strlen (label_2), width, rwidth);
  }

  /************************************************************/
  /*  Draw label outside on top right  */
  /************************************************************/

  if (!force_label && (flags & MONETSHAPE_LABEL_OUTSIDE)) {
    draw_sub_label (text, rx + rwidth, ry - DrawCharHeight,
		    label, labellen, width, rwidth);
  }

  /************************************************************/
  /*  Reverse video  */
  /************************************************************/

  if (flags & (MONETSHAPE_REVERSE | REVERSE(state))) {
    Draw_set_reverse ();
  }

  /************************************************************/
  /*  State is stuff not specific to the shape itself, rather */
  /*  a set of extras.  */
  /************************************************************/

  draw_state (state, border, rx, ry, rwidth, rheight);

}

/******************************************************************/
/******************************************************************/
/*  Create and register MonetShapes */
/******************************************************************/
/******************************************************************/

extern ConnectorState String2ConnectorState (string)
	String string;
{
  if (EQS(string, "big"))
    return connector_big;
  else if (EQS(string, "small"))
    return connector_small;
  else if (EQS(string, "invisible"))
    return connector_invisible;

  return connector_default;
}

extern String ConnectorState2String (state)
     ConnectorState state;
{
  switch (state) {
  case connector_small:
    return "small";
  case connector_invisible:
    return "invisible";
  case connector_big:
  default:
    return "big";
  }
  /* NOTREACHED */
}


/**********************************************************************/
/*  Draw all shapes  */
/**********************************************************************/

extern void MonetShape_draw_all ()
{
  MonetShape shape;
  Position x = 10, y = 10;
  FORALL (shape, MonetShapeTable, next) {
      MonetShape_draw (shape,
		       x, y, shape->width, shape->height,
		       0,False, NULSTR, 0, NULSTR);
      y += shape->height;
  }
}

/**********************************************************************/
/*  Lists all shapes  */
/**********************************************************************/

MONETCALLBACK(do_help_shapes)
     MonetShape shape;

     MonetPrintfnl ("Available MonetShapes");
     FORALL (shape, MonetShapeTable, next) {
       MonetPrintf ("\t%s: default width %u height %u, %d commands",
		    shape->name,
		    shape->width,
		    shape->height,
		    shape->number_of_commands);
       if ( shape->flags & MONETSHAPE_CONNECTOR) {
	 MonetPrintf (" connector");
       }
       if ( shape->flags & MONETSHAPE_IS_NET) {
	 MonetPrintf (" network");
       }
       if (shape->flags & MONETSHAPE_NOT_RESIZABLE) {
	 MonetPrintf (" noresize");
       }
       if (shape->flags & MONETSHAPE_LABEL_BORDER) {
	 MonetPrintf (" labelborder");
       }
       if (shape->flags & MONETSHAPE_EQUAL_SIDES) {
	 MonetPrintf (" equalsides");
       }
       if (shape->flags & MONETSHAPE_NO_BORDER) {
	 MonetPrintf (" noborder");
       }
       if (shape->flags & MONETSHAPE_REVERSE) {
	 MonetPrintf (" reverse");
       }
       if (shape->flags & MONETSHAPE_NO_LABEL) {
	 MonetPrintf (" nolabel");
       }
       if (shape->flags & MONETSHAPE_NO_PICTURE) {
	 MonetPrintf (" nopicture");
       }
       if (shape->flags & MONETSHAPE_NOT_BENDING) {
	 MonetPrintf (" nobend");
       }
       if (shape->flags & MONETSHAPE_LABEL_OUTSIDE) {
	 MonetPrintf (" outsidelabel");
       }
       MonetPrintfnl ("");
     }
MONETEND


extern MonetBool MonetShape_bending (shape)
     MonetShape shape;
{
  if (shape && (shape->flags & MONETSHAPE_NOT_BENDING)) {
    return False;
  }
  return True;
}

extern void MonetShape_reset (shape)
     MonetShape shape;
{
  unsigned i;
  for (i = 0; i < shape->number_of_commands; ++ i) {
    if (shape->commands[i].type == s_text) {
      MonetFree (shape->commands[i].text);
    }
  }
  shape->flags = 0;
  shape->number_of_commands = 0;
}

extern void MonetShape_free (shape)
     MonetShape shape;
{
  if (shape) {
    if (shape == CurrentShape)
      CurrentShape = NULL;
    MonetShape_reset (shape);
    LIST_DEL(MonetShape, shape, MonetShapeTable, next);
    MonetFree (shape);
  }
}

MONETCALLBACK(do_new_shape)
     MonetShape shape;
     unsigned i, c_arg;

     if (shape = String2MonetShape (argv[1])) {
       /*   Already exists  */
       MonetShape_reset (shape);
     } else {
       shape = MonetNew (struct monet_shape);
       shape -> width  = 64;
       shape -> height = 64;
       shape->name = MonetNewString (argv[1]);
       LIST_ADD (shape, MonetShapeTable, next);
       shape->flags = 0;
       shape->number_of_commands = 0;
     }
  
     for (i = 0, c_arg = 2; c_arg < argc; ++c_arg) {
       String action, a1, a2, a3;

       if (i >= MAXCOMMANDS) {
	 MonetPrintfError ("Too many shape commands %d, max is %d",
			   i, MAXCOMMANDS);
	 break;
       }

       action = argv[c_arg];
       a1 = argv[c_arg+1];
       a2 = argv[c_arg+2];
       a3 = argv[c_arg+3];
       if (EQS(action,  "elipse")) {
	 shape->commands[i].type = s_elipse;
	 shape->commands[i].x = MonetString2int(a1);
	 shape->commands[i].y = MonetString2int(a2);
	 c_arg += 2;
	 ++i;
       } else if (EQS(action,  "fillelipse")) {
	 shape->commands[i].type = s_fill_elipse;
	 shape->commands[i].x = MonetString2int(a1);
	 shape->commands[i].y = MonetString2int(a2);
	 c_arg += 2;
	 ++i;
       } else if (EQS(action,  "rectangle")) {
	 shape->commands[i].type = s_rectangle;
	 shape->commands[i].x = MonetString2int(a1);
	 shape->commands[i].y = MonetString2int(a2);
	 c_arg += 2;
	 ++i;
       } else if (EQS(action,  "fillrectangle")) {
	 shape->commands[i].type = s_fill_rectangle;
	 shape->commands[i].x = MonetString2int(a1);
	 shape->commands[i].y = MonetString2int(a2);
	 c_arg += 2;
	 ++i;
       } else if (EQS(action,  "line")) {
	 shape->commands[i].type = s_line;
	 shape->commands[i].x = MonetString2int(a1);
	 shape->commands[i].y = MonetString2int(a2);
	 c_arg += 2;
	 ++i;
       } else if (EQS(action,  "move")) {
	 shape->commands[i].type = s_move;
	 shape->commands[i].x = MonetString2int(a1);
	 shape->commands[i].y = MonetString2int(a2);
	 c_arg += 2;
	 ++i;
       } else if (EQS(action,  "thick")) {
	 ++i;
	 shape->commands[i].type = s_thick;
       } else if (EQS(action,  "thin")) {
	 shape->commands[i].type = s_thin;
	 ++i;
       }
       else if (EQS(action,  "solid")) {
	 shape->commands[i].type = s_solid;
	 ++i;
       }
       else if (EQS(action,  "dotted")) {
	 shape->commands[i].type = s_dotted;
	 ++i;
       } else if (EQS(action,  "text")) {
	 shape->commands[i].type = s_text;
	 shape->commands[i].text_len = MonetStrlen (a3);
	 shape->commands[i].x = MonetString2int(a1);
	 shape->commands[i].y = MonetString2int(a2);
	 shape->commands[i].text = MonetNewString(a3);
	 c_arg += 3;
	 ++i;
       } else if (EQS(action,  "size")) {
	 shape->width = MonetString2int(a1);
	 shape->height= MonetString2int(a2);
	 c_arg += 2;
       } else if (EQS(action,  "connector")) {
	 shape->flags |= MONETSHAPE_CONNECTOR;
       } else if (EQS(action,  "noresize")) {
	 shape->flags |= MONETSHAPE_LABEL_BORDER;
       } else if (EQS(action,  "labelborder"))
	 shape->flags |= MONETSHAPE_LABEL_BORDER;
       else if (EQS(action,  "equalsides"))
	 shape->flags |= MONETSHAPE_EQUAL_SIDES;
       else if (EQS(action,  "noborder"))
	 shape->flags |= MONETSHAPE_NO_BORDER;
       else if (EQS(action,  "nopicture"))
	 shape->flags |= MONETSHAPE_NO_PICTURE;
       else if (EQS(action,  "reverse"))
	 shape->flags |= MONETSHAPE_REVERSE;
       else if (EQS(action,  "nolabel"))
	 shape->flags |= MONETSHAPE_NO_LABEL;
       else if (EQS(action,  "nobend"))
	 shape->flags |= MONETSHAPE_NOT_BENDING;
       else if (EQS(action,  "outsidelabel"))
	 shape->flags |= MONETSHAPE_LABEL_OUTSIDE;
       else if (EQS(action,  "network"))
	 shape->flags |= MONETSHAPE_IS_NET;
       else {
	 MonetPrintfError ("No such shape command [%s]", action);
       }
     }

     if (shape->width == 0 || shape->height == 0) {
       MonetPrintfError ("Shape [%s] size is zero", shape->name);
       shape->width = 64;
       shape->height = 64;
     }
     shape->number_of_commands = i;

     /*  If one of internal dimensions is negative then change the
	 coordinates inside and make the internal dimensions positive
	 */
     if (shape->width < 0) {
       unsigned i;
       shape->width = - shape->width;
       for (i = 0; i < shape->number_of_commands; ++i) {
	 shape->commands[i].x = shape->width - shape->commands[i].x;
       }
     }
     if (shape->height < 0) {
       unsigned i;
       shape->height = - shape->height;
       for (i = 0; i < shape->number_of_commands; ++i) {
	 shape->commands[i].y = shape->height - shape->commands[i].y;
       }
     }
MONETEND


/* -----------
MONETCALLBACK(do_command)
     MonetShape shape;
     String action, a1, a2, a3;
     int i;

     if (CurrentShape == NULL) {
       MonetPrintfError ("No current Shape");
       RETURNSC;
     }
     shape = CurrentShape;

     i = shape->number_of_commands;

     if (i == MAXCOMMANDS) {
       MonetPrintfError ("Too many shape commands %d, max is %d",
			 i, MAXCOMMANDS);
     }

     action = argv[0];
     a1 = argv[1];
     a2 = argv[2];
     a3 = argv[3];

     if (EQS(action,  "elipse")) {
       shape->commands[i].type = s_elipse;
       shape->commands[i].x = MonetString2int(a1);
       shape->commands[i].y = MonetString2int(a2);
       ++ shape->number_of_commands;
     } else if (EQS(action,  "fillelipse")) {
       shape->commands[i].type = s_fill_elipse;
       shape->commands[i].x = MonetString2int(a1);
       shape->commands[i].y = MonetString2int(a2);
       ++ shape->number_of_commands;
     } else if (EQS(action,  "rectangle")) {
       shape->commands[i].type = s_rectangle;
       shape->commands[i].x = MonetString2int(a1);
       shape->commands[i].y = MonetString2int(a2);
       ++ shape->number_of_commands;
     } else if (EQS(action,  "fillrectangle")) {
       shape->commands[i].type = s_fill_rectangle;
       shape->commands[i].x = MonetString2int(a1);
       shape->commands[i].y = MonetString2int(a2);
       ++ shape->number_of_commands;
     } else if (EQS(action,  "line")) {
       shape->commands[i].type = s_line;
       shape->commands[i].x = MonetString2int(a1);
       shape->commands[i].y = MonetString2int(a2);
       ++ shape->number_of_commands;
     } else if (EQS(action,  "move")) {
       shape->commands[i].type = s_move;
       shape->commands[i].x = MonetString2int(a1);
       shape->commands[i].y = MonetString2int(a2);
       ++ shape->number_of_commands;
     } else if (EQS(action,  "thick")) {
       shape->commands[i].type = s_thick;
       ++ shape->number_of_commands;
     } else if (EQS(action,  "thin")) {
       shape->commands[i].type = s_thin;
       ++ shape->number_of_commands;
     } else if (EQS(action,  "solid")) {
       shape->commands[i].type = s_solid;
       ++ shape->number_of_commands;
     } else if (EQS(action,  "dotted")) {
       shape->commands[i].type = s_dotted;
       ++ shape->number_of_commands;
     } else if (EQS(action,  "text")) {
       shape->commands[i].type = s_text;
       shape->commands[i].text_len = MonetStrlen (a3);
       shape->commands[i].x = MonetString2int(a1);
       shape->commands[i].y = MonetString2int(a2);
       shape->commands[i].text = MonetNewString(a3);
       ++ shape->number_of_commands;
     } else if (EQS(action,  "size")) {
       shape->width = MonetString2int(a1);
       shape->height= MonetString2int(a2);
     } else if (EQS(action,  "connector")) {
       shape->flags |= MONETSHAPE_CONNECTOR;
     } else if (EQS(action,  "noresize")) {
       shape->flags |= MONETSHAPE_LABEL_BORDER;
     } else if (EQS(action,  "labelborder")) {
       shape->flags |= MONETSHAPE_LABEL_BORDER;
     } else if (EQS(action,  "equalsides")) {
       shape->flags |= MONETSHAPE_EQUAL_SIDES;
     } else if (EQS(action,  "noborder")) {
       shape->flags |= MONETSHAPE_NO_BORDER;
     } else if (EQS(action,  "nopicture")) {
       shape->flags |= MONETSHAPE_NO_PICTURE;
     } else if (EQS(action,  "reverse")) {
       shape->flags |= MONETSHAPE_REVERSE;
     } else if (EQS(action,  "nolabel")) {
       shape->flags |= MONETSHAPE_NO_LABEL;
     } else if (EQS(action,  "nobend")) {
       shape->flags |= MONETSHAPE_NOT_BENDING;
     } else if (EQS(action,  "outsidelabel")) {
       shape->flags |= MONETSHAPE_LABEL_OUTSIDE;
     } else if (EQS(action,  "network")) {
       shape->flags |= MONETSHAPE_IS_NET;
     } else {
       MonetPrintfError ("No such shape command [%s]", action);
     }
MONETEND
------------ */


MONETCALLBACK(do_last)
     MonetShape shape;

     if (CurrentShape == NULL) {
       MonetPrintfError ("No current Shape");
       RETURNSC;
     }
     shape = CurrentShape;
     if (shape->width == 0 || shape->height == 0) {
       MonetPrintfError ("Shape [%s] size is zero", shape->name);
       shape->width = 64;
       shape->height = 64;
     }

     /*  If one of internal dimensions is negative then change the
	 coordinates inside and make the internal dimensions positive
	 */
     if (shape->width < 0) {
       unsigned i;
       shape->width = - shape->width;
       for (i = 0; i < shape->number_of_commands; ++i) {
	 shape->commands[i].x = shape->width - shape->commands[i].x;
       }
     }
     if (shape->height < 0) {
       unsigned i;
       shape->height = - shape->height;
       for (i = 0; i < shape->number_of_commands; ++i) {
	 shape->commands[i].y = shape->height - shape->commands[i].y;
       }
     }
MONETEND
	 
/**********************************************************************/
/*  Set default connector size  */
/**********************************************************************/

MONETCALLBACK(do_default_connector)
     connector_default = String2ConnectorState (argv[1]);
MONETEND

/**********************************************************************/
/*  Init and finish  */
/**********************************************************************/

static MonetBool Init = False;
extern void MonetShape_init ()
{
  if (Init)
    return;

  MonetShapeTable = NULL;

  (void) MonetMember_module_class ("shape");
  MonetMember_create ( "help",		do_help_shapes,
		      "",
		      "list defined shapes");
  MonetMember_create ( "connector-size",		do_default_connector,
		      "big|small|invisible",
		      "Sets the default connector size");
  MonetMember_create ( "create",		do_new_shape,
		      "name ..." ,
		      "Create a new shape.");
  MonetMember_create ("help-state", do_help_shape_states,
		      "",
		      "Lists names of drawing states");

  Init = True;
  connector_default = connector_big;
}

extern void MonetShape_finish ()
{
  if ( ! Init)
    return;

  Init = False;
  while (MonetShapeTable)
    MonetShape_free (MonetShapeTable);
}

/******************************************************************/
/******************************************************************/
/* $Header: //gaia/group.local/computer/monet/lib/draw/RCS/MonetShape.c,v 1.2 1991/05/30 14:59:39 a38 Exp a38 $ */
/******************************************************************/
/******************************************************************/
