/******************************************************************/
/******************************************************************/
/* $Header: //gaia/group.local/computer/monet/Draw/RCS/text.c,v 1.1 1991/03/26 10:52:24 a38 Exp a38 $ */
/******************************************************************/
/******************************************************************/

#include <monet/msh/General.h>
#include <monet/draw/Draw.h>

/******************************************************************/
/******************************************************************/

static DrawLibrary TextLib;

static FILE * DumpFile = NULL;

/******************************************************************/
/******************************************************************/

static char * shade2string (shade)
	MonetShade shade;
{
	char buffer [31];

	(void) sprintf (buffer, "shade%u", shade);
	return buffer;
}

/******************************************************************/
/* Before draing anything on a particular map, this routine must */
/* be called */
/******************************************************************/

extern MonetBool Draw_start_text (title)
     String title;
{
  char filename [1024]; /* !!! */



  (void) sprintf (filename, "%s.txt", title);
  DumpFile = fopen (filename, "w");
  if (DumpFile == NULL) {
    MonetPrintfError ("Could not open file [%s]", filename);
    return False;
  } else {
    MonetPrintfInform ("Dumping 'text' format map to file [%s]", filename);
  }
  Draw_start_draw (TextLib, 0,0, 1.0, 1.0);
  return True;
}

static void end_draw ()
{
  fclose (DumpFile);
}

static void 
draw_percentage_line (shade,  x, y, xl, yl, xr, yr)
	Position        xl, yl, xr, yr, x,y;
	MonetShade shade;
{

  (void) fprintf (DumpFile, "draw_percentage_line %s  %d %d %d %d %d %d",
	   shade2string (shade), xl,yl, x,y, xr,yr);
  (void) fprintf (DumpFile, "\n");
}

static void 
draw_line (shade,  xl, yl, xr, yr)
	Position        xl, yl, xr, yr;
	MonetShade shade;
{
	(void) fprintf (DumpFile, "draw_line %s %d %d %d %d",
		 shade2string (shade), xl,yl, xr,yr);
	(void) fprintf (DumpFile, "\n");
}

static void 
fill_elipse (shade, x, y, width, height)
	MonetShade shade;
	Position        x, y;
	Dimension       width, height;
{
	(void) fprintf (DumpFile, "fill_elipse %s %d %d %u %u\n",
		 shade2string (shade), x,y, width, height);
}

static void 
draw_elipse (shade, x, y, width, height)
	MonetShade shade;
	Position        x, y;
	Dimension       width, height;
{
	(void) fprintf (DumpFile, "draw_elipse %s %d %d %u %u\n",
		 shade2string (shade), x,y, width, height);
}


static void draw_rectangle (shade, x, y, width, height)
	MonetShade shade;
	Position        x, y;
	Dimension       width, height;
{
	(void) fprintf (DumpFile, "draw_rectangle %s %d %d %u %u\n",
		 shade2string (shade), x,y, width, height);
}

static void draw_roundedRectangle (shade, x, y, width, height)
     MonetShade shade;
     Position        x, y;
     Dimension       width, height;
{
  (void) fprintf (DumpFile, "draw_rounded_rectangle %s %d %d %u %u\n",
	   shade2string (shade), x,y, width, height);
}

static void fill_roundedRectangle (shade, x, y, width, height)
     MonetShade shade;
     Position        x, y;
     Dimension       width, height;
{
  (void) fprintf (DumpFile, "fill_rounded_rectangle %s %d %d %u %u\n",
       shade2string (shade), x,y, width, height);
}

static void fill_rectangle (shade, x, y, width, height)
     MonetShade shade;
     Position        x, y;
     Dimension       width, height;
{
  (void) fprintf (DumpFile, "fill_rectangle %s %d %d %u %u\n",
       shade2string (shade), x,y, width, height);
}

static void draw_string (shade, x, y, w, h, string, len)
     MonetShade shade;
     Position        x, y;
     String string;
     Dimension w,h;
     unsigned len;
{
  (void) fprintf (DumpFile, "draw_string %s %d %d %d %d (%s:%u)\n",
	   shade2string (shade), x,y, w,h,string, len);
}

static void draw_boxed_string (shade, x, y, w, h, string, len)
     MonetShade shade;
     Position        x, y;
     String string;
     Dimension w,h;
     unsigned len;
{
  (void) fprintf (DumpFile, "draw_boxed_string %s %d %d %d %d (%s:%u)\n",
	   shade2string (shade),
       x,y, w,h,string, len);
}

static void set_scale (x,y)
	float x,y;
{
	(void) fprintf (DumpFile, "set_scale %f %f\n",x,y);
}

static void set_reverse ()
{
	(void) fprintf (DumpFile, "set_reverse\n");
}

static MonetBool in_region (x,y,w,h)
     Position x,y;
     Dimension w,h;
{
  return True;
}

/*****************************************************************/
/* Init and finish drawing of entitys */
/*****************************************************************/

extern void 
Draw_init_text ()
{

	NEWDRAWLIB(TextLib, False);
}

extern void 
Draw_finish_text()
{
	MonetFree (TextLib);
	TextLib = NULL;
}

/******************************************************************/
/******************************************************************/
/* $Header: //gaia/group.local/computer/monet/Draw/RCS/text.c,v 1.1 1991/03/26 10:52:24 a38 Exp a38 $ */
/******************************************************************/
/******************************************************************/

