/******************************************************************/
/******************************************************************/
/*  $Header: //gaia/group.local/computer/monet/lib/map/RCS/draw.c,v 1.1 1991/07/22 11:37:05 a38 Exp a38 $  */
/******************************************************************/
/******************************************************************/

#include <monet/map/Drawing.h>
#include "Interface.h"
#include <monet/draw/Shape.h>
#include "mapP.h"

/************************************************************************/
/*  Globals  */
/************************************************************************/


/*************************************************************************/
/* Class map */
/*************************************************************************/

#define CLASS_X_SPACING 16
#define CLASS_Y_SPACING 5

static Position draw_class(map, entity_class, x,y)
     MonetEntity          entity_class;
     Position        x, y;
     MonetMap map;
{
  Drawing		draw;
  MonetEntity		ce;
  Position        x1, x2, yc;

  if (entity_class == NULL) {
    MonetSysError ("draw_class class is NULL");
    return y;
  }
  draw = Map_insert_drawing_class (map, entity_class);
  if (!draw) {
    MonetSysError ("could not get drawing for class [%s]",
		   MonetEntity_title (entity_class));
    return y;
  }
  X(draw) = x;
  Y(draw) = y;
  Draw_system (draw);
  
  yc = Y(draw) + HEIGHT(draw) / 2;
  if (entity_class != MonetEntityTopClass ())
    Draw_line(shade_dark, X(draw) - 1, yc,
		   X(draw) - CLASS_X_SPACING / 2 + 1, yc);
  if (! MonetEntityList_isEmpty(MonetEntity_subclasses(entity_class))) {
    x1 = X(draw) + WIDTH(draw);
    x2 = x1 + CLASS_X_SPACING / 2;
    Draw_line(shade_dark, x1, yc, x2, yc);
    FOR_ENTITYLIST(ce, MonetEntity_subclasses(entity_class)) {
      Position oldyc;
      y = draw_class(map, ce, x1 + CLASS_X_SPACING, y);
      oldyc = yc;
      yc = y + HEIGHT(ce->drawing) / 2;
      Draw_line(shade_dark, x2, oldyc, x2, yc);
      y += HEIGHT(ce->drawing) + CLASS_Y_SPACING;
    } END_FORLIST;
    y -= HEIGHT(draw) + CLASS_Y_SPACING;	/* !!! Very bad style */
  }
  return (y);
}

extern void MonetMap_draw_classes (map)
     MonetMap map;
{
  (void) draw_class(map, MonetEntityTopClass (), 10, 10);
}

/************************************************************************/
/*  Init and Finish  */
/************************************************************************/

extern void MapDrawClass_init ()
{
}

extern void MapDrawClass_finish ()
{
}

/******************************************************************/
/******************************************************************/
/*  $Header: //gaia/group.local/computer/monet/lib/map/RCS/draw.c,v 1.1 1991/07/22 11:37:05 a38 Exp a38 $  */
/******************************************************************/
/******************************************************************/

