/***********************************************************************/
/***********************************************************************/
/*  $Header: //gaia/group.local/computer/monet/lib/map/RCS/gather.c,v 1.1 1991/06/11 11:26:10 a38 Exp a38 $ */
/***********************************************************************/
/*  For exploring from an ip host  */
/*  !!!  Currently the explore stuff is here and should be in          */
/*  !!!  libgather.                                                    */
/*  !!!  This module is really a bit of a mess.                        */
/*  !!! This will soon be thrown away  */
/*  !!! Okay this is now an ip host explore routine.  It works so I'll  */
/*  !!! leave it as it is instead of writing the monetsh equivilent.   */
/***********************************************************************/

#include <monet/map/Drawing.h>
#include <monet/probe/Probe.h>
#include <monet/map/Interface.h>
#include <sys/param.h>
#include <netdb.h>
#include <netinet/in.h>
#include <sys/socket.h>
#include <sys/errno.h>
extern int h_errno;

static MonetEntity Iphost, Ipnetwork, Ipinterface;

/***********************************************************************/

/***********************************************************************/

#define MAX_GATHER_RESULTS   32
/* !!! This ought to be defined elsewhere */
#define MAX_NAME_LENGTH  MAXHOSTNAMELEN
typedef struct gather_result {
	MonetEntity interfaceClass, systemClass;
	char interface[MAX_NAME_LENGTH], system[MAX_NAME_LENGTH];
} GatherResult;

/***********************************************************************/

/***********************************************************************/

static MonetBool gather_connectedIPSystems (sys, official_name,
					  result_data, result_count)
     int *result_count;
     MonetEntity sys;
     GatherResult **result_data;
     char ** official_name;
{
  static GatherResult result [MAX_GATHER_RESULTS];
  static struct hostent  *host;

  int count = 0;
  int i, j, p[4];
  long address;
  char *a;


  
  if (isdigit ((TITLE(sys))[0]))
    /* !!! This has not been tested */
    host = gethostbyaddr (TITLE(sys), MonetStrlen (TITLE(sys)), AF_INET);
  else
    host = gethostbyname (TITLE(sys));
  if (host == NULL) {
    if (h_errno == HOST_NOT_FOUND) {
      *official_name = NULL;
      return True;
    }
    herror ("");
    return False;
  } else {
    *official_name = host->h_name;
    /*		for (i = 0; host->h_aliases[i] != NULL; i++) {
		printf ("Alias [%s]\n", host->h_aliases[i]);
		}
		*/
    if (host->h_addrtype != AF_INET || host->h_length != 4) {
      MonetSysError ("Address type [%d] length [%d]\n", host -> h_addrtype, host-> h_length);
      return False;
    }
    for (i = 0; host->h_addr_list[i] != NULL; i++) {
      if (i == MAX_GATHER_RESULTS) {
	MonetPrintfWarning("Maximum number of connected systems exceeded [%d]",
			   MAX_GATHER_RESULTS);
	break;
      }
      address = ntohl ( (long) host->h_addr_list[i]);
      a = (char*) address;
      for (j=0; j<4; j++) {
	if (a[j] >= 0)
	  p[j] = a[j];
	else
	  p[j] = (a[j] & 255);
      }
      (void) sprintf (result [count].interface, "%u.%u.%u.%u",
		      p[0], p[1], p[2], p[3]);
      result [count].interfaceClass = Ipinterface;
      if (IN_CLASSC(address)) {
	p[1] = 0;
	p[2] = 0;
      } else if (IN_CLASSB(address))
	p[2] = 0;
      (void) sprintf (result [count].system, "%u.%u.%u.0", p[0], p[1], p[2]);
      result [count].systemClass = Ipnetwork;
      count ++;
    }
  }
  *result_count = count;
  *result_data  = result;
  
  return True;
}

/**************************************************************************/
/*    Gather information about connected systems */
/**************************************************************************/

static MonetBool gather_connectedSystems (sys, official_name,
					result_data, result_count)
     int *result_count;
     MonetEntity sys;
     GatherResult **result_data;
     char ** official_name;
{
  MonetBool okay;

  if (MonetEntity_subclass (Iphost, MonetEntity_classOf(sys))) {
    okay = gather_connectedIPSystems (sys, official_name, result_data,
				      result_count);
  } else {
    MonetPrintfError ("Don't know how to gather for [%s]",
		      MonetEntity_title(sys));
    okay =  False;
  }
  return okay; 
}


extern MonetBool explore_connectedSystems (sys)
     Drawing sys;
{
  char * official_name, *title;
  GatherResult *result;
  int result_count, i;
  Drawing system, interface;
  MonetMap map;
  Position y;
  MonetEntity entity = ENTITY(sys);

  Iphost      = String2MonetEntity ("IpHost");
  Ipnetwork   = String2MonetEntity ("IpNetwork");
  Ipinterface = String2MonetEntity ("IpInterface");

  if (!Iphost) {
    MonetPrintfError ("IpHost not defined");
    return False;
  }

  if (!Ipnetwork) {
    MonetPrintfError ("IpNetwork not defined");
    return False;
  }

  if (!Ipinterface) {
    MonetPrintfError ("IpInterface not defined");
    return False;
  }

  title = Drawing_title (sys);
  if (gather_connectedSystems (entity, &official_name, &result, &result_count)
      == False) {
    return False;
  }
  if (official_name == NULL) {
    MonetPrintfError ("System [%s] seems not to exist", title);
    return False;
  }
  if (NEQ (official_name, title)) {
    MonetPrintfError ("The official name of [%s] is [%s]",
		      title, official_name);
    /* !!! Should change the name */
  } else {
    MonetPrintfInform ("Official name [%s]", official_name);
  }
  if (result_count == 0) {
    MonetPrintfInform ("Could not find any connected systems");
    return False;
  }
  y = Y(sys) + 8 + HEIGHT(sys);
  
  map = Drawing_mapOf (sys);
  /* !!! If already exists we have to do a search for existing instance */
  /* !!! Ought to be able to do this in one operation */
  for (i = 0; i < result_count; i++) {
    MONETDEBUG(2, ( "Network [%s]", result[i].system));
    system    = Drawing_create (result[i].system,
				result[i].systemClass, map, X(sys), y, 0,0);
    interface = Drawing_create (result[i].interface,
				result[i].interfaceClass, map, X(sys), y,0,0);
    if (system == NULL) {
      MonetPrintfInform ("System [%s] already exists", result[i].system);
      system    = Drawing_find (result[i].system, result[i].systemClass, map);
    } else {
      y += 6 + HEIGHT(sys);
    }
    MONETDEBUG(2, ( "Interface [%s]", result[i].interface));
    if (interface == NULL) {
      MONETDEBUG(2, ( "Interface [%s] already exists", result[i].interface));
      interface = Drawing_find (result[i].interface,
				result[i].interfaceClass, map);
    } else {
    }
    MonetEntity_make_interface (ENTITY(interface), ENTITY(system));
    MonetEntity_make_interface (ENTITY(interface), ENTITY(sys));
    place_interface (map, interface);
  }
  return True;
}

/***********************************************************************/
/***********************************************************************/
/*  $Header: //gaia/group.local/computer/monet/lib/map/RCS/gather.c,v 1.1 1991/06/11 11:26:10 a38 Exp a38 $ */
/***********************************************************************/
/***********************************************************************/


