/**********************************************************/
/**********************************************************/
/* $Header$  */
/**********************************************************/
/*  Files are saved in a special directory and have a     */
/*  user name and version number attached to their name   */
/*  before saving.  These routines convert a simple file  */
/*  name into the actual nameused in the unix filestore.  */
/*  They check the names for correctness and print        */
/*  diagnostics.                                          */
/*                                                        */
/*  !!! No checks are made on the sizes of filenames.     */
/*  !!! Should also deal with quotas for users.           */
/*  !!! Does not deal with version numbers yet.           */
/**********************************************************/

#include <monet/msh/General.h>
#include <monet/msh/Script.h>
#include <netdb.h>
#include <monet/map/File.h>

static String   map_directory= NULL;

/*****************************************************************************/

/*****************************************************************************/

extern String Monet_map_directory (dir)
     char * dir;
{
  if (dir) {
    MonetFree (map_directory);
    map_directory = MonetNewString (dir);
  }
  return map_directory;
}

/**********************************************************/

/**********************************************************/

static String map_file_name (name)
     String name;
{
  char * dir;
  if (dir = Monet_map_directory (NULSTR)) {
    return (char *) MonetMakePathname (dir, name, NULSTR);
  } else {
    return name;
  }
}

/* -- Should avoid this one  */
extern String Map_name2filename (name)
     String name;
{
  return  map_file_name (MonetTidyString (name));
}

extern String Map_filename2name (filename)
     String filename;
{
  if (filename = MonetTidyString (filename)) {
    char * place = filename;
    while (*filename && *filename == '/') {
      place = filename + 1;
      do {
	++filename;
      } while (*filename && *filename != '/');
    }
    return place;
  }
  return "";
}

extern FILE * Map_fopen_save (file, name)
     String name, file;
{
  char *filename;
  FILE * result;

  if (file) {
    name = file;
  }
  if (!MonetTidyString (name)) {
    MonetPrintfError ("NULL file name");
    return NULL;
  }

  filename = map_file_name (name);
  if (result = fopen (filename, "w"))
    MonetPrintfInform ("Opened [%s] for saving", filename);
  else
    MonetPrintfError ("Could not open file [%s]", filename);
  return result;
}

extern String Map_filename (filename)
     String filename;
{
  filename = MonetTidyString (filename);
  filename = map_file_name (filename);
  return filename;
}
	
extern FILE * Map_fopen_load (filename)
     String filename;
{
  FILE * result;

  filename = MonetTidyString (filename);
  filename = map_file_name (filename);
  if (result = fopen (filename, "r"))
    MonetPrintfInform ("Opened [%s] for loading", filename);
  else
    MonetPrintfError ("Could not open file [%s]", filename);
  return result;
}

extern void monet_map_file_init ()
{
/*  (void) MonetMember_module_class ("MapFile"); */

  map_directory = MonetNewString ("maps");
}

extern void monet_map_file_finish ()
{
  
}

/**********************************************************/
/**********************************************************/
/* $Header$  */
/**********************************************************/
/**********************************************************/

