/****************************************************************/
/****************************************************************/
/*  $Header: //gaia/group.local/computer/monet/lib/map/RCS/interface.c,v 1.1 1991/06/11 11:26:10 a38 Exp a38 $ */
/****************************************************************/
/*  These routines are used for creating and positioning        */
/*  interfaces on the screen.  This is a layer above the        */
/*  interface module provided by _db/interface.c                */
/****************************************************************/

#include <monet/map/Drawing.h>
#include <monet/map/Lines.h>
#include <monet/map/Interface.h>
#include "mapP.h"

/****************************************************************/
/*  Definitions  */
/****************************************************************/

extern MonetBool is_isolated (d)
     Drawing d;
{
  MonetEntity ei, sys = ENTITY(d);

  if (MonetEntity_isInterface (sys)) {
    if (Drawing_from_interface (d) ||
	Drawing_to_interface (d)) {
      return False;
    }
  } else if (MonetEntity_isNode (sys))
    FOR_ENTITYLIST (ei, sys->interfaces) {
      if (get_drawing (ei, Drawing_mapOf(d)))
	return False;
    } END_FORLIST;
  return True;
}

/***************************************************************/
/* Position the interfaces of a system in a nice way */
/* There are more general solutions to this problem */
/* Hopefully this one is good enough for the time being */
/***************************************************************/

static MonetBool is_acute (i)
	Drawing i;
{
	int xf,yf, xt,yt;
	int above;
	Drawing from, to;

	from = Drawing_from_interface (i);
	to   = Drawing_to_interface (i);
	if (from == NULL || to == NULL)
		return False;

	yf = Y(from) - Y(i);
	xf = X(from) - X(i);
	yt = Y(to)   - Y(i);
	xt = X(to)   - X(i);

/*	below = ( sqrt (xf*xf+xt*xt) * sqrt (yf*yf+yt*yt)) >= 0; */
	above = (xf*xt + yf*yt) >= 0;
	return above;
}

extern void straighten_acute_interfaces (drawing)
     Drawing drawing;
{
  Drawing i;
  MonetEntity ei, sys = ENTITY(drawing);

  if (MonetEntity_isInterface (sys))
    if (is_acute (drawing))
      place_interface (Drawing_mapOf(drawing), drawing);
    else if (MonetEntity_isNode (sys))
      FOR_ENTITYLIST (ei, sys->interfaces) {
	if (i = get_drawing (ei, Drawing_mapOf(drawing)))
	  if (is_acute (i))
	    place_interface (Drawing_mapOf(drawing), i);
      } END_FORLIST;
}

extern MonetBool position_interfaces (drawing)
     Drawing drawing;
{
  Drawing i;

  MonetEntity ei, sys = ENTITY(drawing);

  if (MonetEntity_isInterface (sys))
    place_interface (Drawing_mapOf(drawing), drawing);
  else if (MonetEntity_isNode (sys))
    FOR_ENTITYLIST (ei, sys->interfaces) {
      if (i = get_drawing (ei, Drawing_mapOf(drawing)))
	place_interface (Drawing_mapOf(drawing), i);
      else
	return False;
    } END_FORLIST;
  return True;
}

extern void place_interface (map, interface)
     Drawing interface;
     MonetMap map;
{
  Position x,y;

  if (map == NULL)
    map = Drawing_mapOf(interface);
  (void) get_newInterfacePosition  (map, interface, &x, &y);
  Map_insert_drawing (map, interface, NULSHAPE, NULSTR, x,y, 0,0);
}

/****************************************************************/
/*  Init and Finish  */
/****************************************************************/

extern void MonetMap_interfaces_init ()
{
}


extern void MonetMap_interfaces_finish ()
{
  
}

/****************************************************************/
/****************************************************************/
/*  $Header: //gaia/group.local/computer/monet/lib/map/RCS/interface.c,v 1.1 1991/06/11 11:26:10 a38 Exp a38 $ */
/****************************************************************/
/****************************************************************/


