/******************************************************************/
/******************************************************************/
/*  $Header: //gaia/group.local/computer/monet/lib/map/RCS/draw.c,v 1.1 1991/07/22 11:37:05 a38 Exp a38 $  */
/******************************************************************/
/******************************************************************/

#include "mapP.h"
#include <monet/map/Interface.h>
#include <monet/draw/Shape.h>

/************************************************************************/
/*  Globals  */
/************************************************************************/

/*****************************************************************************/
/*  Position elements on a map drawn as a list  */
/*****************************************************************************/

#define CLASS_X_SPACING 16
#define CLASS_Y_SPACING 5

static Position list_class(map, entity_class, x,y)
     MonetEntity          entity_class;
     Position        x, y;
     MonetMap map;
{
  MonetEntity          c;
  Drawing draw;

  if (entity_class == NULL) {
    MonetSysError ("list_class class is NULL");
    return y;
  }
  draw = Map_insert_drawing_class (map, entity_class);
  if (!draw) {	
    MonetSysError ("Could not get drawing for class [%s]",
	       MonetEntity_title(entity_class));
    return y;
  }
  LISTBOX(draw).x = x;
  LISTBOX(draw).y = y;
  Map_adjust_corners (Drawing_mapOf(draw), draw, True);
  Drawing_reset_list_label (draw);
  y += LISTBOX(draw).height + CLASS_Y_SPACING;
  x += CLASS_X_SPACING;
  FOR_ENTITYLIST(c, MonetEntity_subclasses(entity_class)) {
    y = list_class(map, c, x, y);
  } END_FORLIST;
  return (y);
}

extern void MonetMapList_setup (map)
     MonetMap map;
{
  if (Map_classesOnly(map)){
    (void) list_class (map, MonetEntityTopClass (), 20, 10);
  } else {
    Drawing o;
    Position y = 30;
    FOR_DRAWINGLIST(o, Map_elements (map)) {
      LISTBOX(o).x = 20;
      LISTBOX(o).y = y;
      Drawing_reset_list_label (o);
      y += LISTBOX(o).height + CLASS_Y_SPACING;
    } END_FORLIST;
  }
}
/*************************************************************************/
/*  Draw map as a list  */
/*************************************************************************/

extern void Drawing_list_draw (o)
     Drawing o;
{
  Position x,y, nx,ny;
  Dimension w,h;
  String label;

  x = LISTBOX(o).x;
  y = LISTBOX(o).y;
  w = LISTBOX(o).width;
  h = LISTBOX(o).height;
  nx = 2;
  ny = 2;

  if (Drawing_isSelected (o)) {
    Draw_box (shade_dark, shade_background, x, y, w,h, 2);
  }
  label = LISTBOX(o).label;
  Draw_string(shade_dark, x + nx, y + ny,
		   w - nx - nx, h - ny - ny,
		   label, MonetStrlen (label));
}

/************************************************************************/
/*  Init and Finish  */
/************************************************************************/

extern void MapDrawList_init ()
{
}

extern void MapDrawList_finish ()
{
}

/******************************************************************/
/******************************************************************/
/*  $Header: //gaia/group.local/computer/monet/lib/map/RCS/draw.c,v 1.1 1991/07/22 11:37:05 a38 Exp a38 $  */
/******************************************************************/
/******************************************************************/

