/*****************************************************************************/
/*****************************************************************************/
/* $Header: //gaia/group.local/computer/monet/lib/map/RCS/script.c,v 1.1 1991/07/22 11:37:27 a38 Exp a38 $ */
/*****************************************************************************/
/*****************************************************************************/

#include <monet/map/Drawing.h>
#include <monet/msh/Channel.h>
#include <monet/msh/Script.h>
#include <monet/map/Interface.h>
#include <errno.h>
#include <sys/ioctl.h>
#include "mapP.h"

/***************************************************************************/
/*  Definitions  */
/***************************************************************************/

MONETCALLBACK(do_get_selection)
     ISLOADED;
     if (current_Selection (CurrentMap)) {
       result = Drawing_title (current_Selection (CurrentMap));
     } else {
       result = NULL;
     }
MONETEND

MONETCALLBACK(do_free_selection)
     ISLOADED;
     free_selection (CurrentMap);
MONETEND

/***********************************************************************/
/*  Select Local Host                                                  */
/*  !!! This is a bit simplistic in its names selection                */
/*  !!! Could select a network as a local host                         */
/***********************************************************************/

MONETCALLBACK(do_selectLocalHost)
     char * name;
     Drawing o;

     ISLOADED;

     name = Monet_host_name ();
     MonetPrintfInform ("Local Host is [%s]", name);
     free_selection (CurrentMap);
     FOR_DRAWINGLIST (o, Map_elements (CurrentMap)) {
       MonetEntity e = ENTITY(o);
       if (EQS (TITLE(e), name) && MonetEntity_isSystem (e)) {
	 MonetPrintfInform ("Selected local host [%s]", MonetEntity_title (e));
	 add_selection (o);
	 RETURNSC;
       }
     } END_FORLIST;
     MonetPrintfError ("Couldn't find local host [%s] on this map", name);
MONETEND

/*****************************************************************************/
/*  Init finish  */
/*****************************************************************************/

extern void MapScript_select_init ()
{
  (void) MonetMember_module_class ("select");
  MonetMember_create ( "free",		do_free_selection,
		      "",
		      "free selected");
  MonetMember_create ( "top",		do_get_selection,
		      "",
		      "get top of selection list");
  MonetMember_create ( "localhost",	do_selectLocalHost,
		      "",
		      "select local host");
}

extern void MapScript_select_finish ()
{
  
}

/*****************************************************************************/
/*****************************************************************************/
/* $Header: //gaia/group.local/computer/monet/lib/map/RCS/script.c,v 1.1 1991/07/22 11:37:27 a38 Exp a38 $ */
/*****************************************************************************/
/*****************************************************************************/
