


#ifndef MONET_MonetOrdSet_H_
#define MONET_MonetOrdSet_H_

/**********************************************************/
/*  Maintain a simple extendable list                     */
/**********************************************************/

typedef struct monet_ordset * MonetOrdSet;
#define NULSET ((MonetOrdSet) 0)

/**********************************************************
  Prototype for searching scanning whole list
  Because an element could be deleted we check this by reading
  from the same place again, if changed than the element was
  removed if not we read the next one in the sequence.
  **********************************************************/

#define FOR_ORDSET(o,list,type) \
{ unsigned ordset_pos = 0; \
  for (o= (type)MonetOrdSet_getN (list, ordset_pos); o; \
       o = (type)MonetOrdSet_check_getN (list, &ordset_pos, (caddr_t) o)) {

#define END_FORLIST  }}

/**********************************************************/
/*  Functions  */
/**********************************************************/

extern MonetBool	MonetOrdSet_extract	PR((MonetOrdSet, caddr_t));
extern MonetOrdSet	MonetOrdSet_create	PR((void));
extern void		MonetOrdSet_reset	PR((MonetOrdSet));
extern void		MonetOrdSet_free	PR((MonetOrdSet));
extern void		MonetOrdSet_insert	PR((MonetOrdSet, caddr_t));
extern MonetBool	MonetOrdSet_isEmpty	PR((MonetOrdSet));
extern caddr_t		MonetOrdSet_getN	PR((MonetOrdSet, unsigned));
extern caddr_t		MonetOrdSet_check_getN
  PR((MonetOrdSet, unsigned* place, caddr_t previous));
extern caddr_t		MonetOrdSet_first	PR((MonetOrdSet));
extern caddr_t		MonetOrdSet_next	PR((MonetOrdSet));
extern unsigned		MonetOrdSet_sizeOf	PR((MonetOrdSet));
extern caddr_t		MonetOrdSet_second	PR((MonetOrdSet));
extern MonetBool	MonetOrdSet_isMember	PR((MonetOrdSet, caddr_t));

#endif
