/***************************************************************/
/***************************************************************/
/*  $Header$  */
/***************************************************************
  Some stuff for portable signals, BSD signals
  The signal routine 
  ***************************************************************/

#ifndef MONET_SIGNAL_H
#define MONET_SIGNAL_H

#include <signal.h>


/**************************************************************
  MONET_SIGNAL_T is the type of the signal(2) function.
  MONET_SIGNAL_COMPAT is local to this file and is used to
  convert between SYSV and BSD signal semantics.
  For ignoring signals, apparently SIG_IGN does does not work
  properly on some (SYSV) systems.
  **************************************************************/

#ifdef SYSV

#ifdef MONET_SIG_IGN_WORKS
#undef MONET_SIG_IGN_WORKS
#endif

#define MONET_SIGNAL_COMPAT(sig,name)  (void) signal (sig, name);

#else

#define MONET_SIG_IGN_WORKS
#define MONET_SIGNAL_COMPAT(sig,name)

#endif

#if defined(SYSV) && ! defined(sun)
#define MONET_SIGNAL_T int
#else
#define MONET_SIGNAL_T void
#endif


/**************************************************************
  MONET_PFV is the type of a signal handling routine.
 **************************************************************/

typedef MONET_SIGNAL_T (*MONET_PFV) PR((int, ...));
extern MONET_PFV signal();

/**************************************************************
  For declaring signal handling functions
  **************************************************************/

#ifdef MONET_PROTOTYPES

#define MONET_SIGNAL_ROUTINE(name) \
  static MONET_SIGNAL_T name (int sig, ...) { \
  MONET_SIGNAL_COMPAT(sig,name)

#else

#define MONET_SIGNAL_ROUTINE(name) \
  static MONET_SIGNAL_T name (sig) \
    int sig;  {  \
  MONET_SIGNAL_COMPAT(sig,name)

#endif /* MONET_PROTOTYPES */


#define MONET_END_SIGNAL_ROUTINE }


/***************************************************************/
/***************************************************************/

#endif /* MONET_SIGNAL_H */

/***************************************************************/
/***************************************************************/
/*  $Header$  */
/***************************************************************/
/***************************************************************/
