/***************************************************************/
/***************************************************************/
/*  $Header$  */
/***************************************************************/
/***************************************************************/

#ifndef MONET_STRING_TABLE_H
#define MONET_STRING_TABLE_H

typedef struct monet_string_table * MonetStringTable;
typedef struct monet_table_entry  * MonetStr;

extern MonetStringTable MonetStringTable_create
  PR((unsigned size));
extern void      MonetStringTable_free
  PR((MonetStringTable));
extern caddr_t MonetStringTable_lookup
  PR((MonetStringTable, String));
extern MonetStr MonetStringTable_insert_unique
  PR((MonetStringTable, String, caddr_t));
extern void    MonetStringTable_remove
  PR((MonetStringTable, String, caddr_t));
extern char * MonetStringTable_get
  PR((MonetStringTable table, MonetStr number));

extern MonetStr    MonetStringTable_refer
  PR((MonetStringTable table, char * name, caddr_t data));
extern void    MonetStringTable_derefer
  PR((MonetStringTable table, MonetStr number));

/*
extern void    MonetStringTable_insert
  PR((MonetStringTable, String, caddr_t));
*/


/***************************************************************/
/*  Init and finish  */
/***************************************************************/

extern void MonetStringTable_init
  PR((void));
extern void      MonetStringTable_finish
  PR((void));

/***************************************************************/
/*  MonetStr  */
/***************************************************************/

extern MonetBool    MonetStrEQString
  PR((MonetStr str, char * string));
extern void    MonetStr_derefer
  PR((MonetStr));
extern char *    MonetStr2String
  PR((MonetStr));
extern MonetStr    String2MonetStr
  PR((char *));
extern MonetStr    MonetStr_refer
    PR((char *));
extern void MonetStr_dump
  PR((void));

#endif

/***************************************************************/
/***************************************************************/
/*  $Header$  */
/***************************************************************/
/***************************************************************/
