/***************************************************************/
/***************************************************************/
/*  $Header$  */
/***************************************************************/
/***************************************************************/

#ifndef MONET_UNIXDEFS_H
#define MONET_UNIXDEFS_H

#if defined(__STDC__) || defined(__cplusplus) || defined(c_plusplus)
#else
#include <unistd.h>
#endif

/***************************************************************
  Actually used in monet (apart from msh_posix.h)
 ***************************************************************/

MONET_EXTERN_BEGIN

extern int      gethostname PR((const char * name, int namelen));
extern pid_t    getpid PR((void));
extern uid_t    getuid PR((void));
extern int      getdtablesize PR((void));
/*extern int      mkstemp
  PR((const char *));
*/
extern int symlink
  PR((const char *name1, const char *name2));
extern int rename
  PR((const char *name1, const char *name2));
extern int readlink PR((const char *path,  char *buf, int bufsiz));
extern int shutdown
     PR((int s, int how));
extern int close
     PR((int fd));
/*
#ifdef SYSV
extern int setpgrp
  PR((void));
#else
extern int setpgrp
  PR((int pgrp, int pid));
#endif
*/
extern int setpgrp PR((...));

extern gid_t    geteuid
  PR((void));

extern int      chdir PR((const char *path));
extern int      rmdir PR((const char *path));
extern pid_t    fork PR((void));
extern pid_t    getppid PR((void));
extern int      link PR((const char *path1, const char *path2));
extern int      unlink PR((const char *path));
extern int      read PR((int fildes, char *buf, int nbyte));
extern int      write PR((int fildes, const char *buf, unsigned int nbyte));
extern int      dup2 PR((int fildes, int fildes2));
extern int      pipe PR((int fildes[2]));
extern int      dup PR((int fildes));
extern int      execve
 PR((const char *path, const char *argv[],  char *envp[]));

extern double atof  PR((const char *str));

MONET_EXTERN_END

/**************************************************************
  gethostbyname etc.  These are implemented by the resolv library
  supplied with the monet distribution, this is C but monet
  may be compiled by C++ so the definitions are bracketed by
  MONET_EXTERN_ which declares C linkage (if using C++).
  **************************************************************/

MONET_EXTERN_BEGIN

extern int      h_errno;

extern void herror
  PR((char *));

extern struct hostent * gethostbyname
  PR((const char *name));

extern struct hostent * gethostbyaddr
  PR((const char *addr, int len, int type));

MONET_EXTERN_END


/****************************************************************************
  Just a list of posix? definitions  
  ****************************************************************************/

#ifdef DON_T_HAVE_UNISTD_INCLUDE_FILE_THEN_USE_THIS

/*****************************************************************************/
/*  Function Definitions , taken from unistd.h  */
/*****************************************************************************/

extern void     _exit PR((int status));
extern int      access PR((char *path, int amode));
extern unsigned alarm PR((unsigned secs));
extern int      chdir PR((char *path));
extern int      chmod PR((char *path, mode_t mode));
extern int      chown PR((char *path, uid_t owner, gid_t group));
extern int      close PR((int fildes));
extern char     *ctermid PR((char *s));
extern char     *cuserid PR((char *s));
extern int      dup PR((int fildes));
extern int      dup2 PR((int fildes, int fildes2));
extern int      execl PR((char *path, ...));
extern int      execle PR((char *path, ...));
extern int      execlp PR((char *file, ...));
extern int      execv PR((char *path, char *argv[]));
extern int      execve PR((char *path, char *argv[], char *envp[]));
extern int      execvp PR((char *file, char *argv[]));
extern pid_t    fork PR((void));
extern long     fpathconf PR((int fd, int name));
extern char     *getcwd PR((char *buf, int size));
extern gid_t    getegid PR((void));
extern uid_t    geteuid PR((void));
extern gid_t    getgid PR((void));
extern int      getgroups PR((int gidsetsize, gid_t grouplist[]));
extern char     *getlogin PR((void));
extern pid_t    getpgrp PR((void));

extern pid_t    getppid PR((void));

extern int      isatty PR((int fildes));
extern int      link PR((char *path1, char *path2));
/*extern off_t    lseek PR((int fildes, off_t offset, int whence)); */
extern long     pathconf PR((char *path, int name));
extern int      pause PR((void));
extern int      pipe PR((int fildes[2]));
extern int      read PR((int fildes, char *buf, unsigned int nbyte));
extern int      rmdir PR((char *path));
extern int      setgid PR((gid_t gid));
extern int      setpgid PR((pid_t pid, pid_t pgid));
extern pid_t    setsid PR((void));
extern int      setuid PR((uid_t uid));
extern unsigned sleep PR((unsigned int seconds));
extern long     sysconf PR((int name));
extern pid_t    tcgetpgrp PR((int fildes));
extern int      tcsetpgrp PR((int fildes, pid_t pgrp_id));
extern char     *ttyname PR((int fildes));
extern int      unlink PR((char *path));
extern int      write PR((int fildes, char *buf, unsigned int nbyte));

#endif /* NO unistd.h  */

/***************************************************************/

#endif

/***************************************************************/
/***************************************************************/
/*  $Header$  */
/***************************************************************/
/***************************************************************/
