/*****************************************************************************/
/*****************************************************************************/
/* $Header: //gaia/group.local/computer/monet/lib/general/RCS/general.c,v 1.2 1991/07/10 12:50:54 a38 Exp a38 $ */
/*****************************************************************************/
/*****************************************************************************/

#include "General.h"
#include "Array.h"

/*****************************************************************************/
/*  Globals  */
/*****************************************************************************/

typedef struct block * Block;

struct block {
  caddr_t data;
  Block next;
};

struct monet_array {
  unsigned block_size, entry_size, num_entries;
  Block block;
};

/*****************************************************************************/
/*  Create a new array  */
/*****************************************************************************/

extern MonetArray MonetArray_create (block_size, entry_size)
     unsigned block_size, entry_size;
{
  MonetArray array;

  array = MonetNew (struct monet_array);
  array -> block_size = block_size;
  array -> entry_size = entry_size;
  array -> num_entries = 0;
  array -> block = NULL;
  return array;
}

/*****************************************************************************/
/*  Free array  */
/*****************************************************************************/

extern void    MonetArray_free (array)
     MonetArray array ;
{
  Block block;
  FORALL (block, array->block, next) {
    MonetFree (block->data);
    MonetFree (block);
  }
  MonetFree (array);
}

/*****************************************************************************/

/*****************************************************************************/
/*
extern MonetBool MonetArray_resize (array, size)
     MonetArray array;
     unsigned size;
{
  Block block;
  if (array->block == NULL)
    block = array-> block;
  else
    for (block = array->block; block->next; block = block->next)
      size -= array->block_size;

  block->next = Monet
  FORALL (block, array->block, next) {
    if (size < array->block_size)
      return;
    Monet
    size -= array->block_size;
  }
}
*/
/*****************************************************************************/
/*  Get entry, returns NULL if out of bounds  */
/*****************************************************************************/

extern caddr_t MonetArray_get (array, position)
     MonetArray array;
     unsigned position;
{
  Block block;
  FORALL (block, array->block, next) {
    if (position < array->block_size)
      return (block->data+position*array->entry_size);
    position -= array->block_size;
  }
  return NULL;
}

/*****************************************************************************/
/*  Get number of entries in array  */
/*****************************************************************************/

extern unsigned MonetArray_get_size (array)
     MonetArray array;
{
  return array -> block_size * array -> num_entries;
}

/*****************************************************************************/
/*****************************************************************************/
/* $Header: //gaia/group.local/computer/monet/lib/general/RCS/general.c,v 1.2 1991/07/10 12:50:54 a38 Exp a38 $ */
/*****************************************************************************/
/*****************************************************************************/
