/*****************************************************************************/
/*****************************************************************************/
/* $Header: //gaia/group.local/computer/monet/lib/general/RCS/general.c,v 1.2 1991/07/10 12:50:54 a38 Exp a38 $ */
/*****************************************************************************/
/*****************************************************************************/

#include <monet/msh/Entity.h>
#include <monet/msh/EntityStack.h>
#include "monetP.h"

struct monet_entity_stack {
  MonetStackEntry head, place;
  MonetEntityStack next;
};

struct monet_stack_entry {
  MonetEntity entity;
  MonetEntityStack stack;
  MonetStackEntry next, entity_next;
};

static MonetEntityStack Stacks = NULL;

/*****************************************************************************/
/*  Globals  */
/*****************************************************************************/

extern MonetEntityStack MonetEntityStack_create ()
{
  MonetEntityStack stack;
  stack = MonetNew (struct monet_entity_stack);
  stack->head = NULL;
  LIST_ADD (stack, Stacks, next);
  return stack;
}

extern void MonetEntityStack_free (stack)
     MonetEntityStack stack;
{
  while (stack->head)
    (void) MonetEntityStack_pop (stack);
  LIST_DEL (MonetEntityStack, stack, Stacks, next);
  MonetFree (stack);
}

extern void MonetEntityStack_push (stack, entity)
     MonetEntity entity;
     MonetEntityStack stack;
{
  MonetStackEntry entry;
  
  if (entity) {
    MonetEntityStack_remove (stack, entity);
    entry = MonetNew (struct monet_stack_entry);
    LIST_ADD(entry, stack->head, next);
    LIST_ADD(entry, entity->stacks, entity_next);
    entry -> stack = stack;
    entity->stacks = entry;
    entry->entity = entity;
  }
}

extern MonetEntity MonetEntityStack_pop (stack)
  MonetEntityStack stack;
{
  if (stack->head) {
    MonetEntity entity;
    entity = stack->head->entity;
    LIST_DEL (MonetStackEntry, stack->head, entity->stacks, entity_next);
    MonetFree (stack->head);
    stack->head = stack->head->next;
    return entity;
  }
  return NULL;
}

extern MonetEntity MonetEntityStack_top (stack)
  MonetEntityStack stack;
{
  stack->place = stack->head;
  if (stack->head)
    return stack->head->entity;
  return NULL;
}

extern MonetEntity MonetEntityStack_next (stack)
     MonetEntityStack stack;
{
  if (stack->place && (stack->place = stack->place->next)) {
    return stack->place->entity;
  }
  return NULL;
}

extern void MonetEntityStack_remove (stack, entity)
     MonetEntityStack stack;
     MonetEntity entity;
{
  MonetStackEntry entry;
  FORALL (entry, entity->stacks, entity_next) {
    if (stack == entry->stack) {
      LIST_DEL (MonetStackEntry, entry, entry->stack->head, next);
      LIST_DEL (MonetStackEntry, entry, entity->stacks, entity_next);
      MonetFree (entry);
      break;
    }
  }
}

extern void MonetStack_free_entity (entity)
     MonetEntity entity;
{
  while (entity->stacks) {
    LIST_DEL (MonetStackEntry, entity->stacks, entity->stacks->stack->head,
	      next);
    MonetFree (entity->stacks);
    entity->stacks = entity->stacks -> entity_next;
  }
}

extern void monet_entity_stack_init ()
{
  Stacks = NULL;
}

extern void monet_entity_stack_finish ()
{
  while (Stacks)
    MonetEntityStack_free (Stacks);
}

/*****************************************************************************/
/*****************************************************************************/
/* $Header: //gaia/group.local/computer/monet/lib/general/RCS/general.c,v 1.2 1991/07/10 12:50:54 a38 Exp a38 $ */
/*****************************************************************************/
/*****************************************************************************/
