/*****************************************************************************/
/*****************************************************************************/
/* $Header: //gaia/group.local/computer/monet/lib/general/RCS/general.c,v 1.2 1991/07/10 12:50:54 a38 Exp a38 $ */
/*****************************************************************************/
/*  Hmm!  more could be done  */
/*  The host program most define a printer routine 'user_message'  */
/*****************************************************************************/

#include "General.h"

/*****************************************************************************/
/*  Get system error string  */
/*****************************************************************************/

extern String MonetSystemErrorMessage ()
{
	extern int sys_nerr, errno;
	extern char *sys_errlist[];

	if (sys_nerr < errno)
		return NULL;
	return sys_errlist[errno];
}

extern char MonetPrintChar2char (c)
     char c;
{
  char put;
  switch (c) {
  case 'n':
    put = '\n';
    break;
  case 't':
    put = '\t';
    break;
  case 'r':
    put = '\r';
    break;
  default:
    put = c;
    break;
  }
  return put;
}

/*****************************************************************************/

/*****************************************************************************/

extern MonetBool MonetEqStringOfStrings (s1, s2, n1, n2)
     char **s1, **s2;
     int n1, n2;
{
  if (s1 == s2)
    return True;

  if (n1 != n2 && n1 > 0 && n2 > 0)
    return False;

  if (!s1 || !s2) {
    return False;
  }

  while (n1) {
    if (! EQS(s1[n1], s2[n1])) {
      return False;
    }
    --n1;
  }
  return True;
}

extern void MonetFreeStringOfStrings (s, n)
     char **s;
     int n;
{
  if (s) {
    while (n > 0) {
      --n;
      MonetFree (s[n]);
    }
    MonetFree ((char *) s);
  }
}

/*****************************************************************************/
/*  Try to make a short label  */
/*****************************************************************************/

extern char * MonetShortLabel (string)
     char * string;
{
  static char * buf = NULL;
  int len = 0;
  char * c, p = '\0', pp = '\0', * r;
  MonetFree (buf);
  buf = MonetNewString (string);
  if (buf == NULL) {
    return NULL;
  }
  for (c = string, r = buf; *c; ++c) {
    if (isalnum (pp) && MonetCharInString (*c, "aeiou")) {
      /* Ignore vowels in the middle of a word, not the beginning */
    } else if (!isalnum (pp) && !isalnum(*c)) {
      /*  Ignore multiple non alpha numeric */
    } else if (*c == p) {
      /* Ignore repeated characters  */
    } else {
      ++len;
      *r = *c;
      ++ r;
      p = *c;
    }
    pp = *c;
  }
  if (len == 0) {
    /* If cannot reduce don't bother */
    MonetFree (buf);
    buf = NULL;
    return NULL;
  } else {
    *r = NULL;
  }
  return buf;
}

/***************************************************************/
/* Indented version of multiple line string */
/***************************************************************/

extern String MonetString_indent (string, chr, times)
     String string;
     char chr;
     unsigned times;
{
  String c, buf, result, place;
  unsigned len;

  buf = (char *) MonetMalloc (times + 1);
  buf[0] = '\n';
  while (times > 0) {
    -- times;
    buf[times] = chr;
  }
  for (len = 0, c = string; *c; ++len, ++c) {
    if (*c == '\n') {
      len += times;
    }
  }
  result = (char *) MonetMalloc (len + 1);
  place = MonetStringCopyToEnd (result, buf);
  result = MonetReplaceInStringBuffer (string, place, "\n",  buf);
  MonetFree (buf);
  return result;
}

/***************************************************************/
/*  Convert Booleans  */
/***************************************************************/

extern MonetBool String2MonetBool (string)
     String string;
{
  if (EQS(string, "true") || EQS(string, "TRUE") || EQS(string, "True")
      || EQS(string, "t") || MonetString2long (string) != 0)
    return True;
  return False;
}

extern String  MonetBool2String (boolean)
     MonetBool boolean;
{
  if (boolean)
    return "true";
  return "false";
}

/*****************************************************************************/
/*  Print string but put in new lines every 60 characters  */
/*****************************************************************************/

extern void MonetPrintLongString (string)
     char * string;
{
  int len = 0, l;
  char * s;
  while (s = MonetNextWord (string)) {
    l = MonetEndOfWord(s) - s;
    len += l;
    if (len >= 60) {
      MonetPrintfnl ("");
      len = 0;
    }
    MonetPrintf ("  %*s", l, s);
    s += l;
  }
  if (len > 0)
    MonetPrintfnl ("");
}

/******************************************************************/
/*  Produces a timestamp, always in GMT because this is not for   */
/*  local monitoring  */
/******************************************************************/

static char * clock2text (clock)
     long clock;
{
  static char buffer [128];
  register struct tm *tm;

  tm = gmtime (&clock);
  (void) sprintf (buffer, "%d/%d/%d %02d:%02d:%02d",
		  tm-> tm_year, tm -> tm_mon + 1, tm -> tm_mday,
		  tm -> tm_hour, tm -> tm_min, tm -> tm_sec);
  return buffer;
}

extern char * MonetTimeStamp ()
{
  long    clock;

  (void) time (&clock);
  return clock2text (clock);
}

/******************************************************************/
/*  Produces a timestamp, always in GMT because this is not for   */
/*  local monitoring.   This is beautified a bit and not so precise */
/******************************************************************/

extern char * MonetPrettyTimeStamp ()
{
  static char time_string [128];
  long currenttime;

  currenttime = time (0);
  (void) sscanf (ctime (&currenttime), "%[^\n]", time_string);
  return time_string;
}

/*****************************************************************************/
/*  Utility to print capacity as K, M or G instaed of lots of Zeros  */
/*****************************************************************************/

static void long2mega (value, buffer, exp, letter)
     char * buffer;
     long exp, value;
     char letter;
{
  long rem, val;

  rem   = value % exp;
  val   = value / exp;
  if (rem == 0) {
    (void) sprintf (buffer, "%lu%c", val, letter);
  } else {
    (void) sprintf (buffer, "%.1f%c",
		    (float) val / (float) exp, letter);
  }
}

extern String Monetlong2MegaString (c)
     long c;
{
  static char buffer[32];
	  
  if (c == 0)
    return "";

  if (c >= 1000000000)
    long2mega (c, buffer, (long) 1000000000, 'G');
  else if (c >= 1000000)
    long2mega (c, buffer, (long) 1000000, 'M');
  else if (c >= 1000)
    long2mega (c, buffer, (long) 1000, 'K');
  else
    long2mega (c, buffer, (long) 1, ' ');
  return buffer;
}

/*****************************************************************************/
/*  Convert unsigned  */
/*****************************************************************************/

extern String unsigned2string (c)
	unsigned c;
{
	static char buffer[32];

	(void) sprintf (buffer, "%lu", (unsigned long) c);
	return buffer;
}

extern unsigned String2unsigned (s)
	String s;
{
	unsigned c;
	int cc;
	if (s) {
	  cc = sscanf (s, "%ld", &c);
	  if (cc != 1)
	    c = 0;
	    
	} else {
	  c = 0;
	}
	return c;
}

/*****************************************************************************/
/*  Returns long int as a string  */
/*****************************************************************************/

extern String Monetlong2String (l)
     long l;
{
  static char buffer[32];
  (void) sprintf (buffer, "%ld", l);
  return buffer;
}

extern String Monetint2String (l)
     int l;
{
  static char buffer[32];
  (void) sprintf (buffer, "%d", l);
  return buffer;
}

/*****************************************************************************/
/*  Print number with message putting in plural forms  */
/*****************************************************************************/

extern void MonetPrintPrettyCount (before, after, value)
     String before, after;
     unsigned value;
{
  if (value == 0) {
    if (before && *before)
      MonetPrintfnl ("%s no %ss.", before, after);
    else
      MonetPrintfnl ("No %ss.", after);
  } else if (value == 1) {
    if (before && *before)
      MonetPrintfnl ("%s one %s.", before, after);
    else
      MonetPrintfnl ("One %s.", after);
  } else {
    if (before && *before)
      MonetPrintfnl ("%s %lu %ss.", before, value, after);
    else
      MonetPrintfnl ("%lu %ss.", value, after);
  }
}

/*****************************************************************************/
/*  Print number with message putting in plural forms  */
/*****************************************************************************/

extern void MonetPrintErrPrettyCount (before, after, value)
     String before, after;
     unsigned value;
{
  if (value == 0) {
    if (before && *before)
      MonetPrintfError ("%s no %ss.", before, after);
    else
      MonetPrintfError ("No %ss.", after);
  } else if (value == 1) {
    if (before && *before)
      MonetPrintfError ("%s one %s.", before, after);
    else
      MonetPrintfError ("One %s.", after);
  } else {
    if (before && *before)
      MonetPrintfError ("%s %lu %ss.", before, value, after);
    else
      MonetPrintfError ("%lu %ss.", value, after);
  }
}

extern char * MonetPrettyCount (num, what)
     int num;
     char * what;
{
  static char buf [1024], * cp; /* !!! */
  char first, plural;
  MonetBool upper;

  if (! what || !*what) {
    what = "";
    first = '\0';
    upper = False;
  } else if (upper = isupper (*what)) {
    first = tolower (*what);
  } else {
    first = *what;
  }

    plural = 's';
  if (num == 0) {
    (void) sprintf (buf, upper ? "No"  : "no");
  } else if (num == 1) {
    (void) sprintf (buf, upper ? "One" : "one");
    plural = '\0';
  } else {
    (void) sprintf (buf, "%d", num);
  }
  cp = buf + strlen (buf);
  (void) sprintf (cp, " %c%s%c", first, what+1, plural);
  return buf;
}

/*****************************************************************************/
/*  Convert yo lower case  */
/*****************************************************************************/

extern void MonetStringToLowerCase (string)
     String string;
{
  if (string)
    while (*string) {
      if (isupper (*string))
	*string = tolower(*string);
      ++string;
    }
}

/****************************************************************************/
/*  Chekc to see if a character is in a string */
/****************************************************************************/

extern String MonetChar2String (c)
     char c;
{
  static char buf[2] = " ";
  *buf = c;
  return buf;
}

/*****************************************************************************/
/*  Tidy a string */
/*****************************************************************************/

/*****************************************************************************/
/* Returns NULL if cannot tidy string, ie wierd chars or newline             */
/* Space and tab are compressed and removed from the head and tail           */
/* This has a fairly obvious bug that strings greater than 512 will crash it */
/*****************************************************************************/

static char * tidy_name (s)
     char *s;
{
  char * current, * place;
  MonetBool space = False;
#define SIZETIDYBUFFER 1024
  static char TidyBuffer[SIZETIDYBUFFER];

  if (!s)
    return "";

  current=s;
  for (place=TidyBuffer; *current!=NULL;current++) {
    if (isgraph (*current) && *current != '\"' && *current != '\'') {
      space = False;
      *place = *current;
      place ++;
    } else if (current==s) {
      /*  Ignore leading spaces  */
    } else if (!space) {
      *place = ' ';
      place ++;
      space = True;
    }
  }
  if (space)
    *(place-1) = NULL;
  else
    *place = NULL;
  return (TidyBuffer);
}

extern String MonetTidyString (src)
     String src;
{
  String val;
  val = tidy_name (src);
  if (! val || !(*val))
    return NULL;
  return val;
}

/*****************************************************************************/
/*  ?  */
/*****************************************************************************/

extern MonetBool MonetIsWord (src)
	String src;
{
  if (MonetTidyString (src))
    return True;
  return False;
}

/* ====================================================================	*/
/* 	OCCUR() - Check for occurence of pat in str			*/
/* ====================================================================	*/

extern MonetBool MonetIsStringInString (str, pat)
     char *str, *pat;
{
  char *point = str;

  while (point=index(point, *pat)) {
      if (strncmp(point, pat, strlen(pat)) == 0)
	return True;
      point++;
    }
  return False;
}

/***************************************************************************
  Search a string for occurance of a word
  ****************************************************************************/

extern MonetBool MonetWordInString (word, string)
     char * word, * string;
{
  int len, l;

  if (!word || ! string)
    return False;
  len = strlen (word);
  while (string = MonetNextWord (string)) {
    l = MonetEndOfWord(string) - string;
    if (len == l && strncmp (word, string, l) == 0) {
      return True;
    }
    string += l + 1;
  }
  return False;
}

/*****************************************************************************/
/*  Replace one all occurences of one string in another  */
/*  Allows an escape character */
/*****************************************************************************/

extern String MonetReplaceInString (source, search, replacement)
     String source, search, replacement;
{
  static char buf[2048];
  return MonetReplaceInStringBuffer (source, buf, search, replacement);
}

/*****************************************************************************/
/*  Replace one all occurences of one string in another  */
/*  Allows an escape character */
/*****************************************************************************/

extern String MonetReplaceInStringBuffer (source, result, search, replacement)
  String source, search, replacement, result;
{
  int count;
  char * c;

  if (MonetStrlen (search) == 0)
    return source;
  if (MonetStrlen (search) > 1)
    MonetSysError ("MonetReplaceInString: len>1 not yet implemented !!!");

  for (count = 0, c = source; *c!=NULL && count < sizeof(result); ++c) {
    if (count + 1 == sizeof(result)) {
      MonetPrintfInform ("Command too long, truncating");
      break;
    } else if (*c == search[0]) {
      if (replacement) {
	char * p;
	for (p = replacement; *p; p++, count++) {
	  if (count + 1 == sizeof(result)) {
	    MonetPrintfInform ("Command too long, truncating");
	    break;
	  } else {
	    result[count] = *p;
	  }
	}
      } else {
	MonetPrintfError ("No system selected");
	return NULL;
      }
    } else {
      if (*c == '\\')
	++c;
      /*** Copy the character in the template into the request string ***/
      result[count] = *c;
      ++count;
    }
  }
  result[count] = NULL;

  return result;
}

/*****************************************************************************/
/*  Checks to see if a character is in a string  */
/*****************************************************************************/

extern MonetBool MonetCharInString (c, set)
     char c, * set;
{
  while (set && *set)
    if (c == *set)
      return True;
    else
      ++set;
  return False;
}

/*****************************************************************************/
/*  Checks to see if there is anything else at the end of the line  */
/*****************************************************************************/

extern String MonetNextOnLine (cp)
     String cp;
{
  if (cp == NULL)
    return NULL;
  while (SPACEORTAB(*cp))
    ++ cp;
  if (*cp == '\0')
    return NULL;
  return cp;
}

/*****************************************************************************
	looks in 'place' for next non whitespace char and returns
	pointer to it.
*****************************************************************************/

extern String MonetNextWord (place)
     String place;
{
  if (place) {
    while ( (! isprint (*place) || isspace (*place)) &&
	   (*place && *place !=  '\n'))
      ++place;
    if (*place == '\0')
      place = NULL;
  }
  return place;
}

extern String MonetPreviousWord (start, place)
     String place, start;
{
  while ( place > start && (! isprint (*place) || isspace (*place)))
    --place;
  return place;
}

extern String MonetEndOfWord (place)
     String place;
{
  if (place)
    while ((isgraph (*place)) && (!isspace (*place)) && (*place != '\n'))
	   ++place;
  return place;
}

/*****************************************************************************/
/*  Strip white space from the ends of a string  */
/*****************************************************************************/

extern String MonetStripEndWhiteSpace (src)
     String src;
{
  String start, last;
  unsigned len;

  if (start = MonetNextWord (src)) {
    len = MonetStrlen (start);
    if (last = MonetPreviousWord (start, start+len-1))
      *(last+1) = '\0';
  }
  return start;
}

/***************************************************************/
/*  Get next sequence of non space chars in a string  */
/***************************************************************/

extern MonetBool MonetCopyNextWord (buf, result, len)
     String * buf, result;
     unsigned len;
{
  String place, start;
	
  for (place = *buf; !isgraph (*place); ++place)
    if (*place == NULL)
      break;
  for (start = place;isgraph (*place); ++place)
    if (len > 0) {
      *result = *place;
      -- len;
      ++result;
    }
  *result = NULL;
  if (place == start)
    return False;
  *buf = place;
  return True;
}

/*****************************************************************************/
/*  Compare strings for equallity, handles NULL strings as ""                */
/*****************************************************************************/

extern MonetBool MonetStringsEqual (a,b)
     String a,b;
{
  if (a==b)
    return True;
  if (a == NULL)
    return (*b == NULL);
  if (b == NULL)
    return (*a == NULL);

  return strcmp (a, b) == 0;
}

extern MonetBool MonetStringPrefixEqual (prefix,b)
     String prefix,b;
{
  if (!prefix)
    return True;
  if (b)
    if (strncmp (prefix, b, strlen (prefix)) == 0)
      return True;
  return False;
}

/*****************************************************************************/
/*  Copies one string on to another and returns pointer to end of new string */
/*  Count must be initialised outside  */
/*****************************************************************************/

extern String	MonetStringCopyAndCountToEnd (dest, src, count)
     String dest, src;
     unsigned *count;
{
	register char * d, *s;
	if (src)
		s = src;
	else
		s= "";
	for (d=dest;*s; ++s, ++d, ++(*count))
		*d = *s;
	*d = '\0';
	return d;
}
extern String MonetStringCopyFieldToEnd (dest, src, width)
     String dest, src;
     unsigned width;
{
	register char * d, *s;
	if (src)
		s = src;
	else
		s= "";
	for (d=dest;*s && width; ++s, ++d, --width)
		*d = *s;
	while (width) {
	  *d = ' ';
	  ++d;
	  --width;
	}
	*d = '\0';
	return d;
}

extern String MonetStringCopyToEnd (dest, src)
	String dest, src;
{
	register char * d, *s;
	if (src)
		s = src;
	else
		s= "";
	for (d=dest;*s; ++s, ++d)
		*d = *s;
	*d = '\0';
	return d;
};


extern char * MonetReallocAppendString (start, result)
     char * start, * result;
{
  if (start) {
    if (result) {
      char * c;
      int ls, ln;
      ls = strlen (start);
      ln = strlen (result);
      c = MonetMalloc (ls + ln + 1);
      bcopy (start, c, ls);
      bcopy (result, c+ls, ln);
      c[ls+ln] = 0;
      MonetFree (start);
      return c;
    }
    return start;
  }
  return MonetNewString (result);
}
   
/***************************************************************************/
/*  Append to end of a malloced string and remalloc in necessary  */
/***************************************************************************/
/*
extern char MonetReallocAppend (begin, place, insert, space)
     char **begin, *place, *insert;
     int *space, *place;
{
  for (cp = insert, i = place-begin+*space; *cp; ++cp, --i) {
    if (i <= 0) {
      *space = (*space * 3) / 2 + 1;
      result = MonetRealloc (result, available);
    }
   if (available - len < MAXMAPLINELEN) {
      available = (unsigned) (len) + MAPSPACEALLOCATION;
      *begin = MonetRealloc (result, available);
    }
}*/

    
/***************************************************************************/
/*  Converts SNMP timeticks into a string, taken from cmu snmp stuff       *

	Copyright 1988, 1989 by Carnegie Mellon University

                      All Rights Reserved

Permission to use, copy, modify, and distribute this software and its 
documentation for any purpose and without fee is hereby granted, 
provided that the above copyright notice appear in all copies and that
both that copyright notice and this permission notice appear in 
supporting documentation, and that the name of CMU not be
used in advertising or publicity pertaining to distribution of the
software without specific, written prior permission.  

CMU DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING
ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS, IN NO EVENT SHALL
CMU BE LIABLE FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR
ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS,
WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION,
ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS
SOFTWARE.
***************************************************************************/

extern char * Monet_uptime_string(timeticks)
    register unsigned long timeticks;
{
  static char buf [64];
  unsigned long	seconds, minutes, hours, days;

  timeticks /= 100;
  days = timeticks / (60 * 60 * 24);
  timeticks %= (60 * 60 * 24);

  hours = timeticks / (60 * 60);
  timeticks %= (60 * 60);

  minutes = timeticks / 60;
  seconds = timeticks % 60;

  if (days == 0){
    (void) sprintf(buf, "%lu:%02lu:%02lu", hours, minutes, seconds);
  } else if (days == 1) {
    (void) sprintf(buf, "%lu day, %lu:%02lu:%02lu", days, hours, minutes,
		       seconds);
  } else {
    (void) sprintf(buf, "%lu days, %lu:%02lu:%02lu", days, hours, minutes,
		   seconds);
  }
  return buf;
}

extern String MonetString2HexString (buf, cp, len)
     char *buf;
     char  *cp;
     int	    len;
{
    for(; len >= 16; len -= 16){
	sprintf(buf, "%02X %02X %02X %02X %02X %02X %02X %02X ",
		cp[0], cp[1], cp[2], cp[3], cp[4], cp[5], cp[6], cp[7]);
	buf += MonetStrlen(buf);
	cp += 8;
	sprintf(buf, "%02X %02X %02X %02X %02X %02X %02X %02X\n",
		cp[0], cp[1], cp[2], cp[3], cp[4], cp[5], cp[6], cp[7]);
	buf += MonetStrlen(buf);
	cp += 8;
    }
    for(; len > 0; len--){
	sprintf(buf, "%02X ", *cp++);
	buf += MonetStrlen(buf);
    }
    *buf = '\0';
    return buf;
}

extern String MonetString2AsciiString (buf, cp, len)
     char *buf;
     char  *cp;
     int	    len;
{
    int	x;

    if (cp == NULL)
      cp= (char *) "";
    for(x = 0; x < len; x++){
	if (isprint(*cp)){
	    *buf++ = *cp++;
	} else {
	    *buf++ = '.';
	    cp++;
	}
	if ((x % 48) == 47)
	    *buf++ = '\n';
    }
    *buf = '\0';
    return buf;
}


extern String MonetString2PrintString (buf, cp, len)
    char *buf;
    char  *cp;
    int	    len;
{
  if (cp == NULL)
    cp = (char *) "";
  len -= 2;
  *buf = '"'; ++buf;
  while (*cp && (len > 0)) {
    char c;
    c = *cp;
    switch (c) {
    case '\"':
    case '\\':
      *buf = '\\';
      buf++;
      *buf = c;
      break;
    case '\n':
      *buf = '\\';
      buf++;
      *buf = 'n';
      break;
    case '\t':
      *buf = '\\';
      buf++;
      *buf = 't';
      break;
    case '\r':
      *buf = '\\';
      buf++;
      *buf = 'r';
      break;
    default:
      if (isprint(c)) {
	*buf = c;
      } else {
	*buf = ' ';
      }
    }
    ++ buf;
    ++ cp;
  }
  *buf = '"'; ++buf;
  *buf = '\0';
  return buf;
}


extern String PrintString2MonetString (source, buffer, escape)
     String *source, buffer;
     MonetBool escape;
{
  String  cp, put;
  char quote;
  quote = **source;

  put = buffer;
  for ( cp = (*source)+1; *cp && *cp != quote; ++cp) {
    if (escape && *cp == '\\' && *(cp+1)) {
      ++cp;
      *put = MonetPrintChar2char (*cp);
      ++put;
    } else {
      *put = *cp;
      ++put;
    }
  }
  *source = cp;
  *put = NULL;
  return buffer;
}

/*  Lower case compare  */

extern int MonetLowerCaseCompare (s1, s2)
    char *s1, *s2;
{
    char c1, c2;

    while(*s1 && *s2){
	if (isupper(*s1))
	    c1 = tolower(*s1);
	else
	    c1 = *s1;
	if (isupper(*s2))
	    c2 = tolower(*s2);
	else
	    c2 = *s2;
	if (c1 != c2)
	    return ((c1 - c2) > 0 ? 1 : -1);
	s1++;
	s2++;
    }

    if (*s1)
	return -1;
    if (*s2)
	return 1;
    return 0;
}

/***************************************************************************
  Extracts a section from a string, a string can be looked at as being split
  into a number of parts (sections) separated by a 'seperator' character.
  This routine returns the n'th such section from a string.
  ***************************************************************************/

extern String MonetStringSection (string, seperator, number)
     String string;
     char seperator;
     unsigned number;
{
  String start, place;
  static char * buffer = NULSTR;

  if (string == NULL) {
    return NULL;
  }
  if (number == 0)
    return NULL;
  place = start = string;
  while (1) {
    if (*place == seperator || *place == NULL) {
      -- number;
      if (number == 0) {
	unsigned len = place-start;
	MonetFree (buffer);
	buffer = (char *) MonetMalloc (len+1);
	(void) strncpy (buffer, start, len);
	buffer[len] = NULL;
	return buffer;
      }
      if (*place == NULL)
	break;
      start = place + 1;
    }
    ++ place;
  }
  return NULL;
}

/*****************************************************************************/
/*  Concatinate an array of strings  */
/*****************************************************************************/

extern String MonetJoinStrings (argc, argv, between)
     int argc;
     char ** argv, * between;
{
  static char * buf = NULSTR;
  String p;
  unsigned i;
  MonetBool null = True;
  int between_len, buf_len;

  if (buf)
    MonetFree (buf);

  if ( ! argv || argc <= 0) {
    buf = NULSTR;
    return NULSTR;
  }

  between_len = MonetStrlen (between);
  buf_len = between_len * (argc-1) + 1;

  for (i=0; i < argc; ++i) {
    if (argv[i]) {
      buf_len += strlen (argv[i]);
      null = False;
    }
  }

  if (null) {
    buf = NULSTR;
    return NULSTR;
  }

  buf = (char *) MonetMalloc (buf_len);

  if (! buf) {
    MonetSysError ("JoinStrings: Could not mallocate space [%d]", buf_len);
    return NULSTR;
  }

  for (p = buf, *p = '\0', i = 0; i < (argc); ++i) {
    if (argv[i]) {
      if (between && ! null)
	p = MonetStringCopyToEnd (p, between);

      null = False;

      p = MonetStringCopyToEnd (p, argv[i]);
    }
  }

  return buf;
}

/*****************************************************************************/
/*  monet_strcat  */
/*****************************************************************************/

extern char * MonetStrcat (s1, s2)
     char * s1, *s2;
{
  char * result;
  result = MonetMalloc (MonetStrlen(s1)+MonetStrlen(s2)+2);
  (void) sprintf (result, "%s%s", s1,s2);
  return result;
}

/***********************************************************************/
/*  Display version  */
/***********************************************************************/

extern void MonetVersion ()
{
  MonetPrintfnl ("[%s] Version %s",
		  Monet_program_name (), Monet_software_version ());
  MonetPrintfnl ("The [%s] package is available from [%s]",
		  Monet_software_title (), Monet_software_source ());
  MonetPrintfnl ("For more information contact [%s]",
		  Monet_software_contact ());
  MonetPrintfnl ("");
}

/***********************************************************************/
/*  Display copyright  */
/***********************************************************************/

extern void MonetCopyright ()
{
  String name;

  name = MonetNewString (Monet_program_name());
  if (islower(name[0]))
    name[0] = toupper(name[0]);
  else if (islower(name[1]))
     name[1] = toupper(name[1]);
  MonetPrintfnl
    ("**********************************************************************");
  MonetPrintfnl ("%s ver. %s, Copyright (C) 1991 NIKHEF-H, Amsterdam",
		 Monet_software_version (), name);
  MonetPrintfnl ("%s comes with ABSOLUTELY NO WARRANTY.", name);
  MonetPrintfnl ("This is free software, and you are welcome to redistribute it");
  MonetPrintfnl ("under certain conditions.  For details see documentation.");
  MonetPrintfnl
    ("**********************************************************************");
  MonetPrintfnl ("");

  MonetFree (name);
}

/*****************************************************************************/
/*****************************************************************************/

#ifdef MONET_THIS_IS_OBSOLETE_hhsd

extern String MonetJoinStringsUntilNull (argv, between)
     char ** argv, * between;
{
  return MonetJoinStringToStrings (NULSTR, argv, between);
}

extern String MonetJoinStringToStrings (first, argv, between)
     char ** argv, * first, * between;
{
  /* static char buf[4096];  !!! */
  String p;
  unsigned i;
  MonetBool null = True;

  if ( ! argv)
    return NULSTR;

  p = buf;
  *p = '\0';
  if (first)
    p = MonetStringCopyToEnd (p, first);
  
  for (i = 0; argv[i]; ++i) {
    if (argv[i]) {
      null = False;
      p = MonetStringCopyToEnd (p, argv[i]);
      if (between)
	p = MonetStringCopyToEnd (p, between);
    }
  }
  if (p-buf >= sizeof (buf)) {
    MonetSysError ("JoinStringToStrings: buffer overflow");
  }
  if (null)
    return NULSTR;
  return buf;
}
#endif /*  obsolete  */

/*****************************************************************************/
/*****************************************************************************/
/* $Header: //gaia/group.local/computer/monet/lib/general/RCS/general.c,v 1.2 1991/07/10 12:50:54 a38 Exp a38 $ */
/*****************************************************************************/
/*****************************************************************************/
