/*
 * xdm - display manager daemon
 *
 * $XConsortium: daemon.c,v 1.5 89/01/20 10:43:49 jim Exp $
 *
 * Copyright 1988 Massachusetts Institute of Technology
 *
 * Permission to use, copy, modify, and distribute this software and its
 * documentation for any purpose and without fee is hereby granted, provided
 * that the above copyright notice appear in all copies and that both that
 * copyright notice and this permission notice appear in supporting
 * documentation, and that the name of M.I.T. not be used in advertising or
 * publicity pertaining to distribution of the software without specific,
 * written prior permission.  M.I.T. makes no representations about the
 * suitability of this software for any purpose.  It is provided "as is"
 * without express or implied warranty.
 *
 * Author:  Keith Packard, MIT X Consortium
 */
/*
#include <X11/Xos.h>
*/


#include <monet/msh/General.h>
#include <monet/msh/System.h>

#include <sys/ioctl.h>
#ifdef hpux
#include <sys/ptyio.h>
#endif

#include <fcntl.h>



static int Daemon = 0;

extern void exit ();

extern void MonetBecomeDaemon (do_fork)
     MonetBool do_fork;
{
    register int i;

    /*  -- really a debugging thing, so easier to test  */
    if (do_fork) {
      /*
       * fork so that the process goes into the background automatically. Also
       * has a nice side effect of having the child process get inherited by
       * init (pid 1).
       */

      if (fork ())			/* if parent */
	exit (0);				/* then no more work to do */
    }

    /*
     * Close standard file descriptors and get rid of controlling tty
     */

#ifdef SYSV
    setpgrp ();
#else
    setpgrp (0, getpid());
#endif

    close (0); 
    close (1);
    close (2);

    if ((i = open ("/dev/tty", O_RDWR)) >= 0) {	/* did open succeed? */
#if defined(SYSV) && defined(TIOCTTY)
	int zero = 0;
	(void) ioctl (i, TIOCTTY, &zero);
#else
	(void) ioctl (i, TIOCNOTTY, (char *) 0);    /* detach, BSD style */
#endif
	(void) close (i);
    }

    /*
     * Set up the standard file descriptors.
     */
    (void) open ("/", O_RDONLY);	/* root inode already in core */
    (void) dup2 (0, 1);
    (void) dup2 (0, 2);
    Daemon = 1;
    /*  Send messages to syslog  */
    MonetSyslog (True);
}

extern int MonetIsDaemon ()
{
  return Daemon;
}
