/*****************************************************************************/
/*****************************************************************************/
/* $Header: //gaia/group.local/computer/monet/lib/general/RCS/general.c,v 1.2 1991/07/10 12:50:54 a38 Exp a38 $ */
/*****************************************************************************/
/*  Initialises the basic monet library.  */
/*****************************************************************************/

#include "General.h"
#include <monet/msh/StrFifo.h>
#include "monetP.h"
#include "scriptP.h"

static MonetFinishRoutine Finish_handler;

static unsigned	Config_debug;

/*****************************************************************************/
/*  Debugging stuff  */
/*****************************************************************************/

extern unsigned Monet_debug ()
{
  return Config_debug;
}

/*****************************************************************************/
/*  Debugging stuff  */
/*****************************************************************************/

extern void Monet_debug_on (level)
     unsigned level;
{
  Config_debug = level;
}

/*****************************************************************************/
/* Init and Finish */
/*****************************************************************************/

extern void monet_debug_init ()
{
  Config_debug = 0;
}

extern void monet_debug_finish ()
{
}

/***************************************************************************/
/*  Finish off */
/***************************************************************************/

extern void Monet_quit (status)
     int status;
{
  if (Finish_handler) {
    Finish_handler ();
  } else {
    Monet_finish ();
  }
  (void) exit (status);
}

/*****************************************************************************/
/* Init and Finish */
/*****************************************************************************/

extern void Monet_init (program_name, finish, file, directory, argc, argv)
     String program_name;
     char * file, * directory;
     MonetFinishRoutine finish;
     int argc;
     char **argv;
{
  Finish_handler = finish;
  monet_debug_init ();
  monet_config_init (program_name, directory);
  Channel_init ();
  MonetPrintf_init ();
  MonetStringTable_init ();
  MonetStrFifo_init ();
  MonetEntity_init ();
  monetsh_init ();
  MonetConfig_init (file, argc, argv);
  monet_start_server ();
  monet_sh_init ();
}

extern void Monet_finish ()
{
  monet_sh_finish ();
  monet_close_server ();
  MonetConfig_finish ();
  monetsh_finish ();
  MonetEntity_finish ();
  MonetStrFifo_finish ();
  MonetStringTable_finish ();
  MonetPrintf_finish ();
  Channel_finish ();
  monet_config_finish ();
  monet_debug_finish ();
}

/*****************************************************************************/
/*****************************************************************************/
/* $Header: //gaia/group.local/computer/monet/lib/general/RCS/general.c,v 1.2 1991/07/10 12:50:54 a38 Exp a38 $ */
/*****************************************************************************/
/*****************************************************************************/
