/*****************************************************************************/
/*****************************************************************************/
/* $Header: //gaia/group.local/computer/monet/Xmonet/RCS/main.c,v 1.1 1991/03/26 12:00:14 a38 Exp a38 $ */
/*****************************************************************************/
/* This module provides support for a simple (extensible) script programming */
/* language.  It provides basic functionality, loops, conditionals, vars,    */
/* pipes, members and a set of standard functions.  Other modules can extend  */
/* on the set of standard functions using the C interface.                   */
/* The main bias is towards short scripts for text processing, especially    */
/* processing the output for normal operating system programs, so that use   */
/* sh, awk etc can be avoided when they aren't really necessary and impose   */
/* an unwanted processor overhead.                                           */
/* Input can come from a file, stdin or from a string.                       */
/* !!! This stuff is very similar to the code for config and they could be   */
/* !!! combined.                                                             */
/* This module is the interpreter and parser                                 */
/*****************************************************************************/

#include "scriptP.h"

/*****************************************************************************/
/*  Init finish  */
/*****************************************************************************/

extern void monetsh_init ()
{
  MonetLibrary_init ();
  MonetLibrary_begin (monetlib, "monet", "Basic Monet");

  monet_lex_init ();
  monetsh_init_context ();
  monetsh_init_member ();
  monetsh_init_raise ();
  monetsh_init_history ();
  MonetEvent_init ();

  MonetLibrary_done ();
}

extern void monetsh_finish ()
{
  MonetEvent_finish ();
  monetsh_finish_history ();
  monetsh_finish_raise ();
  monetsh_finish_member ();
  monetsh_finish_context ();
  monet_lex_finish ();
  MonetLibrary_finish ();
}

/*****************************************************************************/
/*****************************************************************************/
/* $Header: //gaia/group.local/computer/monet/Xmonet/RCS/main.c,v 1.1 1991/03/26 12:00:14 a38 Exp a38 $ */
/*****************************************************************************/
/*****************************************************************************/

