/*****************************************************************************/
/*****************************************************************************/
/* $Header: //gaia/group.local/computer/monet/Xmonet/RCS/main.c,v 1.1 1991/03/26 12:00:14 a38 Exp a38 $ */
/*****************************************************************************
  This maintains a list of loaded libraries, each library consists of a set
  of classes.  Only classes using MonetMember_module_class are registered.

  The name and short description are stored in the string table for no
  particularly good reason rather than just allocating them.
 ****************************************************************************/

#include "scriptP.h"

struct monet_library {
  MonetLibType type;
  MonetStr small, big;
  char  class_name [1024];
  MonetLibrary next;
};

static MonetLibrary List;
static MonetBool Loading;

/*****************************************************************************/

/*****************************************************************************/

extern void MonetLibrary_begin (type, small, big)
     MonetLibType type;
     char * small, * big;
{
  MonetLibrary lib;

  if (lib = MonetNew (struct monet_library)) {
    LIST_ADD(lib, List, next);
    lib -> type     = type;
    lib -> big      = MonetStr_refer (big);
    lib -> small    = MonetStr_refer (small);
    lib -> class_name[0] = '\0';
    Loading = True;
  }
}

extern void MonetLibrary_done ()
{
  Loading = False;
}

extern void MonetLibrary_register (entity_class)
     MonetEntity entity_class;
{
  if (Loading) {
    char * name = MonetEntity_title (entity_class);
    if (!MonetWordInString (name, List->class_name))
      (void) sprintf (List->class_name + strlen (List->class_name),
		      "  %s\n", name);
  }
}

extern void MonetLibrary_print ()
{
  MonetLibrary lib, NewList;

  /*  -- Reverse list so it comes out in the correct order  */
  LIST_REVERSE(MonetLibrary, List, NewList, next);
  FORALL(lib, NewList, next) {
    char * type;
    switch (lib->type) {
    case monetlib:
      type = "lib";
      break;
    case monetmsh:
      type = "msh";
      break;
    case monetapp:
      type = "app";
      break;
    }
    MonetPrintf ("%s %s %s\n%s",
		   type,
		   MonetStr2String (lib->small),
		   MonetStr2String (lib->big),
		   lib->class_name);
  }
  /*  -- Return list to the way it was  */
  LIST_REVERSE(MonetLibrary, NewList, List, next);
}

/*****************************************************************************/
/*  Init finish  */
/*****************************************************************************/

extern void	MonetLibrary_init ()
{
  Loading = False;
  List = NULL;
}

extern void	MonetLibrary_finish ()
{
  while (List) {
    MonetStr_derefer (List->big);
    MonetStr_derefer (List->small);
    MonetFree (List);
    List = List->next;
  }
}

/*****************************************************************************/
/*****************************************************************************/
/* $Header: //gaia/group.local/computer/monet/Xmonet/RCS/main.c,v 1.1 1991/03/26 12:00:14 a38 Exp a38 $ */
/*****************************************************************************/
/*****************************************************************************/

