/*****************************************************************************/
/*****************************************************************************/
/* $Header: //gaia/group.local/computer/monet/Xmonet/RCS/main.c,v 1.1 1991/03/26 12:00:14 a38 Exp a38 $ */
/*****************************************************************************/
/*  Defines some basic functions for monet script  */
/*****************************************************************************/

#include "scriptP.h"

/*************************************************************************/

static MonetBool Message = False;
static int ExceptionCode = MONETSH_OKAY;
static char  * ExceptionName[MONETSH_MAX_EXCEPTION], * ExceptionMessage = NULL;
static MonetExceptionFailer Failer = NULL;
static long FailPeriod;

/*************************************************************************/
/*  Script failed with error  */
/*************************************************************************/

extern void MonetException_register_fail (fail)
     MonetExceptionFailer fail;
{
  Failer = fail;
}

/*************************************************************************/
/*  Break execution */
/*************************************************************************/

extern void MonetException_report ()
{
  if (ExceptionCode) {
    if (Message && ExceptionMessage) {
      MonetPrintfnl ("[%d %s] %s", ExceptionCode,
			ExceptionName[ExceptionCode],
			ExceptionMessage);
    } else {
      MonetPrintfnl ("[%d %s]", ExceptionCode,
			ExceptionName[ExceptionCode]);
    }
    MonetException_raise (MONETSH_OKAY);
  }
}

extern void MonetException_raise_message (code, message)
     int code;
     char  * message;
{
  ExceptionCode = code;

  if (message) {
    if (ExceptionMessage) {
      MonetFree (ExceptionMessage);
    }
    Message = True;
    ExceptionMessage = MonetNewString (message);
  } else {
    Message = False;
  }
}

extern void MonetException_raise (code)
     int code;
{
  ExceptionCode = code;
  Message = False;
}

extern void MonetException_register (code, name)
     int code;
     char * name;
{
  MonetException_deregister (code);
  ExceptionName[code] = MonetNewString (name);
}

extern void MonetException_deregister (code)
     int code;
{
  if (ExceptionName[code]) {
    MonetFree (ExceptionName[code]);
  }
}

extern int MonetException_code ()
{
  if (Failer && ExceptionCode == MONETSH_OKAY) {
    long now, begin;

    begin = MonetContext_get_started (MonetContext_current ());
/*    if (begin < previous)
      begin = previous;
*/
    now = time (NULL);
    if (now - begin > FailPeriod) {
/*      previous = now; */
      Failer ();
    }
  }
  return ExceptionCode;
}

extern char * MonetException_name ()
{
  return ExceptionName[ExceptionCode];
}

/*****************************************************************************/
/*  Init finish  */
/*****************************************************************************/

extern void monetsh_init_raise ()
{
  for (ExceptionCode = MONETSH_MAX_EXCEPTION; ExceptionCode; --ExceptionCode)
    ExceptionName[ExceptionCode -1] = NULL;
  MonetException_register (MONETSH_HALT, "halt");
  MonetException_register (MONETSH_CONTINUE, "continue");
  MonetException_register (MONETSH_BREAK, "break");
  MonetException_register (MONETSH_SIGNAL, "signal");
  MonetException_register (MONETSH_RETURN, "return");
  MonetException_register (MONETSH_OKAY, "okay");
  MonetException_register (MONETSH_ERROR, "error");
  MonetException_register (MONETSH_EXIT, "exit");
  (void) MonetMember_module_class ("control");
  MonetMember_create_write_long ("fail-period", &FailPeriod,
		"The period that a program is running before by some user \
			    action, such as pressing a mouse key");
  FailPeriod = 4;
}

extern void monetsh_finish_raise ()
{
}

/*****************************************************************************/
/*****************************************************************************/
/* $Header: //gaia/group.local/computer/monet/Xmonet/RCS/main.c,v 1.1 1991/03/26 12:00:14 a38 Exp a38 $ */
/*****************************************************************************/
/*****************************************************************************/
