
#ifndef MONET_PRIVATE_SCRIPT_H
#define MONET_PRIVATE_SCRIPT_H

/*  This is a private header file for the script stuff  */

#include <monet/msh/General.h>
#include <monet/msh/Script.h>
#include <monet/msh/ScriptTree.h>
#include <monet/msh/StringTable.h>  /*  For MonetStr  */

#define SCRIPT_OPEN_BRACKET '('
#define SCRIPT_CLOSE_BRACKET ')'
#define SCRIPT_COMMENT_CHAR '#'

/*****************************************************************************/
/* Definitions */
/*****************************************************************************/

extern MonetMember MonetEntity_inherit
  PR((MonetEntity, MonetStr id, MonetEntity top));
extern long MonetMembers_changed
  PR((void));
extern void  MonetEntity_free_members
  PR((MonetEntity));

extern MonetMember MonetMember_lookup
  PR((MonetEntity, MonetStr id));
extern void MonetTree_dump
  PR((MonetTree, unsigned depth));
extern MonetTree MonetTree_parse
  PR((MonetTree source));
extern MonetTree String2MonetTree
  PR((String cp, MonetTree *tree, int *depth, MonetBool loose));
extern String MonetTree2String
  PR((MonetTree tree));
extern String MonetHistory_add
  PR((String));
extern void     MonetTree_free
  PR((MonetTree));
extern MonetTree MonetTree_create
  PR((MonetLex lex, String value));
extern void     MonetTree_change_type
  PR((MonetTree, MonetLex lex));
extern void     MonetTree_change_name
  PR((MonetTree, char *));

extern void MonetTreeFixTail
  PR((MonetTree tree, MonetTree tail));

extern MonetStr MonetContext_filename
  PR((MonetStr filestr));

extern int MonetContext_line_number
  PR((int line));

extern void MonetContext_filename_line
  PR((MonetStr * file, int *line));

extern void	monetsh_init                    PR((void));
extern void	monetsh_finish                  PR((void));
extern void	monetsh_init_member		PR((void));
extern void	monetsh_finish_member		PR((void));
extern void	monetsh_init_base		PR((void));
extern void	monetsh_finish_base		PR((void));
extern void	monetsh_init_src                PR((void));
extern void	monetsh_finish_src              PR((void));
extern void	monetsh_init_context            PR((void));
extern void	monetsh_finish_context          PR((void));
extern void	monetsh_init_raise              PR((void));
extern void	monetsh_finish_raise            PR((void));
extern void	monet_lex_init                  PR((void));
extern void	monet_lex_finish                PR((void));
extern void     monetsh_init_history            PR((void));
extern void     monetsh_finish_history          PR((void));

extern void	MonetLibrary_init               PR((void));
extern void	MonetLibrary_finish             PR((void));

#endif

