/********************************************************************/
/********************************************************************/
/* $Header$ */
/********************************************************************/
/********************************************************************/

/***************************************************************************/
/*  the pinger for apollos  */
/***************************************************************************/

#ifdef apollo

#include "/sys/ins/base.ins.c"
#include "/sys/ins/x25.ins.c" 

/* Macros to DEBUG info	*/

#define write_string(name,len)    {char * i=name; for(;i<(name+len);++i) putchar(*i); }
#define OUTSTATUS   printf ("Status = %x\n", status);
#define OUTS(name,len)  printf ("name:%d = [", len); write_string((char *)name,len); printf ("]\n");
#define OUTX(name) printf("name = %x\n", name);

MONETCALLBACK (do_x25_ping_once)
     char	*Idadr = arg[0];
     x25_$adr_t		x121addr ;
     short int		x121addrlen = 0;
     name_$name_t		hostname ;
     short int		hostnamelen = 0;
     name_$pname_t		gateway ;
     short int		gatewaylen = 0;
     status_$t		status, close_status;
     x25_$udata_t		userdata ;
     short int		userdatalen = 0;
     x25_$clear_data_t	clear;
     long int		handle = 0;
     char x121[1024], gate[1024], host[1024]; /* !!! */
     extern int errno;
     MonetLookupX25 lookup;

     if ((lookup = MonetHost2X25 (Idadr)) == NULL) {
       result = "invalid";
       RETURNSC;
     }
     bzero (x121addr, sizeof(x121addr));
     bzero (userdata, sizeof(userdata));
     x121addrlen = lookup->addrlen;
     userdatalen = lookup->userdatalen;
     bcopy (lookup->address,  x121addr, x121addrlen);
     bcopy (lookup->userdata, userdata, userdatalen);

     /* Try to make the call */

     MONETDEBUG(1, ("userdatalen= %d", userdatalen));
     x25_$call(gateway, gatewaylen, x121addr, x121addrlen,
	       userdata, userdatalen, handle, clear, status);
     if (handle != 0) {
       x25_$close(handle, close_status);
       if (close_status.all != status_$ok) {
	 MonetSysError ("x25_$close returned status [%lx]", close_status.all);
       }
     }

#ifdef DEBUG                                  
     printf("INFO after call setup :\n");
     OUTS(hostname, hostnamelen);
     OUTS(gateway, gatewaylen);
     OUTS(x121addr, x121addrlen);
     OUTSTATUS;

     (void) strncpy (gate, gateway, gatewaylen);
     gate[gatewaylen] = NULL;
     (void) strncpy (x121, x121addr, x121addrlen);
     x121[x121addrlen] = NULL;
     
     MONETDEBUG(1, ("[%s][%s] Handle : %x , cause %x , diagnostic %x status %x",
		 gate, x121, handle, (int) clear.cause, (int) clear.diagnostic,
		 status));
#endif DEBUG

     /* See if call succeeded */

     if (status.all == status_$ok) {
       result = "reachable";
     } else if (status.all == x25_$link_not_up) {
       /*  !!! Should set a flag saying there is a problem and issue a warning */
       result = "unknown";
     } else {
       result = "unreachable";
     }
MONETEND
#endif /***** apollo *****/


/********************************************************************/
/********************************************************************/
/* $Header$ */
/********************************************************************/
/********************************************************************/


