/********************************************************************/
/********************************************************************/
/* $Header$ */
/********************************************************************/
/********************************************************************/

/***************************************************************************/
/*  the pinger for gould_np1  */
/***************************************************************************/

#ifdef GOULD_NP1

#include <stdio.h>
#include <errno.h>
#include <syslog.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <sys/socketvar.h>
#include <netdb.h>
#include <netccitt/ccitt.h>
#include <netccitt/x25.h>
#include <netccitt/x25_user.h>


/* ====================================================================	*/
/* 	getcause(fd, error) - Diagnose error on openening a connection	*/
/* ====================================================================	*/
static void getcause (fd, error)
int             fd;
int             error;
{
	int             cause, diag, len;

	len = sizeof (int);

	if (getsockopt (fd, SOL_X25, X25_CAUSE, &cause, &len) < 0) {
		perror ("getsockopt X25_CAUSE");
		return;
	}

	if (getsockopt (fd, SOL_X25, X25_DIAG, &diag, &len) < 0) {
		perror ("getsockopt X25_DIAG");
		diag = 0;
	}

	MONETDEBUG(1, (stderr, "Errno: %d, Cause: %d, diagnostics: %d\n",
		    error, cause, diag));
}

/* ====================================================================	*/
/* 	openx25() - open a connection to address PSE_DTELOG		*/
/* ====================================================================	*/

MONETCALLBACK (do_x25_ping_once)
     String host = arg[0];
     extern          		errno;
     register int    		sd;
     struct sockaddr_ccitt 		r_address;
     struct ccitt_addr 		ccitt_addr();
     int             		buffer_len;
     char            		buffer[128];
     MonetLookupX25 lookup;

     if ((lookup = MonetHost2X25 (host) == NULL) {
       result = "invalid";
       RETURNSC;
     }
     r_address.scc_addr   = ccitt_addr(lookup->address);
     r_address.scc_family = AF_CCITT;
     if (r_address.scc_addr.s_length == -1) {
       MONETDEBUG(1, ("address conversion failed"))
       result = "invalid";
       RETURNSC;
     }

     if ((sd = socket (AF_CCITT, SOCK_SEQPACKET, 0)) < 0) {
       perror ("ping_x25: socket");
       result = "invalid";
       RETURNSC;
     }
     bzero (buffer, sizeof(buffer));
     buffer_len  = lookup->userdatalen;
     bcopy (lookup->userdata, buffer, buffer_len);

     if (setsockopt (sd, SOL_X25, X25_CALLUSER, buffer, buffer_len) < 0) {
       perror ("openx25: setsockopt");
       result = "unknown";
     } else if (connect (sd, &r_address, sizeof (r_address)) < 0) {
       perror ("openx25: connect");
       result = "unreachable";
       getcause (sd, errno);
     } else {
       result = "reachable";
     }
     close (sd);
MONETEND

#endif /* GOULD_NP1 */


/********************************************************************/
/********************************************************************/
/* $Header$ */
/********************************************************************/
/********************************************************************/


