.TH  libmonetprobe 3 "Release 0.10" Monet
.\" $Header$
.SH NAME
.TP
.B libquery
\- Monet Network Monitor/Query Library
.SH SYNOPSIS
.B "#include <monet/query/Lib.h>"
.sp
\fIcc\fR\0...\0\fB\-lquery\fR
.SH DESCRIPTION
The \fIlibquery\fR library contains a set of modules for monitoring
various types of network protocol (X.25, IP, TCP, SNMP).  The results
are cooked into a generic format so that the library user does not need
to worry about different protocols.
.PP
It should be easy to add new protocols and thus a consistent interface
needs to be defined.  The interface is defined as a structure containing
a set of pointers to functions.  This means that \fBvirtually no existing
code\fR need be changed;  one \fI#include\fR and one line to initialise
the module, plus of course a source file to implement the module.
This structure is defined in \fImonet/lib/query/Lib.h\fR.
.PP
Queries can be made syncronously or asyncronously, the latter is prefered
because this give much better respose time.
.SH PRIORITY
New requests are given priority over existing ones so that resposes are
returned quickly.
.PP
A frequency attribute can be attached to each query, this indicates the
\fIminimum\fR period between querying a perticular entity.  So that
it can be arranged for a system to be queried every 5 minutes, say.
.SH SEE ALSO
monet(1N), monetd(8N)
.SH BUGS
All queries are made syncronously, this means that only one query is out standing
at a time.
.br
Priority scheme is too primitve to be useful.  Currently ignores the period
between queries.
.br
Does not examine the results of other queries.  Not very clever.
.SH AUTHORS
James Barr, NIKHEF-H, Amsterdam

