/*****************************************************************************/
/*****************************************************************************/
/* $Header: //gaia/group.local/computer/monet/Xmonet/RCS/main.c,v 1.1 1991/03/26 12:00:14 a38 Exp a38 $ */
/*****************************************************************************/
/*  For doing network queries  */
/*****************************************************************************/

#include <monet/msh/General.h>
#include <monet/msh/Script.h>
#include "probeP.h"

#include <sys/errno.h>
#include <sys/wait.h>
#include <sys/time.h>
#include <sys/socket.h>
#include <netdb.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <ctype.h>

/*****************************************************************************/
/*  Use rpc statsrv protocol to get load on a system  */
/*****************************************************************************/
#ifdef RPCSVC_RSTAT
#include <rpcsvc/rstat.h>


MONETCALLBACK(do_rstat)
     MonetPrintfWarning ("%s:  Not yet implemented", argv[0]);
     /*
     char *host = argv[1];
     struct statstime statp;
     if (rstat(host, &statp) == 0) {
       static char buf [256];
       result = buf;
       (void) sprintf (buf, "");
     } else {
       result = NULL;
     }
     */
MONETEND

#endif

/*****************************************************************************/
/*  Tcp  */
/*  !!! Should generalise this by giving 'monetsh' socket handling           */
/*  !!! capability and writing this in monetsh script.                       */
/*****************************************************************************/

MONETCALLBACK(do_tcp_ping_once)
     String host = argv[1];
     int    port = MonetString2int (argv[2]);
     int	sock;
     struct	sockaddr_in server;
     struct	hostent *hp;

     bzero(&server, sizeof(server));
     server.sin_family = AF_INET;
     server.sin_port = htons(port);

     if ((hp = gethostbyname(host)) == NULL) {
       result = "invalid";
     } else {
       bcopy(hp->h_addr, (char *) &server.sin_addr, hp->h_length);
       if ((sock = socket(AF_INET, SOCK_STREAM, 0)) < 0) {
	 result = "unknown";
       } else {
	 if (connect(sock, (struct sockaddr *) &server, sizeof(server)) < 0) {
	   if (errno == ENETUNREACH || errno == ETIMEDOUT) {
	     result = "unreachable";
	   } else { /* !!! */
	     result = "unknown";
	   }
	 } else {
	   result = "reachable";
	 }
	 close(sock);
       }
     }
MONETEND

/*****************************************************************************/
/*  Init and finish  */
/*****************************************************************************/

extern void MonetProbe_init ()
{
  MonetLibrary_begin (monetlib, "probe", "Network Monitoring");

  MonetProbe_x25_init ();
  MonetProbe_snmp_init ();

  (void) MonetMember_module_class ("tcp");
  MonetMember_create ("ping-once", do_tcp_ping_once,
     "host port",
     "Succeeds if can connect to the tcp port on the specified host");

#ifdef RPCSVC_RSTAT
  (void) MonetMember_module_class ("rstat");

  MonetMember_create ("rstat", do_rstat,
     "host",
     "Returns a strings giving rstat(3) information");


#endif
  MonetLibrary_done ();
}

extern void MonetProbe_finish ()
{
  MonetProbe_snmp_finish ();
  MonetProbe_x25_finish ();
}

/*****************************************************************************/
/*****************************************************************************/
/* $Header: //gaia/group.local/computer/monet/Xmonet/RCS/main.c,v 1.1 1991/03/26 12:00:14 a38 Exp a38 $ */
/*****************************************************************************/
/*****************************************************************************/
