/***************************************************************************/
/***************************************************************************/
/*  $Header$  */
/***************************************************************************/
/***************************************************************************/
/*  The SNMPTRAP stuff is taken from 'snmptrapd' an application that */
/*  comes with   the cmu snmp stuff.  */
/*  !!! It is not tested although the makefiles have been */
/*  !!! altered for it.  I would like to first of all just get it to act like */
/*  !!! snmptrad, then use these traps usefully to report back to the mapper */
/***************************************************************************/

/***********************************************************
	Copyright 1988, 1989 by Carnegie Mellon University

                      All Rights Reserved

Permission to use, copy, modify, and distribute this software and its 
documentation for any purpose and without fee is hereby granted, 
provided that the above copyright notice appear in all copies and that
both that copyright notice and this permission notice appear in 
supporting documentation, and that the name of CMU not be
used in advertising or publicity pertaining to distribution of the
software without specific, written prior permission.  

CMU DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING
ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS, IN NO EVENT SHALL
CMU BE LIABLE FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR
ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS,
WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION,
ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS
SOFTWARE.
******************************************************************/

#include <monet/msh/General.h>
#include <monet/msh/Script.h>
#include <monet/msh/NiceSocket.h>
#include <errno.h>
#include <sys/file.h>

static unsigned SnmpGets = 0, SnmpSets = 0, SnmpNexts = 0;
static unsigned SnmpGetsFail = 0, SnmpSetsFail = 0, SnmpNextsFail = 0;
static MonetBool Snmp_initialised, Snmp_traps;

#define SNMPOKAY \
   if (Snmp_initialised == False) { \
      MonetPrintfError ("Snmp has not been initialised yet, use snmp-init"); \
      result = NULL; \
      RETURNSC; \
   }

/***************************************************************************/
/*  Definitions  */
/***************************************************************************/

#ifdef CMU_SNMP

#include <signal.h>
#include <sys/errno.h>
#include <sys/wait.h>
#include <sys/time.h>
/*
#include <sys/socket.h>
#include <netinet/in.h>
*/
#include <arpa/inet.h>
#include <ctype.h>

#include "snmpP.h"

extern int  errno;
extern int snmp_dump_packet;
/*** "cmusnmp/snmp_impl.h", #defines void as 'char, to avoid problems !!! */
/*** !!! with compilers that don't support void *  ***/
#undef void  /* !!! hastle with cmusnmp */

int snmp_dump_packet = 0;

extern String MonetOid_sprint_short_objid PR((oid *, int len));

extern String MonetOid_sprint_variable PR((oid*, int, struct variable_list *));

extern String MonetOid_sprint_value    PR((oid*, int, struct variable_list *));

extern String MonetOid_sprint_type     PR((oid*, int, struct variable_list *));
/*
static int ascii_to_binary(cp, bufp)
    u_char  *cp;
    u_char *bufp;
{
    int	subidentifier;
    u_char *bp = bufp;

    for(; *cp != '\0'; cp++){
	if (isspace(*cp))
	    continue;
	if (!isdigit(*cp)){
	    printf("Input error\n");
	    return -1;
	}
	subidentifier = atoi(cp);
	if (subidentifier > 255){
	    printf("subidentifier %d is too large ( > 255)\n", subidentifier);
	    return -1;
	}
	*bp++ = (u_char)subidentifier;
	while(isdigit(*cp))
	    cp++;
	cp--;
    }
    return bp - bufp;
}
*/

/***************************************************************************/

/***************************************************************************/

static struct {
  int num;
  char * name;
} Traps [] = {
  { SNMP_TRAP_COLDSTART, "ColdStart" },
  { SNMP_TRAP_WARMSTART, "WarmStart" },
  { SNMP_TRAP_LINKDOWN, "LinkDown" },
  { SNMP_TRAP_LINKUP, "LinkUp" },
  { SNMP_TRAP_AUTHFAIL, "AuthenticationFailure" },
  { SNMP_TRAP_EGPNEIGHBORLOSS, "EGPNeighborLoss" },
  { SNMP_TRAP_ENTERPRISESPECIFIC, "EnterpriseSpecific" },
  { -1, NULL }
};

static char * trap_description (trap)
    int trap;
{
  int i;
  for (i = 0; Traps[i].name; ++i) {
    if (Traps[i].num == trap)
      return Traps[i].name;
  }
  return "Unknown";
}

extern char * MonetSnmpTrap2Name (name)
     char * name;
{
  int num;
  num = MonetSnmpTrap2int (name);
  if (num != -1) {
    return trap_description (num);
  }
  return NULL;
}

extern int MonetSnmpTrap2int (name)
     char * name;
{
  int i;

  name = MonetTidyString (name);

  if (name == NULL)
    return -1;
  if (isdigit (*name)) {
    return atoi (name);
  }
  for (i = 0; Traps[i].name; ++i) {
    if (EQS(name, Traps[i].name))
      return Traps[i].num;
  }
  return -1;
}

MONETCALLBACK(do_trap2string)
     result = MonetSnmpTrap2Name (argv[1]);
MONETEND

MONETCALLBACK(do_trap2int)
     result = Monetlong2String ((long) MonetSnmpTrap2int (argv[1]));
MONETEND

MONETCALLBACK(do_list_traps)
  int i;
  for (i = 0; Traps[i].name; ++i) {
    MonetPrintfnl ("%d %s", Traps[i].num, Traps[i].name);
  }
MONETEND

/***************************************************************************/

/***************************************************************************/

static int trap_callback(op, session, reqid, pdu, magic)
     int op;
     struct snmp_session *session;
     int reqid;
     struct snmp_pdu *pdu;
     void *magic;
{
  char buf[64];

  if (op == RECEIVED_MESSAGE && pdu->command == TRP_REQ_MSG) {
    char command[1024];
    /*    MonetPrintfInform("%s: %s Trap (%d) Uptime: %s",
	  inet_ntoa(pdu->agent_addr.sin_addr),
	  trap_description(pdu->trap_type),
	  pdu->specific_type, Monet_uptime_string(pdu->time, buf));
	  */
    (void) sprintf (command, "snmp-trap-handler \"%s\" \"%s\" \"%d\" \"%s\"",
		    inet_ntoa(pdu->agent_addr.sin_addr),
		    trap_description(pdu->trap_type),
		    pdu->specific_type, Monet_uptime_string(pdu->time));
    MONETDEBUG(20, ( "snmp-handler: [%s]", command));
    (void) MonetshExecute (command, NULL, False);
  } else if (op == TIMED_OUT){
    MonetSysError("Timeout: This shouldn't happen!\n");
  }
  return 1;
}

#endif /* CMU_SNMP */

MONETCALLBACK (do_snmp_traps)
     int port;
     struct snmp_session session, *ss;

     SNMPOKAY;
     if (argc == 2) {
       port = (int) MonetString2long (argv[1]);
     } else {
       port = SNMP_TRAP_PORT;
     }

#ifdef CMU_SNMP
     bzero((char *)&session, sizeof(struct snmp_session));
     session.peername = NULL;
     session.community = NULL;
     session.community_len = 0;
     session.retries = SNMP_DEFAULT_RETRIES;
     session.timeout = SNMP_DEFAULT_TIMEOUT;
     session.authenticator = NULL;
     session.callback = trap_callback;
     session.callback_magic = NULL;
     session.local_port = port;
     ss = snmp_open(&session);
     if (ss == NULL) {
       MonetPrintfError("Couldn't open snmp for traps (port %d)",
			port);
       Snmp_traps = False;
     } else {
       Snmp_traps = True;
     }
#endif
MONETEND

/***************************************************************************/
/*  Start a session  */
/***************************************************************************/

static struct snmp_session * open_snmp_session (session, gateway, community)
     char *gateway, * community;
     struct snmp_session * session;
{
  struct snmp_session * ss;
  if (! gateway) {
    MonetPrintfError ("snmp: host name is NULL");
    return NULL;
  }
  if (! community || *community == NULL) {
    community = "public";
  }
  bzero((char *)session, sizeof(struct snmp_session));
  session->peername = gateway;
  session->community = (u_char *)community;
  session->community_len = MonetStrlen((char *)community);
  session->retries = SNMP_DEFAULT_RETRIES;
  session->timeout = SNMP_DEFAULT_TIMEOUT;
  session->authenticator = NULL;
  snmp_synch_setup(session);
  ss = snmp_open(session);
  if (ss == NULL) {
    MonetPrintfError ("Couldn't open snmp for [%s]", gateway);
  }
  return ss;
}

/*****************************************************************************/
/*  Set up monetsh variables from the results of an snmp request  */
/*****************************************************************************/

static String set_up_snmp_result (response)
     struct snmp_pdu *response;
{
  unsigned count;
  struct variable_list *vars;
  static char buf[8192];
  String f;

  f = buf;
  *f = '\0';
  for(count = 0, vars = response->variables; vars;
      count ++, vars = vars->next_variable) {
    String value, objid;
    if (count > 0) {
      *f = '\n';
      ++f;
    }
    objid = MonetOid_sprint_short_objid(vars->name, vars->name_length);
    f = MonetStringCopyToEnd (f, objid);
    *f = '\t'; ++f;
    value = MonetOid_sprint_value (vars->name, vars->name_length, vars);
    f = MonetStringCopyToEnd (f, value);
  }
  *f = '\0';
  if (count == 0)
    return NULL;
  return buf;
}

/*****************************************************************************/
/*  Handle the resoponse from an snmp query  */
/*****************************************************************************/

static void handle_snmp_response (ss, pdu, gateway, result)
     struct snmp_session  *ss;
     struct snmp_pdu *pdu;
     char ** result, * gateway;
{
  struct snmp_pdu *response;
  int status;

  response = NULL;
  status = snmp_synch_response(ss, pdu, &response);

  if (status == STAT_SUCCESS) {
    if (response->errstat == SNMP_ERR_NOERROR) {
      *result = set_up_snmp_result (response);
    } else {
      MonetPrintfError ("%s", snmp_errstring ((int) response->errstat));
    }
  } else if (status == STAT_TIMEOUT) {
    MonetPrintfError ("No Response from %s", gateway);
  } else {    /* status == STAT_ERROR */
    MonetPrintfError ("Error Occurred");
  }
  /*  If things went well and response is set the response == pdu  */
  /*  therefore there is no need to free 'pdu'  */
  if (response) {
    snmp_free_pdu (response);
  }
}

/***************************************************************************/
/*  Set up variables for get/getnext operation  */
/***************************************************************************/

static MonetBool set_up_variables (argc, names, pdu)
     char ** names;
     int argc;
     struct snmp_pdu *pdu;
{
  int count, name_length;

  for(count = 0; count < argc; count++) {
    oid name[MAX_NAME_LEN];

    name_length = MAX_NAME_LEN;
    if (names[count] == NULL) {
      MonetPrintfError ("snmp-get: variable is null");
      return False;
    }
    if (!read_objid(names[count], name, &name_length)){
      MonetPrintfError ("Invalid object identifier: %s", names[count]);
      return False;
    }
    snmp_add_null_var(pdu, name, name_length);
  }
  return True;
}

/***************************************************************************/
/*  Adjust 'select(2)' parameters to handle traps  */
/***************************************************************************/

extern void MonetProbe_before_select(numbits,readbits, writebits, other, timer)
     int *numbits;
     fd_set *readbits, *writebits, *other;
     struct timeval *timer;
{
  int block;
#ifdef CMU_SNMP
  if (Snmp_traps) {
    block = 1;
    snmp_select_info(numbits, readbits, timer, &block);
    /* if (block == 1)
       timer = NULL;   block without timeout */
  }
#endif /* CMU_SNMP */
}

/***************************************************************************/
/*  Called after select to handle pending input  */
/***************************************************************************/

extern void MonetProbe_after_select (count, readbits, writebits, other)
     int count;
     fd_set *readbits, *writebits, *other;
{
#ifdef CMU_SNMP
  if (Snmp_traps) {
    if (count == 0) {
      snmp_timeout();
    } else if (count > 0) {
      snmp_read(readbits);
    }
  }
#endif /* CMU_SNMP */
}

/*****************************************************************************/

/*****************************************************************************/

typedef struct snmp_request * SnmpRequest;
struct snmp_request {
  oid *name;
  int len;
  String var;
};
/*
static MonetBool oid_cmp (o1, l1, o2, l2)
     oid * o1, *o2;
     int l1, l2;
{
  if (l1 == l2) {
    while (l1 > 0) {
      -- l1;
      if (o1[l1] != o2[l1])
	return False;
    }
    return True;
  }
  return False;
}
*/
/*****************************************************************************/
/*
 * snmpget.c - send snmp GET requests to a network entity.
 *
 */
/***********************************************************
	Copyright 1988, 1989 by Carnegie Mellon University

                      All Rights Reserved

Permission to use, copy, modify, and distribute this software and its 
documentation for any purpose and without fee is hereby granted, 
provided that the above copyright notice appear in all copies and that
both that copyright notice and this permission notice appear in 
supporting documentation, and that the name of CMU not be
used in advertising or publicity pertaining to distribution of the
software without specific, written prior permission.  

CMU DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING
ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS, IN NO EVENT SHALL
CMU BE LIABLE FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR
ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS,
WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION,
ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS
SOFTWARE.
******************************************************************/

extern int	snmp_dump_packet;

MONETCALLBACK(do_snmpget)
     struct snmp_session session, *ss;
     struct snmp_pdu *pdu;
     char * gateway;

     SNMPOKAY;

     result = NULL;
     gateway = argv[1];

     if (ss = open_snmp_session (&session, gateway, argv[2])) {
       if (pdu = snmp_pdu_create(GET_REQ_MSG)) {
	 ++SnmpGets;
	 if (set_up_variables (argc-3, argv+3, pdu)) {
	   handle_snmp_response (ss, pdu, gateway, &result);
	 } else {
	   snmp_free_pdu (pdu);
	 }
       } else {
	 ++SnmpGetsFail;
       }
       snmp_close(ss);
     }
MONETEND

/*****************************************************************************/
/*  snmp get next  */
/*****************************************************************************/
/*
 * snmpgetnext.c - send snmp GETNEXT requests to a network entity.
 *
 */

MONETCALLBACK (do_snmpgetnext)
     struct snmp_session session, *ss;
     struct snmp_pdu *pdu;
     char * gateway;

     SNMPOKAY;

     result = NULL;
     gateway = argv[1];

     if (ss = open_snmp_session (&session, gateway, argv[2])) {
       if (pdu = snmp_pdu_create(GETNEXT_REQ_MSG)) {
	 ++SnmpNexts;
	 if (set_up_variables (argc-3, argv+3, pdu)) {
	   handle_snmp_response (ss, pdu, gateway, &result);
	 } else {
	   snmp_free_pdu (pdu);
	 }
       } else {
	 ++SnmpNextsFail;
       }
       snmp_close(ss);
     }
MONETEND

/***************************************************************************/
/*  Snmp set  */
/***************************************************************************/

MONETCALLBACK(do_snmpset)
     char * type, * varname, * value, *gateway;
     struct snmp_session session, *ss;
     struct snmp_pdu *pdu;
     struct variable_list *vp;
     oid name[MAX_NAME_LEN];

     SNMPOKAY;

     result = NULL;
     type = argv [3];
     varname = argv[4];
     value = argv[5];
     result = NULL;
     gateway = argv[1];
     if (! gateway) {
       gateway = "";
     }

     if (varname == NULL) {
       MonetPrintfError ("snmp-set: variable is null");
       RETURNSC;
     }

     if (vp = (struct variable_list *)malloc(sizeof(struct variable_list))) {
     } else {
       MonetPrintfError ("snmp-set: could not malloc space");
       RETURNSC;
     }
     vp->next_variable = NULL;
     vp->name = NULL;
     vp->val.string = NULL;

     vp->name_length = MAX_NAME_LEN;
     if (!read_objid(varname, name, &vp->name_length)) {
       MonetPrintfError ("Invalid object identifier: %s", varname);
       MonetFree (vp);
       RETURNSC;
     }
     vp->name = (oid *)malloc(vp->name_length * sizeof(oid));
     bcopy((char *)name, (char *)vp->name, vp->name_length * sizeof(oid));

   
     if (EQS(type, "int")) {
       vp->type = INTEGER;
     } else if (EQS(type, "oct")) {
       vp->type = STRING;
     } else if (EQS(type, "nul")) {
       vp->type = NULLOBJ;
     } else if (EQS(type, "oid")) {
       vp->type = OBJID;
     } else {
       MonetPrintfError
       ("Sorry type should be one of [int,oct,nul,oid], not [%s]", type);
       MonetFree (vp->name);
       MonetFree (vp);
       RETURNSC;
     }
     switch(vp->type){
     case INTEGER:
       vp->val.integer = (long *)malloc(sizeof(long));
       *(vp->val.integer) = atol(value);
       vp->val_len = sizeof(long);
       break;
     case STRING:
       vp->val_len = MonetStrlen (value) + 1;/*ascii_to_binary(value, value);*/
       vp->val.string = (u_char *)malloc(vp->val_len);
       bcopy((char *)value, (char *)vp->val.string, vp->val_len);
       break;
     case NULLOBJ:
       vp->val_len = 0;
       vp->val.string = NULL;
       break;
     case OBJID:
       vp->val_len = MAX_NAME_LEN;;
       read_objid(value, (oid *) value, &vp->val_len);
       vp->val_len *= sizeof(oid);
       vp->val.objid = (oid *)malloc(vp->val_len);
       bcopy((char *)value, (char *)vp->val.objid, vp->val_len);
       break;
     default:
       MonetPrintfError ("Internal error");
       MonetFree (vp->name);
       MonetFree (vp);
       RETURNSC;
     }

     if (ss = open_snmp_session (&session, gateway, argv[2])) {
       if (pdu = snmp_pdu_create(SET_REQ_MSG)) {
	 ++SnmpSets;
	 pdu->variables = vp;
	 handle_snmp_response (ss, pdu, gateway, &result);
       } else {
	 ++SnmpSetsFail;
	 MonetFree (vp->name);
	 MonetFree (vp);
       }
       snmp_close(ss);
     }
MONETEND

MONETCALLBACK (do_snmp_dump_packets)
     snmp_dump_packet = String2MonetBool (argv[1]);
MONETEND

MONETCALLBACK (do_snmp_init)
     /*  Load in snmp mib file  */
     if (Snmp_initialised) {
       MonetPrintfWarning ("SNMP already initialised");
     } else {
       if (argc == 1) {
	 /* Use this instead of cmusnmp's init_mib  */
	 MonetMib_init (argv[1]);
       } else {
	 MonetMib_init (NULL);
       }
       Snmp_initialised = True;
     }
MONETEND

MONETCALLBACK (do_help)
     MonetPrintfnl ("Snmp Gets,  okay: %d  fail %d", SnmpGets,  SnmpGetsFail);
     MonetPrintfnl ("Snmp Nexts, okay: %d  fail %d", SnmpNexts, SnmpNextsFail);
     MonetPrintfnl ("Snmp Sets,  okay: %d  fail %d", SnmpSets,  SnmpSetsFail);
MONETEND

/***************************************************************************/
/*  Init and finish  */
/***************************************************************************/

extern void MonetProbe_snmp_init ()
{
#ifdef CMU_SNMP

  Snmp_initialised = False;
  MonetMib_init ("mib.txt");
  Snmp_initialised = True;
  Snmp_traps = False;
  (void) MonetMember_module_class ("snmp");
  MonetMember_create
    ("init",  do_snmp_init,
     "?mib-file",
     "Initialises the snmp stuff and loads in the mib file. \
     Default is '(monet-dir)/mib.txt'");
  MonetMember_create
    ("help",  do_help,
     "",
     "Data about snmp queries");
  MonetMember_create
    ("traps",  do_snmp_traps,
     "?port",
     "Enable handling of snmp traps, default port is 162");
  MonetMember_create
    ("dump-packets",  do_snmp_dump_packets,
     "boolean",
     "If set will dump all snmp packets sent out to standard output");
  MonetMember_create
    ("get",  do_snmpget,
     "host passwd variables ...",
     "Does an snmpget, returns the values in new variables \
that have the same name as the mib variable");
  MonetMember_create
    ("next",  do_snmpgetnext,
     "host passwd variables ...",
     "Does an snmpgetnext, returns the value");
  MonetMember_create
    ("set",  do_snmpset,
     "host passwd variable type value.",
     "Does an snmpset, the type is 'int|nul|nul|oid'");
  MonetMember_create
    ("list-traps",  do_list_traps,
     "",
     "Lists all known snmp traps");
  MonetMember_create
    ("trap2int",  do_trap2int,
     "name",
     "Given a name or number returns the trap number, returns -1 if unknown");
  MonetMember_create
    ("trap2name",  do_trap2string,
     "number",
     "Given a name or number returns the trap name");

  MonetConfig_create ("-trap", "snmp->traps", "true",
		      "Enable snmp traps");
  MonetProbe_snmp_trap_init ();
#endif /* CMU_SNMP */
}

extern void MonetProbe_snmp_finish ()
{
  MonetProbe_snmp_trap_finish ();
  
  Snmp_initialised = False;
}

/***************************************************************************/
/***************************************************************************/
/*  $Header$ */
/***************************************************************************/
/***************************************************************************/


