/***************************************************************************/
/***************************************************************************/
/*  $Header$  */
/***************************************************************************/
/***************************************************************************/
/*  The SNMPTRAP stuff is taken from 'snmptrapd' an application that */
/*  comes with   the cmu snmp stuff.  */
/*  !!! It is not tested although the makefiles have been */
/*  !!! altered for it.  I would like to first of all just get it to act like */
/*  !!! snmptrad, then use these traps usefully to report back to the mapper */
/***************************************************************************/

#include <monet/msh/General.h>
#include <monet/msh/Script.h>
#include <monet/msh/NiceSocket.h>
/*
 * snmptrap.c - send snmp traps to a network entity.
 *
 */
/***********************************************************
	Copyright 1989 by Carnegie Mellon University

                      All Rights Reserved

Permission to use, copy, modify, and distribute this software and its 
documentation for any purpose and without fee is hereby granted, 
provided that the above copyright notice appear in all copies and that
both that copyright notice and this permission notice appear in 
supporting documentation, and that the name of CMU not be
used in advertising or publicity pertaining to distribution of the
software without specific, written prior permission.  

CMU DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING
ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS, IN NO EVENT SHALL
CMU BE LIABLE FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR
ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS,
WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION,
ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS
SOFTWARE.
******************************************************************/

/*
#include <netinet/in.h>
#include <sys/socket.h>
*/
#include <netdb.h>
#include <stdio.h>
#include <sys/time.h>
#include <net/if.h>
#include <sys/ioctl.h>
#include <sys/file.h>
#include <nlist.h>

#include "snmpP.h"

extern int  errno;
extern int	snmp_dump_packet;

#define NUM_NETWORKS	16   /* max number of interfaces to check */

static oid objid_enterprise[] = {1, 3, 6, 1, 4, 1, 3, 1, 1};
static oid objid_sysdescr[] = {1, 3, 6, 1, 2, 1, 1, 1, 0};

static struct nlist nl[] = {
    { "_boottime" },
    { "" }
};


static int snmp_input (operation, session, reqid, pdu, magic)
     int operation;
     struct snmp_session *session;
     int reqid;
     struct snmp_pdu *pdu;
     void *magic;
{
}

#ifndef IFF_LOOPBACK
#define IFF_LOOPBACK 0
#endif
#define LOOPBACK    0x7f000001
static u_long
get_myaddr(){
    int sd;
    struct ifconf ifc;
    struct ifreq conf[NUM_NETWORKS], *ifrp, ifreq;
    struct sockaddr_in *in_addr;
    int count;
    int interfaces;		/* number of interfaces returned by ioctl */

    if ((sd = socket(AF_INET, SOCK_DGRAM, 0)) < 0)
	return 0;
    ifc.ifc_len = sizeof(conf);
    ifc.ifc_buf = (caddr_t)conf;
    if (ioctl(sd, SIOCGIFCONF, (char *)&ifc) < 0){
	close(sd);
	return 0;
    }
    ifrp = ifc.ifc_req;
    interfaces = ifc.ifc_len / sizeof(struct ifreq);
    for(count = 0; count < interfaces; count++, ifrp++){
	ifreq = *ifrp;
	if (ioctl(sd, SIOCGIFFLAGS, (char *)&ifreq) < 0)
	    continue;
	in_addr = (struct sockaddr_in *)&ifrp->ifr_addr;
	if ((ifreq.ifr_flags & IFF_UP)
	    && (ifreq.ifr_flags & IFF_RUNNING)
	    && !(ifreq.ifr_flags & IFF_LOOPBACK)
	    && in_addr->sin_addr.s_addr != LOOPBACK){
		close(sd);
		return in_addr->sin_addr.s_addr;
	    }
    }
    close(sd);
    return 0;
}

/*
 * Returns uptime in centiseconds(!).
 */
static long uptime(){
    struct timeval boottime, now, diff;
    int kmem;

    if ((kmem = open("/dev/kmem", 0)) < 0)
	return 0;
    nlist("/vmunix", nl);
    if (nl[0].n_type == 0){
	close(kmem);
	return 0;
    }
    
    lseek(kmem, (long)nl[0].n_value, L_SET);
    read(kmem, (char *) &boottime, sizeof(boottime));
    close(kmem);

    gettimeofday(&now, 0);
    now.tv_sec--;
    now.tv_usec += 1000000L;
    diff.tv_sec = now.tv_sec - boottime.tv_sec;
    diff.tv_usec = now.tv_usec - boottime.tv_usec;
    if (diff.tv_usec > 1000000L){
	diff.tv_usec -= 1000000L;
	diff.tv_sec++;
    }
    return ((diff.tv_sec * 100) + (diff.tv_usec / 10000));
}

static u_long parse_address(address)
    char *address;
{
    u_long addr;
    struct sockaddr_in saddr;
    struct hostent *hp;

    if ((addr = inet_addr(address)) != -1)
	return addr;
    hp = gethostbyname(address);
    if (hp == NULL){
	fprintf(stderr, "unknown host: %s\n", address);
	return 0;
    } else {
	bcopy((char *)hp->h_addr, (char *)&saddr.sin_addr, hp->h_length);
	return saddr.sin_addr.s_addr;
    }

}

MONETCALLBACK(do_snmp_trap)
     struct snmp_session session, *ss;
     struct snmp_pdu *pdu;
     struct variable_list *vars;
     char *gateway = NULL;
     char *community = NULL;
     char  *specific = NULL, *description = NULL, *agent = NULL;
     int port = SNMP_TRAP_PORT, trap;

     gateway = argv[1];
     community = argv[2];
     trap = MonetSnmpTrap2int (argv[3]);
     if (trap == -1) {
       MonetPrintfError ("No such trap [%s]", argv[3]);
       result = NULL;
       RETURNSC;
     }
     specific = argv[4];
     description = argv[5];
     if (argc == 8) {
       port = (int) MonetString2long (argv[6]);
       agent = argv[7];
     } else if (argc == 7) {
       if (argv[6] && isdigit (*argv[6])) {
	 port = atoi (argv[6]);
       } else {
	 agent = argv[6];
       }
     }

    if (!(gateway && community && specific && description)) {
      MonetPrintfError ("snmp-trap: One of the arguments is NULL");
      result = NULL;
      RETURNSC;
    }

    bzero((char *)&session, sizeof(struct snmp_session));
    session.peername = gateway;
    session.community = (u_char *)community;
    session.community_len = strlen((char *)community);
    session.retries = SNMP_DEFAULT_RETRIES;
    session.timeout = SNMP_DEFAULT_TIMEOUT;
    session.authenticator = NULL;
    session.callback = snmp_input;
    session.callback_magic = NULL;
    session.remote_port = port;
    ss = snmp_open(&session);
    if (ss == NULL){
	MonetPrintfError ("Couldn't open snmp for sending traps to port %d",
			  port);
	result = NULL;
	RETURNSC;
    }

    pdu = snmp_pdu_create(TRP_REQ_MSG);
    pdu->enterprise = (oid *)malloc(sizeof(objid_enterprise));
    bcopy((char *)objid_enterprise, (char *)pdu->enterprise,
	  sizeof(objid_enterprise));
    pdu->enterprise_length = sizeof(objid_enterprise) / sizeof(oid);
    if (agent != NULL)
	pdu->agent_addr.sin_addr.s_addr = parse_address(agent);
    else
	pdu->agent_addr.sin_addr.s_addr = get_myaddr();
    pdu->trap_type = trap;
    pdu->specific_type = atoi(specific);
    pdu->time = uptime();

    pdu->variables = vars = (struct variable_list *)
     malloc(sizeof(struct variable_list));
    vars->next_variable = NULL;
    vars->name = (oid *)malloc(sizeof(objid_sysdescr));
    bcopy((char *)objid_sysdescr, (char *)vars->name, sizeof(objid_sysdescr));
    vars->name_length = sizeof(objid_sysdescr) / sizeof(oid);
    vars->type = ASN_OCTET_STR;
    vars->val.string = (u_char *)malloc(strlen(description) + 1);
    strcpy((char *)vars->val.string, description);
    vars->val_len = strlen(description);

    if (snmp_send(ss, pdu)== 0){
	MonetPrintfError ("error sending trap pdu");
    }
     snmp_free_pdu (pdu);
     snmp_close(ss);
MONETEND

/***************************************************************************/
/*  Init and finish  */
/***************************************************************************/

extern void MonetProbe_snmp_trap_init ()
{
#ifdef CMU_SNMP
  MonetMember_create
    ("trap", do_snmp_trap,
     "host community trap-type specific-type device-description ?port ?agent",
     "Generates an snmp trap and sends it to a listening agent");
#endif /* CMU_SNMP */
}

extern void MonetProbe_snmp_trap_finish ()
{
#ifdef CMU_SNMP
#endif /* CMU_SNMP */
}

/***************************************************************************/
/***************************************************************************/
/*  $Header$ */
/***************************************************************************/
/***************************************************************************/


