/*****************************************************************************/
/*****************************************************************************/
/* $Header: //gaia/group.local/computer/monet/Xmonet/RCS/main.c,v 1.1 1991/03/26 12:00:14 a38 Exp a38 $ */
/*****************************************************************************/
/*  Defines some basic functions for monet script  */
/*****************************************************************************/

#include "stdP.h"
#include <monet/msh/ScriptTree.h>

/***************************************************************************/
/*  Log 2  */
/***************************************************************************/

MONETCALLBACK(do_log2)
     unsigned v;
     v = String2unsigned (argv[1]);
     if (v <= 0) {
       result = NULL;
     } else {
       result = unsigned2string (MonetLog2 (v));
     }
MONETEND

MONETCALLBACK(do_sqrt)
     unsigned v;
     v = String2unsigned (argv[1]);
     if (v < 0) {
       result = NULL;
     } else {
       result = unsigned2string (MonetSqrt (v));
     }
MONETEND

MONETCALLBACK(do_abs)
     int v;
     v = MonetString2int (argv[1]);
     result = Monetint2String (abs (v));
MONETEND

/***************************************************************************/
/*  Pusedo random number  */
/***************************************************************************/

MONETCALLBACK(do_random)
     if (argc > 1) {
       srandom (MonetString2int (argv[1]));
     }
     result = Monetlong2String (random ());
MONETEND

/***************************************************************************/
/*  Inc/Dec  */
/***************************************************************************/

SCRIPTENVIRONMENT(do_inc)
     long value;
     result = MonetTree_execute (arg_entity, arg->next, NULL);
     value = MonetString2long (result) + 1;
     result = Monetlong2String (value);
     MonetTree_assign (entity, arg, result);
MONETEND

SCRIPTENVIRONMENT(do_dec)
     long value;
     result = MonetTree_execute (arg_entity, arg->next, NULL);
     value = MonetString2long (result) - 1;
     result = Monetlong2String (value);
     MonetTree_assign (entity, arg, result);
MONETEND

/***************************************************************************/
/*  Compare operations  */
/***************************************************************************/

MONETCALLBACK(do_eq)
     if (! MonetStringsEqual (argv[1], argv[2])) {
       result = NULL;
     }
     MONETDEBUG(13, ( "[%s] == [%s], result [%s]", argv[1], argv[2],result));
MONETEND

MONETCALLBACK(do_neq)
     if (MonetStringsEqual (argv[1], argv[2])) {
       result = NULL;
     }
MONETEND

MONETCALLBACK(do_ge)
     if (MonetString2long(argv[1]) < MonetString2long(argv[2])) {
       result = NULL;
     }
MONETEND

MONETCALLBACK(do_le)
     if (MonetString2long(argv[1]) > MonetString2long(argv[2])) {
       result = NULL;
     }
MONETEND

MONETCALLBACK(do_gt)
     if (MonetString2long(argv[1]) <= MonetString2long(argv[2])) {
       result = NULL;
     }
MONETEND

MONETCALLBACK(do_lt)
     if (MonetString2long(argv[1]) >= MonetString2long(argv[2])) {
       result = NULL;
     }
MONETEND

/***************************************************************************/
/*  Arithmetic operations  */
/***************************************************************************/

MONETCALLBACK(do_unary_minus)
     result = Monetlong2String (- MonetString2long(argv[1]));
MONETEND

MONETCALLBACK(do_unary_plus)
     result = argv[1];
MONETEND

MONETCALLBACK(do_add)
     result = Monetlong2String (MonetString2long(argv[1]) +
			       MonetString2long(argv[2]));
MONETEND

MONETCALLBACK(do_modulo)
     result = Monetlong2String (MonetString2long(argv[1]) %
			       MonetString2long(argv[2]));
MONETEND

MONETCALLBACK(do_mul)
     result = Monetlong2String (MonetString2long(argv[1]) *
			       MonetString2long(argv[2]));
MONETEND

MONETCALLBACK(do_sub)
     result = Monetlong2String (MonetString2long(argv[1]) -
			       MonetString2long(argv[2]));
MONETEND

MONETCALLBACK(do_div)
     long divisor, value;
     if (divisor = MonetString2long(argv[2])) {
       value = MonetString2long(argv[1]) / divisor;
     } else {
       MonetScriptFail ("Divide by zero");
       value = 2<<31;
     }
     result = Monetlong2String (value);
MONETEND

/***************************************************************************/
/*  Logical Operations  */
/***************************************************************************/

MONETCALLBACK(do_not)
     if (Script_true (argv[1])) {
       result = NULL;
     }
MONETEND

SCRIPTENVIRONMENT(do_and)
    result = MonetTree_execute (arg_entity,arg, NULL);
    if (Script_true (result))
      result = MonetTree_execute (arg_entity,arg->next, NULL);
MONETEND

SCRIPTENVIRONMENT(do_or)
    result = MonetTree_execute (arg_entity,arg, NULL);
    if (Script_false (result))
      result = MonetTree_execute (arg_entity,arg->next, NULL);
MONETEND

/***************************************************************************/
/*  Bitwise functions  */
/***************************************************************************/

MONETCALLBACK(do_bit_and)
     result = Monetlong2String (MonetString2long (argv[1]) &
				MonetString2long (argv[2]));
MONETEND

MONETCALLBACK(do_bit_or)
     result = Monetlong2String (MonetString2long (argv[1]) |
				MonetString2long (argv[2]));
MONETEND

MONETCALLBACK(do_bit_xor)
     result = Monetlong2String (MonetString2long (argv[1]) ^
				MonetString2long (argv[2]));
MONETEND

MONETCALLBACK(do_bit_not)
     result = Monetlong2String ( ~ MonetString2long (argv[1]));
MONETEND

MONETCALLBACK(do_shift_left)
     result = Monetlong2String (MonetString2long (argv[1]) <<
				MonetString2long (argv[2]));
MONETEND

MONETCALLBACK(do_shift_right)
     result = Monetlong2String (MonetString2long (argv[1]) >>
				MonetString2long (argv[2]));
MONETEND

/*****************************************************************************/
/*  Init finish  */
/*****************************************************************************/

extern void monetsh_init_arith ()
{
  (void) MonetMember_module_class ("arith");

  MonetMember_create ( "random",		do_random,
		      "?seed",
"Uses random (3), generates pusedo random numbers \
in the range 0  to (2**31)-1");
  MonetMember_create ( "log2",		do_log2,
		      "num",
		      "Returns log2 of number, returns false if num <= 0");
  MonetMember_create ( "sqrt",		do_sqrt,
		      "num",
		      "Returns sqrt of number");
  MonetMember_create ( "abs",		do_abs,
		      "num",
		      "Returns abs of number");

  /*  Inc/Dec */
  MonetMember_create_environment ( "++",		do_inc,
		      "a",
		      "Increments 'a' by 1");
  MonetMember_create_environment ( "--",		do_inc,
		      "a",
		      "Decrements 'a' by 1");
  /*  Comparision */
  MonetMember_create ( "==",		do_eq,
		      "a b",
		      "Compares a and b for equality");
  MonetMember_create ( "!=",		do_neq,
		      "a b",
		      "Compares a and b for inequality");
  MonetMember_create ( "<=",		do_le,
		      "left right" ,"");
  MonetMember_create ( ">=",		do_ge,
		      "left right" ,"");
  MonetMember_create ( "<",		do_lt,
		      "left right" ,"");
  MonetMember_create ( ">",		do_gt,
		      "left right" ,"");
  /*  Arithmetic */
  MonetMember_create ( "+",		do_add,
		      "left right" ,"");
  MonetMember_create ( "-",		do_sub,
		      "left right" ,"");
  MonetMember_create ( "/",		do_div,
		      "left right" ,"");
  MonetMember_create ( "*",		do_mul,
		      "left right" ,"");
  MonetMember_create ( "%",		do_modulo,
		      "left right" ,"");
  MonetMember_create ( "unary-",		do_unary_minus,
		      "operand" ,"");
  MonetMember_create ( "unary+",		do_unary_plus,
		      "operand" ,"");
  /* Bitwise */
  MonetMember_create ( "&",		do_bit_and,
		      "left right" ,
		      "Bitwise 'and of its arguments");
  MonetMember_create ( "|",		do_bit_or,
		      "left right" ,
		      "Bitwise 'or' of its arguments");
  MonetMember_create ( "^",		do_bit_xor,
		      "left right" ,
		      "Bitwise 'xor' of its arguments");
  MonetMember_create ( "~",		do_bit_not,
		      "operand" ,
		      "Bitwise complenent of its arguments");
  MonetMember_create ( "<<",		do_shift_left,
		      "left right" ,
		      "Bitwise shift left");
  MonetMember_create ( ">>",		do_shift_right,
		      "left right" ,
		      "Bitwise shift left");
  
  /*  Logical */
  MonetMember_create ( "!",		do_not,
		      "condition",
		      "Returns the inverse of the condition");
  MonetMember_create_environment ( "||", do_or,
				  "left right",
				  "if <left> fails then execute <right>");
  MonetMember_create_environment ( "&&", do_and,
				  "left right",
				  "if <left> succeeds then execute <right>");
}

extern void monetsh_finish_arith ()
{
}

/*****************************************************************************/
/*****************************************************************************/
/* $Header: //gaia/group.local/computer/monet/Xmonet/RCS/main.c,v 1.1 1991/03/26 12:00:14 a38 Exp a38 $ */
/*****************************************************************************/
/*****************************************************************************/
