/*****************************************************************************/
/*****************************************************************************/
/* $Header: //gaia/group.local/computer/monet/Xmonet/RCS/main.c,v 1.1 1991/03/26 12:00:14 a38 Exp a38 $ */
/*****************************************************************************/
/*****************************************************************************/

#include "stdP.h"
#include <monet/msh/Context.h>
/*#include <monet/msh/Lib.h> */

/*****************************************************************************/
/*****************************************************************************/

static MonetEntity get_e (entity, arg)
     MonetEntity entity;
     MonetTree arg;
{
  String ent;

  ent = MonetTree_execute (entity, arg, NULL);
  if (MonetException_code () != MONETSH_OKAY) {
    return NULL;
  }
  if (ent) {
    if (entity = String2MonetEntity (ent)) {
    } else {
      MonetPrintfError ("No such entity [%s]", ent);
    }
  } else {
    MonetPrintfError ("Entity is null");
    entity = NULL;
  }
  return entity;
}

static MonetAttribute get_a (entity, arg)
     MonetEntity entity;
     MonetTree arg;
{
  MonetAttribute attribute;
  String ent;

  if (arg->type == lex_call_function) {
    ent = LNAME(arg);
  } else {
    ent = MonetTree_execute (entity, arg, NULL);
  }
  if (ent) {
    if (attribute = String2MonetAttribute (ent)) {
    } else {
      MonetPrintfError ("No such attribute [%s]", ent);
    }
  } else {
    MonetPrintfError ("Attribute is null");
    attribute = NULL;
  }
  return attribute;
}

/*****************************************************************************/
/*  Get attribute value of entity  */
/*****************************************************************************/

SCRIPTENVIRONMENT(do_member)
     MonetEntity qualifier;
     if (qualifier = get_e (entity, arg)) {
       result = MonetTree_execute_qualified
	 (entity, qualifier, arg->next, NULL);
     }
MONETEND

/***************************************************************************/
/*  assign  */
/***************************************************************************/

extern void MonetTree_assign (entity, arg, value)
     MonetEntity entity;
     MonetTree arg;
     char * value;
{
  MonetMember member;
  MonetStr id;

  if (arg->type == lex_get_attribute) {
    if (!(entity = get_e (entity, arg->arg))) {
      return;
    } else {
      id = arg->arg->next->id;
    }
  } else {
    id = arg->id;
  }

  if (member = MonetEntity_find_member (entity, id, &entity)) {
  } else {
    char * name;
    name = MonetStr2String (id);
    MonetParseWarning ("[%s] has not been declared, should use [var %s]",
		       name, name);
    member = MonetMember_create_local (name, value);
  }
  if (member) {
    MonetMember_assign (entity, member, value);
  }
}

/***************************************************************************/
/*  assign  */
/***************************************************************************/

SCRIPTENVIRONMENT(do_assign)
     result = MonetTree_execute (arg_entity, arg->next, NULL);
     MonetTree_assign (arg_entity, arg, result);
MONETEND

MONETCALLBACK(do_with)
     /* This could perfectly well be written as a script
	but it is convenient to do it here because
	exceptions are easier to ignore here.  They must be
	ignored so that the use stack can be emptied again */

     int i;
     MonetEntity e;
     for (i = 1; i < argc-1; ++i) {
       if (e = String2MonetEntity (argv[i])) {
	 MonetContext_use (e);
       } else {
	 MonetPrintfError ("No such entity [%s]", argv[i]);
       }
     }
     result = MonetshEntityExecute (entity, argv[argc-1], NULL, False);
     for (i = 1; i < argc-1; ++i) {
       if (e = String2MonetEntity (argv[i])) {
	 MonetContext_unuse (e);
       } else {
	 MonetPrintfError ("No such entity [%s]", argv[i]);
       }
     }
MONETEND

/*****************************************************************************/
/*  Set attribute value of entity  */
/*****************************************************************************/

MONETCALLBACK(do_unset)
     unsigned place;
     for (place = 1; place < argc; ++place) {
       MonetAttribute id;
       if (id = String2MonetAttribute (argv[place])) {
	 MonetEntity_delete_attribute(entity, id);
       } else {
	 MonetPrintfError ("No such attribute [%s]", argv[place]);
       }
     }
MONETEND

/*****************************************************************************/
/*  Create class/entity and set attributes of entity  */
/*****************************************************************************/

MONETCALLBACK (do_set)
     MonetEntity superclass ;
     String title, class_name = NULL;

     if (entity == NULL) {
       MonetPrintfError ("No entity");
       RETURNSC;
     }

     title = MonetEntity_title (entity);
     if (argc % 2 == 0) {
       /* Must be even number of arguments */
       MonetPrintfError ("Value of an attribute is missing, class [%s]",
			 title);
     } else {
       /* -- Put the arguments into arrays of attributes and values */
       /* -- If there are any problems then abort.                  */
       MonetAttribute id[MONET_MAX_ATTRIBUTES];
       String values [MONET_MAX_ATTRIBUTES];
       unsigned i, j;

       for (i = 1, j = 0; i < argc; i+=2) {
	 MonetAttribute attribute;
	 unsigned len = MonetStrlen (argv[i]);
	 if (len == 0) {
	   MonetPrintfError ("Attribute is null");
	   RETURNSC;
	 }
	 if (argv[i][len-1] == '=')
	   argv[i][len-1] = '\0';
	 if (attribute = String2MonetAttribute (argv[i])) {
	   if (MonetClassAttribute == attribute) {
	     class_name = argv[i+1];
	   } else {
	     id[j] = attribute;
	     values[j] = argv[i+1];
	     ++j;
	   }
	 } else {
	   MonetParseError ("set [%s]: No such attribute [%s]",
			     title, argv[i]);
	   RETURNSC;
	 }
       }
       if (class_name) {
	 if (superclass = String2MonetClass (class_name)) {
	   if (entity && MonetEntity_classOf(entity) != superclass) {
	     MonetParseError ("Can't change class of [%s] from [%s] to [%s]",
			       MonetEntity_title (entity),
			       MonetEntity_title
			       (MonetEntity_classOf (entity)),
			       class_name);
	     RETURNSC;
	   }
	 } else {
	   MonetPrintfError ("No such class [%s]", class_name);
	   RETURNSC;
	 }
       }
       id[j] = NULL;
       values[j] = NULL;
       MonetEntity_set_attributes (entity, id, values);
     }
MONETEND

/***************************************************************/
/*  Help on all entities  */
/***************************************************************/

MONETCALLBACK(do_help_entities)
     MonetEntity e;
     FORALL(e, Entities, next) {
	MonetPrintfnl ("[Entity %s]", MonetEntity_title (e));
    }
MONETEND

/*****************************************************************************/
/*  Create an entity class   */
/*****************************************************************************/

SCRIPTENVIRONMENT(do_class)
     MonetEntity superclass, givenclass ;
     String string, title;
     MonetBool isclass;

     string = LNAME(arg);
     givenclass = String2MonetClass (LNAME(arg->next));
     if (! givenclass) {
       MonetPrintfError ("No such class [%s]", LNAME(arg->next));
       result = NULL;
       RETURNSC;
     }
     entity = parse_title (string, &title, &superclass, &isclass);
     if (entity && (givenclass != superclass)) {
       MonetPrintfError ("Can't change class of [%s] from [%s] to [%s]",
			 MonetEntity_title (entity),
			 MonetEntity_title (superclass),
			 MonetEntity_title (givenclass));
     } else if (entity == NULL && title == NULL) {
       MonetPrintfError ("[%s] is not a valid entity name", string);
     } if (! isclass) {
       MonetPrintfError ("[%s] is not the name of a class", string);
     } else if (!title && !entity) {
       MonetPrintfError ("[%s] is not the name of a class", string);
     } else {
       /* -- Create the new entity class and then set all the values */
       /* -- in one go.  */
       if (! entity) {
	 if (entity = MonetEntity_create_class (givenclass, title))
	   MonetLibrary_register (entity);
       }
       if (entity) {
	 MonetMember_deeper ();
	 (void) MonetTree_execute (entity,arg->next->next, NULL);
	 MonetMember_shallower ();
       } else {
	 MonetPrintfError ("Could not create class/entity [%s]", string);
       }
     }
MONETEND

MONETCALLBACK(do_rename)
     MonetEntity_rename (String2MonetEntity (argv[1]), argv[1]);
MONETEND

/***************************************************************************/
/*  Check if name is defined  */
/***************************************************************************/

MONETCALLBACK(do_defined)
     MonetMember member;
     MonetStr id;

     if (argc==3) {
       if (id = String2MonetStr (argv[2])) {
	 MonetEntity e;
	 if (e = String2MonetEntity (argv[1])) {
	   member = MonetEntity_qualified_member (e, id);
	 } else {
	   MonetPrintfError ("No such entity [%s]", argv[1]);
	   member = NULL;
	 }
       }
     } else if (id = String2MonetStr (argv[1])) {
       member = MonetEntity_find_member (entity, id, NULL);
     }
     if (!id || !member) {
       result = NULL;
     }
MONETEND

MONETCALLBACK(do_which)
     MonetEntity which;
     MonetStr id;
     if ((id = String2MonetStr (argv[1])) &&
	 MonetEntity_find_member (entity, id, &which)) {
       result = MonetEntity_title (which);
     } else {
       result = NULL;
     }
MONETEND

MONETCALLBACK(do_documentation)
     MonetEntity which;
     MonetMember member;
     MonetStr id;
     if ((id = String2MonetStr (argv[1])) &&
	 (member = MonetEntity_find_member (entity, id, &which))) {
       result = MonetMember_documentation (member);
     } else {
       result = NULL;
     }
MONETEND

MONETCALLBACK(do_declaration)
     MonetEntity which;
     MonetMember member;
     MonetStr id;
     if ((id = String2MonetStr (argv[1])) &&
	 (member = MonetEntity_find_member (entity, id, &which))) {
       result = MonetMember_declaration (member);
     } else {
       result = NULL;
     }
MONETEND

/***************************************************************************/
/*  The current/this/self entity  */
/***************************************************************************/

MONETCALLBACK(do_current_entity)
     if (entity) {
       result = MonetEntity_title (entity);
     } else {
       result = NULL;
     }
MONETEND

/***************************************************************************/
/* Libraries */
/***************************************************************************/

MONETCALLBACK(do_library_begin)
     if (MonetStrlen (argv[1]) == 0) {
       MonetPrintfError ("Name is empty");
     } else if (MonetStrlen (argv[1]) == 0) {
       MonetPrintfError ("Short description is empty");
     } else {
       MonetLibrary_begin (monetmsh, argv[1], argv[2]);
     }
MONETEND

MONETCALLBACK(do_library_done)
     MonetLibrary_done ();
MONETEND

MONETCALLBACK(do_library_print)
     MonetLibrary_print ();
MONETEND

/*****************************************************************************/
/*  Init finish  */
/*****************************************************************************/

extern void monetsh_init_entity ()
{
  (void) MonetMember_module_class ("library");

  MonetMember_create ("begin",		do_library_begin,
		      "name short-description",
		      "Creates a library, all classes defined until \
'library->done' is called, will be registered with this library.");

  MonetMember_create ("done",		do_library_done,
		      "",
		      "Closes library begun by previous library->begin.");

  MonetMember_create ("print",		do_library_print,
		      "",
		      "Prints out each define library followed by a list \
of its classes, one per line.  This is for making reference manuals.");

  (void) MonetMember_module_class ("Top");

  MonetMember_create ("defined",		do_defined,
		      "?entity member",
		      "Returns true if function/var/attribute is defined \
if entity is specified, just checks that entity");

  MonetMember_create ("which",		do_which,
		      "member",
		      "If 'member' where executed now, returns which entity \
'member' was a member of.");

  MonetMember_create ("declaration",  do_declaration,
		      "member",
		      "returns declaration of member");

  MonetMember_create ("documentation",  do_documentation,
		      "member",
		      "returns documentation of member");

  MonetMember_create_environment ( "->", do_member,
				  "entity instruction" ,
				  "access function or var in entity");
  MonetMember_create_environment ( ".", do_member,
				  "entity instruction" ,
				  "access function or var in entity");
  MonetMember_create_environment ( ",", do_member,
				  "entity instruction" ,
				  "access function or var in entity");
  MonetMember_create_environment ( "=",	do_assign,
				  "target value" ,
				  "Assign 'value' to 'target'");
  MonetMember_create ("with",		do_with,
		      "entity ... instruction" ,
	      "Temporarily 'use' entities while executing the instruction.");
  MonetMember_create ("set",  do_set,
		      "?attribute-value ...",
		      "Create an entity and set its attributes");
  MonetMember_create ("unset",  do_unset,
		      "?attribute ...",
		      "Unset attributes of an entity");
  MonetMember_create ("help-entities",		do_help_entities,
		      "",
		      "lists all defined entities");
 MonetMember_create_environment ("class", do_class,
		      "name class sequence",
		      "Declare a class");
  MonetMember_create ("rename",		do_rename,
		      "name",
		      "Rename an entity");
  MonetMember_create ( "entity",       	do_current_entity,
		      "" ,
	      "The current (self/this) entity, always one current entity");

}

extern void monetsh_finish_entity ()
{
}

/*****************************************************************************/
/*****************************************************************************/
/* $Header: //gaia/group.local/computer/monet/Xmonet/RCS/main.c,v 1.1 1991/03/26 12:00:14 a38 Exp a38 $ */
/*****************************************************************************/
/*****************************************************************************/


