/*****************************************************************************/
/*****************************************************************************/
/* $Header: //gaia/group.local/computer/monet/Xmonet/RCS/main.c,v 1.1 1991/03/26 12:00:14 a38 Exp a38 $ */
/*****************************************************************************/
/*  Defines some basic functions for monet script  */
/*****************************************************************************/

#include "stdP.h"

/*****************************************************************************/
/*  File handling  */
/*****************************************************************************/

MONETCALLBACK(do_file_exists)
     if ( ! MonetFileExists (argv[1])) {
       result = NULL;
     }
MONETEND

/*****************************************************************************/
/*  Full File name  */
/*****************************************************************************/

MONETCALLBACK(do_pathname)
     result = MonetFilename (argv[1]);
MONETEND

/***************************************************************************/
/* Make a temporary filename  */
/***************************************************************************/

MONETCALLBACK(do_tempfilename)
     static char * name_template = NULSTR;
     char * name;

     if (argc == 1 || argv[1] == NULL) {
       name = "";
     } else {
       name = argv[1];
     }
     MonetFree (name_template);
     if (name_template = (char *) MonetMalloc (MonetStrlen (name) + 6 + 1)) {
       (void) sprintf (name_template, "%sXXXXXX", name);
       if (mktemp(name_template)) {
	 result = name_template;
       } else {
	 result = NULL;
       }
     } else {
       result = NULL;
     }
MONETEND

/*****************************************************************************/
/*  Init finish  */
/*****************************************************************************/

extern void monetsh_init_file ()
{
  (void) MonetMember_module_class ("file");

  MonetMember_create ( "exists",		do_file_exists,
		      "filename",
		      "returns true if the given file exists");
  MonetMember_create ( "path",		do_pathname,
		      "?filename",
		      "Returns the full pathname of a file");
  MonetMember_create ( "temp",		do_tempfilename,
		      "?prefix",
		      "Creates a unique name for a temporary file, \
		      the pathname will be prefixed by 'prefix'");
}

extern void monetsh_finish_file ()
{
}

/*****************************************************************************/
/*****************************************************************************/
/* $Header: //gaia/group.local/computer/monet/Xmonet/RCS/main.c,v 1.1 1991/03/26 12:00:14 a38 Exp a38 $ */
/*****************************************************************************/
/*****************************************************************************/
