/*****************************************************************************/
/*****************************************************************************/
/* $Header: //gaia/group.local/computer/monet/Xmonet/RCS/main.c,v 1.1 1991/03/26 12:00:14 a38 Exp a38 $ */
/*****************************************************************************/
/*  Defines some basic information monet stuff  */
/*****************************************************************************/

#include "stdP.h"

/***************************************************************************/
/*  Some messages */
/***************************************************************************/

MONETCALLBACK(do_version)
     MonetVersion ();
MONETEND

MONETCALLBACK(do_debug)
     String name = argv[1];
     if (EQS (name, "off")) {
       MonetPrintfnl ("Setting debug off");
       Monet_debug_on (0);
     } else if (EQS (name, "on")) {
       MonetPrintfnl ("Setting debug on");
       Monet_debug_on (1);
     } else if (argc >= 2) {
       unsigned level = (unsigned) String2unsigned (name);
       MonetPrintfnl ("Setting debug [%d]", level);
       Monet_debug_on (level);
     }
     result = Monetint2String (Monet_debug());
MONETEND

MONETCALLBACK(do_write_debug)
     String message;
     int level;

     level = MonetString2int (argv[1]);
     message = MonetJoinStrings (argc-2, argv+2, " ");
     MONETDEBUG(level, (message));
MONETEND

MONETCALLBACK(do_copyright_message)
     MonetCopyright ();
MONETEND

/***********************************************************************/
/*  Access some system options  */
/***********************************************************************/

MONETCALLBACK(do_software_author)
     result = Monet_software_author ();
MONETEND

MONETCALLBACK(do_software_contact)
     result = Monet_software_contact ();
MONETEND

MONETCALLBACK(do_software_source)
     result = Monet_software_source ();
MONETEND

MONETCALLBACK(do_software_title)
     result = Monet_software_title ();
MONETEND

MONETCALLBACK(do_software_version)
     result = Monet_software_version ();
MONETEND

MONETCALLBACK(do_system_name)
     result = Monet_system_type ();
MONETEND

MONETCALLBACK(do_program_name)
     result = Monet_program_name ();
MONETEND

MONETCALLBACK(do_monet_directory)
     result = Monet_dir (argv[1]);
MONETEND

MONETCALLBACK(do_user_home_dir)
     result = Monet_home_dir (argv[1]);
MONETEND

MONETCALLBACK(do_user_address)
     result = Monet_user_address (argv[1]);
MONETEND

MONETCALLBACK(do_user_id)
     result = Monet_user_id ();
MONETEND

MONETCALLBACK(do_local_host)
     result = Monet_host_name ();
MONETEND


MONETCALLBACK(do_set_short)
     static char buf[2];
     if (argv[1]) {
       buf [0] = MonetLex_set_short_get (*argv[1]);
     } else {
       buf [0] = MonetLex_set_short_get ('\0');
     }
     buf [1] = '\0';
     result = buf;
MONETEND

/*****************************************************************************/
/*  Init finish  */
/*****************************************************************************/

extern void monetsh_init_monet ()
{
  (void) MonetMember_module_class ("config");

  MonetMember_create ( "copyright",		do_copyright_message,
		      "",
		      "copyright message");
  MonetMember_create ( "version",		do_version,
		      "",
		      "which version of the software");
  MonetMember_create ( "debug",		do_debug,
		      "?on|off|#",
		      "set debugging mode on or off");
  MonetMember_create ( "write-debug",		do_write_debug,
		      "level message ...",
		      "Write a debug message");
  MonetMember_create ("software-source", do_software_source,
		      "",
		      "Where Monet Software is available from");
  MonetMember_create ( "software-contact", do_software_contact,
		      "",
		      "Who to contact in case");
  MonetMember_create ( "software-author", do_software_author,
		      "",
		      "Author of Monet");
  MonetMember_create ( "software-version", do_software_version,
		      "",
		      "Current Version of the software");
  MonetMember_create ( "software-title", do_software_title,
		      "",
		      "Name of the package");
  MonetMember_create ( "program-name", do_program_name,
		      "",
		      "Name of the program");
  MonetMember_create ( "system-name", do_system_name,
		      "",
		      "Type of system");
  MonetMember_create ("monet-dir", do_monet_directory,
		      "?dir",
		      "System directory");
  MonetMember_create ( "home-dir", do_user_home_dir,
		      "?dir",
		      "The user home directory");
  MonetMember_create ( "user-id", do_user_id,
		      "",
		      "User id of the user");
  MonetMember_create ( "host-name", do_local_host,
		      "",
		      "Name of the local host");
  MonetMember_create ( "user-address", do_user_address,
		      "?address",
		      "The users (e-)mail address");
  MonetMember_create ( "short-get", do_set_short,
		      "char",
		      "If char is '.' ',', then it can be used in place of ->,\
		      returns the previous value,");
  MonetConfig_create ("-short", "config->short-get", ".",
		      "'.' or ',' can be used in place of ->");
  MonetConfig_create ("-dir", "config->monet-dir", NULSTR,
		      "Where to look for run time specific files");
  MonetConfig_create ("-startup", "startup-file", NULSTR,
		      "The name of the startup file");
  MonetConfig_create ("-home", "config->home-dir", NULSTR,
		      "The user home directory, if not ~");
  MonetConfig_create ("-debug", "config->debug", "on",
		      "Switches on debugging -debug [on|off|num]");
  MonetConfig_create ("-email", "config->user-address", NULSTR,
		      "Sets the users email address.");
}

extern void monetsh_finish_monet ()
{
}

/*****************************************************************************/
/*****************************************************************************/
/* $Header: //gaia/group.local/computer/monet/Xmonet/RCS/main.c,v 1.1 1991/03/26 12:00:14 a38 Exp a38 $ */
/*****************************************************************************/
/*****************************************************************************/
