/*****************************************************************************/
/*****************************************************************************/
/* $Header: //gaia/group.local/computer/monet/Xmonet/RCS/main.c,v 1.1 1991/03/26 12:00:14 a38 Exp a38 $ */
/*****************************************************************************/
/*  Defines some basic functions for monet script  */
/*****************************************************************************/

#include "stdP.h"
#include <monet/msh/NiceSocket.h>

/***************************************************************************/
/***************************************************************************/

MONETCALLBACK(do_create)
     int s, domain, type, protocol;
     domain = AF_INET;
     type = SOCK_STREAM;
     protocol = 0;
     s = socket (domain, type, protocol);
     result = Monetint2String (s);
MONETEND

MONETCALLBACK(do_accept)
     int	sock, s, addrlen;
     struct	sockaddr_in addr;

     sock = MonetString2int (argv[1]);
     bzero((char *) &addr, sizeof(addr));
     addrlen = sizeof (addr);
     s = accept(sock, (struct sockaddr *) &addr, &addrlen);
     if (s < 0) {
       s = -errno;
     }
     result = Monetint2String (s);
MONETEND

MONETCALLBACK(do_bind)
     int	sock, s, port;
     struct	sockaddr_in server;

     sock = MonetString2int (argv[1]);
     port = MonetString2int (argv[2]);
     bzero((char *) &server, sizeof(server));
     server.sin_family = AF_INET;
     server.sin_addr.s_addr = INADDR_ANY;
     server.sin_port = htons(port);

     s = bind(sock, (struct sockaddr *) &server, sizeof(server));
     result = Monetint2String (s);
MONETEND

MONETCALLBACK(do_readable)
     int  sock;
     sock = MonetString2int (argv[1]);
     if (!readable (sock)) {
       result = NULSTR;
     }
MONETEND

MONETCALLBACK(do_connect)
     int	sock, cc, port;
     char * host;
     struct	sockaddr_in server;
     struct	hostent *hp;

     sock = MonetString2int (argv[1]);
     host = argv[2];
     port = MonetString2int (argv[3]);

     if (!host) {
       host = "localhost";
     }
     bzero((char *) &server, sizeof(server));
     server.sin_family = AF_INET;
     server.sin_port = htons(port);

     if (isdigit(host[0])) {
       server.sin_addr.s_addr = inet_addr(host);
     } else {
       hp = gethostbyname(host);
       if (hp == NULL) {
	 result = "-9999";
	 RETURNSC;
       }
       bcopy(hp->h_addr, &server.sin_addr, hp->h_length);
     }

     cc = connect(sock, (struct sockaddr *) &server, sizeof(server));
     if (cc < 0) {
       cc = -errno;
     }
     result = Monetint2String (cc);
MONETEND

MONETCALLBACK(do_listen)
     int	sock, backlog, s;
     sock    = MonetString2int (argv[1]);
     backlog = MonetString2int (argv[2]);
     s = listen (sock, backlog);
     result = Monetint2String (s);
MONETEND

MONETCALLBACK(do_read)
     int len;

     len  = MonetString2int (argv[2]);
     if (len < 0) {
       MonetPrintfError ("Len is < 0 [%d]", len);
       result = NULSTR;
     } else {
       int	sock, cc;
       static char * data = NULSTR;
       sock = MonetString2int (argv[1]);
       if (data) {
	 MonetFree (data);
       }
       data = MonetMalloc (len + 1);
       cc = read (sock, data, len);
       if (cc <= 0) {
	 MonetFree (data);
	 data = NULSTR;
	 result = NULSTR;
       } else {
	 data[cc] = '\0';
	 result = data;
       }
     }
MONETEND

MONETCALLBACK(do_write)
     int	sock, cc, len, datalen;
     char * data;

     sock = MonetString2int (argv[1]);
     data = argv[2];
     datalen = MonetStrlen (data);
     if (argc == 4) {
       len = MonetString2int (argv[3]);
       if (len > datalen)
	 len = datalen;
     } else {
       len = datalen + 1;
     }
     cc = write (sock, data, len);
     result = Monetint2String (cc);
MONETEND

MONETCALLBACK(do_close)
     int	sock, cc;
     sock    = MonetString2int (argv[1]);
     cc = close (sock);
     result = Monetint2String (cc);
MONETEND

MONETCALLBACK(do_shutdown)
     int	sock, cc, how;
     sock = MonetString2int (argv[1]);
     how  = MonetString2int (argv[2]);
     cc = shutdown (sock, how);
     result = Monetint2String (cc);
MONETEND

/*****************************************************************************/
/*  Init finish  */
/*****************************************************************************/

extern void monetsh_init_socket ()
{
  (void) MonetMember_module_class ("socket");

  MonetMember_create ( "create",		do_create,
		      "",
		      "Creates a new socket, by default selects AF_INET");

  MonetMember_create ( "accept",		do_accept,
		      "socket",
		      "Accepts a previously bound socket connection \
and returns 0 if okay and -errno if not okay");

  MonetMember_create ( "bind",		do_bind,
		      "socket port",
		      "Binds a name to an unnamed socket");

  MonetMember_create ( "readable",		do_readable,
		      "socket",
		      "Succeeds if there is something to read on the socket.");

  MonetMember_create ( "connect", do_connect,
		      "socket host port",
		      "Connects a socket.  Returns 0 if okay otherwise, \
returns -errno, -9999 if no such host.");

  MonetMember_create ( "listen", do_listen,
		      "socket backlog",
		      "Listen on a socket for new connections.");

  MonetMember_create ( "read",		do_read,
		      "socket len",
		      "Reads <len> bytes from socket.");

  MonetMember_create ( "write",		do_write,
		      "socket data ?length",
		      "Write to a socket, if no length given then \
sends all of data followed by char 0.  If length is greater than actual \
data lenght then only the exact amount of data is sent. ");

  MonetMember_create ( "close", do_close,
		      "socket",
		      "Closes a socket.");

  MonetMember_create ( "shutdown", do_shutdown,
		      "how",
		      "Shutdown a socket, if how = 0 receives disabled, \
how = 1, sends disabled, how = 2, sends & receives disabled.");

}

extern void monetsh_finish_socket ()
{
}

/*****************************************************************************/
/*****************************************************************************/
/* $Header: //gaia/group.local/computer/monet/Xmonet/RCS/main.c,v 1.1 1991/03/26 12:00:14 a38 Exp a38 $ */
/*****************************************************************************/
/*****************************************************************************/
