/*****************************************************************************/
/*****************************************************************************/
/* $Header: //gaia/group.local/computer/monet/Xmonet/RCS/main.c,v 1.1 1991/03/26 12:00:14 a38 Exp a38 $ */
/*****************************************************************************/
/*  Defines some basic functions for monet script  */
/*****************************************************************************/

#include "stdP.h"

/*****************************************************************************/
/*  Format strings  */
/*****************************************************************************/

MONETCALLBACK(do_uptime_string)
     result = Monet_uptime_string (MonetString2long (argv[1]));
MONETEND

/*****************************************************************************/
/*  Join strings  */
/*****************************************************************************/

MONETCALLBACK(do_concat)
     result = MonetJoinStrings (argc-1, argv+1, NULL);
MONETEND

/*****************************************************************************/
/*  Shorten a string label  */
/*****************************************************************************/

MONETCALLBACK(do_abbrev)
     result = MonetShortLabel (argv[1]);
MONETEND

/*****************************************************************************/
/*  Is a word in a string */
/*****************************************************************************/

MONETCALLBACK(do_word_in_string)
     if (! MonetWordInString (argv[1], argv[2])) {
       result = NULSTR;
     }
MONETEND

/*****************************************************************************/
/*  Print formatted text  */
/*****************************************************************************/

MONETCALLBACK(do_print_text)
     MonetPrintText (argv[1], 70, MonetJoinStrings (argc-2, argv+2, NULL));
MONETEND

/*****************************************************************************/
/*  Convert to lower case  */
/*****************************************************************************/

MONETCALLBACK(do_lower)
     static char * buf = NULL;
     MonetFree (buf);
     if (argv [1]) {
       buf = MonetNewString (argv[1]);
       MonetStringToLowerCase (buf);
     } else {
       buf = NULL;
     }
     result = buf;
MONETEND

/*****************************************************************************/
/*  Remove suffix from string  */
/*****************************************************************************/

MONETCALLBACK(do_remove_suffix)
     char * string, * suffix;
     int stl, sfl;
     static char * Short = NULL;

     if ((string = argv[1]) && (suffix = argv[2])
	 && (stl = strlen (string)) && (sfl = strlen (suffix))
	 && (sfl <= stl) && (EQS(suffix, string + stl - sfl))) {
       MonetFree (Short);
       Short = MonetMalloc (stl-sfl+1);
       strncpy (Short, string, stl-sfl);
       Short [stl-sfl] = '\0';
     } else {
       MonetFree (Short);
       Short = NULL;
     }
     result = Short;
MONETEND


/*****************************************************************************/
/*  Extract sections of a string  */
/*****************************************************************************/

MONETCALLBACK(do_sprintf)
     char * format = argv[1], * put;
     int argnum;
     static char buf[2048];

     if (format) {
       buf[0] = '\0';
       for (argnum = 2, put = buf; *format; ++format) {
	 long num;
	 double dub;
	 if (*format == '%') {
	   String arg;
	   if (argnum >= argc) {
	     arg = "";
	   } else if (argv[argnum] == NULL) {
	     arg = "";
	   } else {
	     arg = argv[argnum];
	     ++argnum;
	   }
	   ++format;
	   switch (*format) {
	   case '%':
	     *put = *format;
	     ++put;
	     break;
	   case 's':
	     put = MonetStringCopyToEnd (put, arg);
	     break;
	   case 'c':
	     *put = *arg;
	     ++put;
	     break;
	   case 'd':
	     (void) sscanf  (arg, "%ld", &num);
	     (void) sprintf (put, "%ld", num);
	     put += MonetStrlen (put);
	     break;
	   case 'u':
	     (void) sscanf (arg, "%lu", &num);
	     (void) sprintf (put, "%lx", num);
	     put += MonetStrlen (put);
	     break;
	   case 'x':
	     (void) sscanf (arg, "%lx", &num);
	     (void) sprintf (put, "%lx", num);
	     put += MonetStrlen (put);
	     break;
	   case 'o':
	     (void) sscanf (arg, "%lx", &num);
	     (void) sprintf (put, "%lx", num);
	     put += MonetStrlen (put);
	     break;
	   case 'f':
	     (void) sscanf (arg, "%lf", &dub);
	     (void) sprintf (put, "%lf", dub);
	     put += MonetStrlen (put);
	     break;
	   default:
	     MonetPrintfWarning ("%s: do not know option [%%%c] [%s]",
				 argv[0], *format, argv[1]);
	     break;
	   }
	 } else if (*format == '\\') {
	   ++format;
	   switch (*format) {
	   case 't':
	     *put = '\t';
	     break;
	   case 'n':
	     *put = '\n';
	     break;
	   case 'r':
	     *put = '\r';
	     break;
	   default:
	     *put = *format;
	     break;
	   }
	   ++put;
	 } else {
	   *put = *format;
	   ++put;
	 }
       }
       result = buf;
       *put = '\0';
     } else {
       result = NULL;
     }
MONETEND

/*****************************************************************************/
/*  Extract sections of a string  */
/*****************************************************************************/

MONETCALLBACK(do_left_string)

MONETEND

/*****************************************************************************/
/*  Access array  */
/*****************************************************************************/
/*
MONETCALLBACK(do_array)

MONETEND
*/
/*****************************************************************************/
/*  Find the n'th word is a string, words are seperated by a specified  */
/*  character  */
/*****************************************************************************/

MONETCALLBACK(do_section)
     char sep;
     int place;
     if (argc == 4 && argv[2]) {
       sep = argv[3][0];
     } else {
       sep = '\n';
     }
     place = MonetString2int (argv[2]);
     if (place <= 0) {
       return NULL;
     } else {
       result = MonetStringSection (argv[1], sep, (unsigned) place);
     }
MONETEND

/*****************************************************************************/
/*  Wildcard compare operations  */
/*****************************************************************************/

MONETCALLBACK(do_printable)
     static char buf [1024]; /* !!! */
     (void) MonetString2PrintString (buf, argv[1], sizeof (buf));
     result = buf;
MONETEND

/*****************************************************************************/
/*  Wildcard compare operations  */
/*****************************************************************************/

MONETCALLBACK(do_wildcard_eq)
     if (! MonetMatchWildcard (argv[1], argv[2])) {
       result = NULL;
     }
MONETEND

MONETCALLBACK(do_wildcard_neq)
     if (MonetMatchWildcard (argv[1], argv[2])) {
       result = NULL;
     }
MONETEND

/*****************************************************************************/
/*  Extract words from sentence  */
/*****************************************************************************/

MONETCALLBACK(do_next_word)
     if (result = MonetNextWord (argv[1])) {
       int len;
       char * last;
       static char * buf = NULL;
       if (buf) {
	 MonetFree (buf);
       }
       last = MonetEndOfWord (result);
       len = last - result;
       buf = (char *) malloc (len+1);
       (void) strncpy (buf, result, len);
       buf [len] = '\0';
       result = buf;
     }
MONETEND

MONETCALLBACK(do_after_word)
     if (result = MonetNextWord (argv[1])) {
       if ((result = MonetEndOfWord (result)) && *result) {
	 ++result;
       }
     }
MONETEND

MONETCALLBACK(do_strlen)
     result = unsigned2string (MonetStrlen (argv[1]));
MONETEND

MONETCALLBACK(do_remove_bracket)
     static char * buf = NULL;

     MonetFree (buf);
     buf = NULL;
     if (argv[1] && *argv[1] == '(') {
       char *cp;
       for (cp = argv[1]+1; *cp; ++cp);
       if (*(cp-1) == ')')  {
	   int len = cp - argv[1];
	   buf = MonetNewString (argv[1]+1);
	   buf [len-2] = '\0';
	 }
     }
     result = buf;
MONETEND

/*****************************************************************************/
/*  Init finish  */
/*****************************************************************************/

extern void monetsh_init_string ()
{
  (void) MonetMember_module_class ("string");

  MonetMember_create
    ( "print-indented",		do_print_text,
     "indent text ...",
     "prints text formatted on multiple lines, each \
line beginning with 'indent'.  Adds fullstop at end and capitalises \
first letter");
  MonetMember_create ( "strlen",		do_strlen,
		      "string",
		      "Returns the number of characters in its argument");
  MonetMember_create ( "remove-bracket",		do_remove_bracket,
		      "string",
		      "Removes one level of surrounding ( )");
  MonetMember_create ( "lower",		do_lower,
		      "string",
		      "Returns lower case version of 'string'");
  MonetMember_create ( "=~",		do_wildcard_eq,
		      "a p",
		      "a matches pattern p");
  MonetMember_create ( "!~",		do_wildcard_neq,
		 	"a p",
		      "a does not match pattern p");
  MonetMember_create ( "left",		do_left_string,
			    "string #",
		      "");
  MonetMember_create ( "concat",		do_concat,
			    "string ..." ,
		      "Concatinates its arguments");
  MonetMember_create ( "printable",		do_printable,
			    "string" ,
			    "Returns 'string' but in printable format, \
with special characters and quotes escaped");
  MonetMember_create ( "section",		do_section,
			    "string index ?sep",
"Treats 'string' as a list with 'sep' between entries,\
returns entry number 'index', '\\n' is default");
  MonetMember_create ( "uptime",		do_uptime_string,
			    "seconds",
		      "Returns formatted uptime");
  MonetMember_create ( "sprintf",		do_sprintf,
			    "format ...",
		      "Simple 'sprintf', supports %s %d %f %o %x %c");
  MonetMember_create ( "abbrev",		do_abbrev,
			    "string",
			    "Find an abbreviation for a string \
fails if nothing shorter is found");
  MonetMember_create ( "remove-suffix",		do_remove_suffix,
		      "string suffix",
		      "Remove suffix from string if possible \
return false if not possible");
  MonetMember_create ( "next-word",		do_next_word,
		      "string",
		      "Returns the first word in a sentence\
Words are printable characters surrounded by spaces");
  MonetMember_create ( "after-word",		do_after_word,
		      "string",
		      "Returns rest of the sentance following its first word\
Words are printable characters surrounded by spaces.");
  MonetMember_create ( "word-in-string", do_word_in_string,
		      "word string",
		      "Searches <string> for words, character sequences, \
surrounded by whitespace.  If one of these words matches <word> then the \
function succeeds.");
}

extern void monetsh_finish_string ()
{
}

/*****************************************************************************/
/*****************************************************************************/
/* $Header: //gaia/group.local/computer/monet/Xmonet/RCS/main.c,v 1.1 1991/03/26 12:00:14 a38 Exp a38 $ */
/*****************************************************************************/
/*****************************************************************************/
