/*****************************************************************************/
/*****************************************************************************/
/* $Header: //gaia/group.local/computer/monet/Xmonet/RCS/main.c,v 1.1 1991/03/26 12:00:14 a38 Exp a38 $ */
/*****************************************************************************/
/*  Defines some basic functions specific to sun  */
/*****************************************************************************/

#include "stdP.h"

MONET_EXTERN_BEGIN

extern int getdomainname
  PR((char *name, int namelen));

MONET_EXTERN_END


/***************************************************************************/
/*  debugging  */
/***************************************************************************/

#ifdef  DebugMalloc
extern MonetBool MonetMallocVerify ()
{
  if (malloc_verify ()) {
    MonetPrintfInform ("Malloc verify worked okay");
    return True;
  }
  MonetPrintfInform ("Malloc verify failed");
  return False;
}

MONETCALLBACK(do_mallocmap)
     mallocmap ();
MONETEND

MONETCALLBACK(do_malloc_debug)
     malloc_debug (atoi (argv[1]));
MONETEND

MONETCALLBACK(do_malloc_verify)
     (void) MonetMallocVerify ();
MONETEND

#endif

/***************************************************************************/
/*  Host name to address stuff  */
/***************************************************************************/

MONETCALLBACK(do_get_domain_name)
     char name [65];
     if (getdomainname(name, sizeof(name)) == 0) {
       result = name;
     } else {
       result = NULL;
     }
MONETEND

MONETCALLBACK(do_tempnam)
     result = tempnam (argv[1], argv[2]);
MONETEND

/*****************************************************************************/
/*  Init finish  */
/*****************************************************************************/

extern void monetsh_init_sun ()
{
  (void) MonetMember_module_class ("sun");

  /*  Get host by name */

  MonetMember_create ("get-domain-name",  do_get_domain_name,
		      "",
		      "Returns the domain name for the current processor\
		      uses unix 'getdomainname(2)");

  MonetMember_create ( "tempnam",		do_tempnam,
		      "directory prefix",
		      "Creates a unique name for a temporary file");
#ifdef DebugMalloc
  /*  Malloc debugging  */
  MonetMember_create ( "mallocmap",		do_mallocmap,
		      "" ,
		      "Dump heap to stdout");
  MonetMember_create ( "malloc-debug",		do_malloc_debug,
		      "int-level" ,
		      "Malloc debug");
  MonetMember_create ( "malloc-verify",		do_malloc_verify,
		      "" ,
		      "Malloc verify");

#endif
 
}

extern void monetsh_finish_sun ()
{
}

/*****************************************************************************/
/*****************************************************************************/
/* $Header: //gaia/group.local/computer/monet/Xmonet/RCS/main.c,v 1.1 1991/03/26 12:00:14 a38 Exp a38 $ */
/*****************************************************************************/
/*****************************************************************************/
